

package ufcoderadvancedapplet;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.regex.Pattern;
import java.beans.PropertyVetoException;
import javax.swing.*;


public class GLFunctions     implements KeyListener,FocusListener 
{
  
  
   public JCheckBox HEXBOX=new JCheckBox();

   public String TEXTFIELD=null;
           
   public static final int 
                           KEYLENGTH             =6;

   public final static String ANY_DATA           ="You must enter any data !",
                              APPROPRIATE_FORMAT = "You must enter the appropriate format !",
                              CORRECT_VALUE      ="Enter a value between 0 and 255";
   private JTextField txtTextField;
  
             
    public void CreateTextBox(JPanel pnlContainer,int textfield_width,int textfield_height,
                            int textfield_top,int textfield_left,String textfield_name )
    {
           JTextField textfield;
           for(int br=0;br<6;br++)
           {
                        textfield=new JTextField();
                        textfield.setBounds(textfield_left+(textfield_width*br+2),textfield_top,textfield_width,textfield_height);
                        textfield.setBorder(javax.swing.BorderFactory.createLineBorder(Color.BLACK));
                        textfield.setName(textfield_name);
                        textfield.setHorizontalAlignment(javax.swing.JTextField.CENTER);
                        textfield.setFont(new java.awt.Font("Verdana",1,11));                        
                        textfield.addFocusListener(this);
                        textfield.addKeyListener(this);                    
                        textfield.setText("255");                        
                        textfield.setEditable(true);                        
                        textfield.setVisible(true);
                        pnlContainer.add(textfield);
           }
           pnlContainer.repaint();
    }
   
    public void CreatePKBox(JPanel pnlContainer,int txtTextField_width,int txtTextField_height,
                            int txtTextField_top,int txtTextField_left,String txtTextField_name )
    {
           for(int br=0;br<6;br++)
           {
                        txtTextField=new JTextField();
                        txtTextField.setBounds(txtTextField_left+(txtTextField_width*br+2),txtTextField_top,txtTextField_width,txtTextField_height);
                        txtTextField.setBorder(javax.swing.BorderFactory.createLineBorder(Color.BLACK));
                        txtTextField.setName(txtTextField_name);
                        txtTextField.setHorizontalAlignment(javax.swing.JTextField.CENTER);
                        txtTextField.setFont(new java.awt.Font("Verdana",1,11)); 
                        txtTextField.addFocusListener(this);
                        txtTextField.addKeyListener(this);
                        txtTextField.setText("255");
                        txtTextField.setVisible(true);
                        pnlContainer.add(txtTextField);
           }
           pnlContainer.repaint();
    }
   
    
    @Override
    public void keyTyped(KeyEvent e) {
 boolean bParse=false;
        JTextField tf=(JTextField)e.getSource();  
      
        try{                                       
        if (HEXBOX.isSelected() && tf.getName()==TEXTFIELD){
          if (tf.getText().length()>1) {
                e.consume();
            }
          boolean bol_check=Pattern.matches("[a-fA-F_0-9]", String.valueOf(e.getKeyChar()));
          if (!bol_check){
              e.consume();             
          }
        }
        else
        {
           if (tf.getText().length()>2) {
                e.consume();
            }
           boolean bol_check=Pattern.matches("[0-9]", String.valueOf(e.getKeyChar()));
           if (!bol_check){
              e.consume();             
          }
        }
        }catch(NumberFormatException NFE){
                     
        }
    
    }
    
    
   @Override
     public void keyPressed(KeyEvent e) {
      
    }
    @Override
    public void keyReleased(KeyEvent e) {
      
    }
    @Override
    public void focusGained(FocusEvent e) {
      
    }
    @Override
    public void focusLost(FocusEvent e) {        
    String sMessages = null;        
        JTextField tf = (JTextField) e.getSource();         
        try {
            if (tf.getText().trim().isEmpty() || (Integer.parseInt(tf.getText(),16)>255)) {

                if (HEXBOX.isSelected() && tf.getName()==TEXTFIELD) {
                    sMessages = "Must enter a hex value between 0 and FF !";
                    JOptionPane.showMessageDialog(new frmuFrAdvancedApplet().getRootPane(), sMessages, "Warning !", JOptionPane.WARNING_MESSAGE);
                    tf.requestFocus();
                    tf.selectAll();
                    return;
                } 
            }
                    sMessages = "Must enter a decimal value between 0 and 255 !";
                    if (tf.getText().trim().isEmpty() || Short.parseShort(tf.getText()) > 255 || Short.parseShort(tf.getText())<0) {
                        JOptionPane.showMessageDialog(new frmuFrAdvancedApplet().getRootPane(), sMessages, "Warning !", JOptionPane.WARNING_MESSAGE);
                        tf.requestFocus();
                        tf.selectAll();
                        return;
                    }
                
               
            }catch(NumberFormatException NFE){
                // tf.requestFocus();
                // tf.selectAll();    
            }  
           
       
    }

    public void actionPerformed(ActionEvent e) {

      
    }

    public void HexBoxs(JPanel pnlContainer,String name_textfield,JCheckBox CheckBox){
    short parse_hex=0;
         if (CheckBox.isSelected())
         {

             for (int br=0;br<pnlContainer.getComponentCount();br++)
             {
                 if (pnlContainer.getComponent(br).getName()==name_textfield){
                     parse_hex=Short.parseShort(((JTextField)pnlContainer.getComponent(br)).getText());
                     ((JTextField)pnlContainer.getComponent(br)).setText(Integer.toHexString(parse_hex).toUpperCase());
                 }
             }
         }
         else
         {

             for (int br=0;br<pnlContainer.getComponentCount();br++)
             {
                 if (pnlContainer.getComponent(br).getName()==name_textfield){
                     parse_hex=Short.parseShort(((JTextField)pnlContainer.getComponent(br)).getText(),16);
                     ((JTextField)pnlContainer.getComponent(br)).setText(Integer.toString(parse_hex));
                 }
             }


         }
        
//         HEXBOX=CheckBox;

    }
   public void AddFrame(JInternalFrame internal_frame,JDesktopPane pnlContainer,JLabel header_panel,String header_text)
  {
      JInternalFrame[]child_frame=pnlContainer.getAllFrames();
      JInternalFrame jframe=new JInternalFrame();
      pnlContainer.remove(jframe);
      try
      {
      for(JInternalFrame int_frame:child_frame){
     //     if(int_frame.getName().equals(internal_frame.getName()))
     //     {
           pnlContainer.remove(int_frame);
           pnlContainer.repaint();
           header_panel.setText(header_text);
           header_panel.setVisible(true);
       //   }
     }
          internal_frame.pack();
          internal_frame.setVisible(true);
          pnlContainer.add(internal_frame);
          header_panel.setText(header_text);
          header_panel.setVisible(true);
          pnlContainer.repaint();
          internal_frame.setBounds(12,0, 569,449);
          internal_frame.setSelected(true);
     
      }catch(PropertyVetoException pe)
      {

      }
  }
    public byte[] PK_KEY(JPanel pnlHeader)
    {
       byte count=0;
       byte[]pk_key=new byte[7];
        for (int br=0;br<pnlHeader.getComponentCount();br++)
                {
                    if (pnlHeader.getComponent(br).getName()=="txtPKKey")
                    {
                        pk_key[count]=(byte)Integer.parseInt(((JTextField)(pnlHeader.getComponent(br))).getText());
                        count++;
                    }
                }
       return pk_key;
    }
    
    
      public byte[] KEY(JPanel pnlKEYs,String name_of_key,JCheckBox CheckBox)
  {
       byte bCountIndex=0;
       byte[]KEY=new byte[6];
       
      if (HEXBOX.isSelected()) {
          for (int iCounter = 0; iCounter <pnlKEYs.getComponentCount(); iCounter++) {
              if (pnlKEYs.getComponent(iCounter).getName() == name_of_key) {
                  KEY[bCountIndex] = (byte) Integer.parseInt(((JTextField) pnlKEYs.getComponent(iCounter)).getText(), 16);
                  bCountIndex++;
              }
          }
      } else {
          for (int iCounter = 0; iCounter < pnlKEYs.getComponentCount(); iCounter++) {
             
              if (pnlKEYs.getComponent(iCounter).getName() == name_of_key) {
                  KEY[bCountIndex] = (byte) Integer.parseInt(((JTextField) (pnlKEYs.getComponent(iCounter))).getText());
                  bCountIndex++;
              }
          }
      }
       return KEY;
  }
      
   public byte[] WriteArray(byte[] bGetBytesArray,int iDataLength,int iMaxBytes)
        {
            byte[] bCloneArray = new byte[iMaxBytes];
            System.arraycopy(bGetBytesArray,0, bCloneArray,0, bGetBytesArray.length);
            for (int br = bGetBytesArray.length; br < iDataLength; br++)
            {
                bCloneArray[br] = 32;
            }
                                    
            return bCloneArray;

        }   
      
}
