
package ufcoderadvancedapplet;

import javax.swing.JOptionPane;


public class frmBlockReadWrite extends javax.swing.JInternalFrame {
    static final int 
         FUNCT_LIGHT_OK     = 4,
         FUNCT_SOUND_OK     = 0,//4 Tripple sound
         FUNCT_LIGHT_ERROR  = 2,
         FUNCT_SOUND_ERROR  = 0,//2 Long sound
         DL_OK              = 0;
    
    static final byte
         MIFARE_AUTHENT1A   = 0x60,  
         MIFARE_AUTHENT1B   = 0x61,
         MAX_BLOCK_BYTES    = 16;
    
    
    final static String ANY_DATA            = "You must enter any data !",
                        APPROPRIATE_FORMAT  = "You must enter the appropriate format !";
   
    
    public frmBlockReadWrite() {

        initComponents();
        new GLFunctions().CreatePKBox(pnlPKKey,29,20,13,350,"txtPKKey");
    }
    static final byte ARRAY_LENGTH=16;
    static final String FORMAT="Input format is 01FF or 01 FF \nYou must enter 16 bytes !";   
    byte[]baReadBlock=new byte[ARRAY_LENGTH];
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        rbtnRadioGroup = new javax.swing.ButtonGroup();
        pnlPKKey = new javax.swing.JPanel();
        rbAUTH1A = new javax.swing.JRadioButton();
        rbAUTH1B = new javax.swing.JRadioButton();
        lblKeyIndex = new javax.swing.JLabel();
        cboKeyIndex = new javax.swing.JComboBox();
        lblPKKey = new javax.swing.JLabel();
        tabBlockReadWrite = new javax.swing.JTabbedPane();
        tabBlockRead = new javax.swing.JPanel();
        pnlBlockRead = new javax.swing.JPanel();
        lblBlockRead = new javax.swing.JLabel();
        lblBlockAddress = new javax.swing.JLabel();
        txtBlockAddress = new javax.swing.JTextField();
        btnBlockRead = new javax.swing.JButton();
        lblReadData = new javax.swing.JLabel();
        txtReadData = new javax.swing.JTextField();
        chkBRHex = new javax.swing.JCheckBox();
        pnlBlockReadAKM1 = new javax.swing.JPanel();
        lblBlockReadAKM1 = new javax.swing.JLabel();
        lblBlockAddressAKM1 = new javax.swing.JLabel();
        txtBlockAddressAKM1 = new javax.swing.JTextField();
        btnBlockReadAKM1 = new javax.swing.JButton();
        lblReadDataAKM1 = new javax.swing.JLabel();
        txtReadDataAKM1 = new javax.swing.JTextField();
        chkBRHexAKM1 = new javax.swing.JCheckBox();
        pnlBlockReadAKM2 = new javax.swing.JPanel();
        lblBlockReadAKM2 = new javax.swing.JLabel();
        lblBlockAddressAKM2 = new javax.swing.JLabel();
        txtBlockAddressAKM2 = new javax.swing.JTextField();
        btnBlockReadAKM2 = new javax.swing.JButton();
        lblReadDataAKM2 = new javax.swing.JLabel();
        txtReadDataAKM2 = new javax.swing.JTextField();
        chkBRHexAKM2 = new javax.swing.JCheckBox();
        pnlBlockReadPK = new javax.swing.JPanel();
        lblBlockReadPK = new javax.swing.JLabel();
        lblBlockAddressPK = new javax.swing.JLabel();
        txtBlockAddressPK = new javax.swing.JTextField();
        btnBlockReadPK = new javax.swing.JButton();
        lblReadDataPK = new javax.swing.JLabel();
        txtReadDataPK = new javax.swing.JTextField();
        chkBRHexPK = new javax.swing.JCheckBox();
        pnlBlockWrite = new javax.swing.JPanel();
        pnlBlockWritte = new javax.swing.JPanel();
        txtWriteData = new javax.swing.JTextField();
        txtBlockAddressWrite = new javax.swing.JTextField();
        btnBlockWrite = new javax.swing.JButton();
        lblBlockWrite = new javax.swing.JLabel();
        lblBlockAddressWrite = new javax.swing.JLabel();
        lblWriteData = new javax.swing.JLabel();
        chkBWHex = new javax.swing.JCheckBox();
        pnlBlockWritte1 = new javax.swing.JPanel();
        txtWriteDataAKM1 = new javax.swing.JTextField();
        txtBlockAddressWriteAKM1 = new javax.swing.JTextField();
        btnBlockWriteAKM1 = new javax.swing.JButton();
        lblBlockWriteAKM1 = new javax.swing.JLabel();
        lblBlockAddressWriteAKM1 = new javax.swing.JLabel();
        lblWriteDataAKM1 = new javax.swing.JLabel();
        chkBWHexAKM1 = new javax.swing.JCheckBox();
        pnlBlockWritteAKM2 = new javax.swing.JPanel();
        txtWriteDataAKM2 = new javax.swing.JTextField();
        txtBlockAddressWriteAKM2 = new javax.swing.JTextField();
        btnBlockWriteAKM2 = new javax.swing.JButton();
        lblBlockWriteAKM2 = new javax.swing.JLabel();
        lblBlockAddressWriteAKM2 = new javax.swing.JLabel();
        lblWriteDataAKM2 = new javax.swing.JLabel();
        chkBWHexAKM2 = new javax.swing.JCheckBox();
        pnlBlockWrittePK = new javax.swing.JPanel();
        txtWriteDataPK = new javax.swing.JTextField();
        txtBlockAddressWritePK = new javax.swing.JTextField();
        btnBlockWritePK = new javax.swing.JButton();
        lblBlockWritePK = new javax.swing.JLabel();
        lblBlockAddressWritePK = new javax.swing.JLabel();
        lblWriteDataPK = new javax.swing.JLabel();
        chkBWHexPK = new javax.swing.JCheckBox();
        txtFunctionStatus = new javax.swing.JTextField();
        txtFErrorCode = new javax.swing.JTextField();
        txtFErrorExplain = new javax.swing.JTextField();

        setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        setResizable(true);
        setTitle("frmBlockReadWrite");
        setName("frmBlockReadWrite"); // NOI18N
        setPreferredSize(new java.awt.Dimension(569, 449));
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlPKKey.setBackground(new java.awt.Color(255, 255, 255));
        pnlPKKey.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        rbAUTH1A.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioGroup.add(rbAUTH1A);
        rbAUTH1A.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1A.setSelected(true);
        rbAUTH1A.setText("AUTH 1A");
        rbAUTH1A.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        rbAUTH1B.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioGroup.add(rbAUTH1B);
        rbAUTH1B.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1B.setText("AUTH 1B");
        rbAUTH1B.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblKeyIndex.setText("Key Index");

        cboKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        cboKeyIndex.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", " " }));
        cboKeyIndex.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblPKKey.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblPKKey.setText("PK Key");

        javax.swing.GroupLayout pnlPKKeyLayout = new javax.swing.GroupLayout(pnlPKKey);
        pnlPKKey.setLayout(pnlPKKeyLayout);
        pnlPKKeyLayout.setHorizontalGroup(
            pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPKKeyLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(rbAUTH1A)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rbAUTH1B)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lblKeyIndex)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(10, 10, 10)
                .addComponent(lblPKKey)
                .addContainerGap(340, Short.MAX_VALUE))
        );
        pnlPKKeyLayout.setVerticalGroup(
            pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPKKeyLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblPKKey)
                    .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblKeyIndex)
                    .addComponent(rbAUTH1A)
                    .addComponent(rbAUTH1B))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        getContentPane().add(pnlPKKey, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 658, 40));

        tabBlockReadWrite.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        tabBlockReadWrite.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N

        tabBlockRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabBlockRead.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlBlockRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlBlockRead.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N

        lblBlockRead.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockRead.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblBlockRead.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockRead.setText("Block Read");
        lblBlockRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockRead.setOpaque(true);

        lblBlockAddress.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddress.setText("Block Address");

        txtBlockAddress.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtBlockAddress.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddress.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockRead.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        btnBlockRead.setText("READ");
        btnBlockRead.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockRead.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockReadActionPerformed(evt);
            }
        });

        lblReadData.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblReadData.setText("Read Data");

        txtReadData.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtReadData.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtReadData.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        chkBRHex.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        chkBRHex.setText("Hex");
        chkBRHex.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkBRHexItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout pnlBlockReadLayout = new javax.swing.GroupLayout(pnlBlockRead);
        pnlBlockRead.setLayout(pnlBlockReadLayout);
        pnlBlockReadLayout.setHorizontalGroup(
            pnlBlockReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockReadLayout.createSequentialGroup()
                .addComponent(lblBlockRead, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
            .addGroup(pnlBlockReadLayout.createSequentialGroup()
                .addGroup(pnlBlockReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(lblReadData)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(chkBRHex))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadLayout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(lblBlockAddress)
                        .addGap(4, 4, 4)
                        .addComponent(txtBlockAddress, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBlockRead, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(txtReadData)))
                .addContainerGap())
        );
        pnlBlockReadLayout.setVerticalGroup(
            pnlBlockReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockReadLayout.createSequentialGroup()
                .addComponent(lblBlockRead)
                .addGap(6, 6, 6)
                .addGroup(pnlBlockReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockAddress)
                    .addGroup(pnlBlockReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(txtBlockAddress, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnBlockRead, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(9, 9, 9)
                .addGroup(pnlBlockReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblReadData)
                    .addComponent(chkBRHex))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtReadData, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(14, 14, 14))
        );

        tabBlockRead.add(pnlBlockRead, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, -1));

        pnlBlockReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlBlockReadAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N

        lblBlockReadAKM1.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockReadAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblBlockReadAKM1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockReadAKM1.setText("Block Read AKM1");
        lblBlockReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockReadAKM1.setOpaque(true);

        lblBlockAddressAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressAKM1.setText("Block Address");

        txtBlockAddressAKM1.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtBlockAddressAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockReadAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        btnBlockReadAKM1.setText("READ");
        btnBlockReadAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockReadAKM1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockReadAKM1ActionPerformed(evt);
            }
        });

        lblReadDataAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblReadDataAKM1.setText("Read Data");

        txtReadDataAKM1.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtReadDataAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtReadDataAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        chkBRHexAKM1.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        chkBRHexAKM1.setText("Hex");
        chkBRHexAKM1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkBRHexAKM1ItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout pnlBlockReadAKM1Layout = new javax.swing.GroupLayout(pnlBlockReadAKM1);
        pnlBlockReadAKM1.setLayout(pnlBlockReadAKM1Layout);
        pnlBlockReadAKM1Layout.setHorizontalGroup(
            pnlBlockReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblBlockReadAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGroup(pnlBlockReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadAKM1Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(lblReadDataAKM1)
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(chkBRHexAKM1))
                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadAKM1Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(txtReadDataAKM1))
                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadAKM1Layout.createSequentialGroup()
                    .addGap(10, 10, 10)
                    .addComponent(lblBlockAddressAKM1)
                    .addGap(4, 4, 4)
                    .addComponent(txtBlockAddressAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                    .addComponent(btnBlockReadAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );
        pnlBlockReadAKM1Layout.setVerticalGroup(
            pnlBlockReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockReadAKM1Layout.createSequentialGroup()
                .addComponent(lblBlockReadAKM1)
                .addGap(6, 6, 6)
                .addGroup(pnlBlockReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockAddressAKM1)
                    .addGroup(pnlBlockReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(txtBlockAddressAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnBlockReadAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(9, 9, 9)
                .addGroup(pnlBlockReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblReadDataAKM1)
                    .addComponent(chkBRHexAKM1))
                .addGap(5, 5, 5)
                .addComponent(txtReadDataAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(14, 14, 14))
        );

        tabBlockRead.add(pnlBlockReadAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 10, -1, 119));

        pnlBlockReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlBlockReadAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N

        lblBlockReadAKM2.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockReadAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblBlockReadAKM2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockReadAKM2.setText("Block Read AKM2");
        lblBlockReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockReadAKM2.setOpaque(true);

        lblBlockAddressAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressAKM2.setText("Block Address");

        txtBlockAddressAKM2.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtBlockAddressAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockReadAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        btnBlockReadAKM2.setText("READ");
        btnBlockReadAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockReadAKM2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockReadAKM2ActionPerformed(evt);
            }
        });

        lblReadDataAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblReadDataAKM2.setText("Read Data");

        txtReadDataAKM2.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtReadDataAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtReadDataAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        chkBRHexAKM2.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        chkBRHexAKM2.setText("Hex");
        chkBRHexAKM2.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkBRHexAKM2ItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout pnlBlockReadAKM2Layout = new javax.swing.GroupLayout(pnlBlockReadAKM2);
        pnlBlockReadAKM2.setLayout(pnlBlockReadAKM2Layout);
        pnlBlockReadAKM2Layout.setHorizontalGroup(
            pnlBlockReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblBlockReadAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGroup(pnlBlockReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadAKM2Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(lblReadDataAKM2)
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(chkBRHexAKM2))
                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadAKM2Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(txtReadDataAKM2))
                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadAKM2Layout.createSequentialGroup()
                    .addGap(10, 10, 10)
                    .addComponent(lblBlockAddressAKM2)
                    .addGap(4, 4, 4)
                    .addComponent(txtBlockAddressAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                    .addComponent(btnBlockReadAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );
        pnlBlockReadAKM2Layout.setVerticalGroup(
            pnlBlockReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockReadAKM2Layout.createSequentialGroup()
                .addComponent(lblBlockReadAKM2)
                .addGap(6, 6, 6)
                .addGroup(pnlBlockReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockAddressAKM2)
                    .addGroup(pnlBlockReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(txtBlockAddressAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnBlockReadAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGroup(pnlBlockReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlBlockReadAKM2Layout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addComponent(lblReadDataAKM2))
                    .addGroup(pnlBlockReadAKM2Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(chkBRHexAKM2)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtReadDataAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(14, 14, 14))
        );

        tabBlockRead.add(pnlBlockReadAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 140, -1, 119));

        pnlBlockReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlBlockReadPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N

        lblBlockReadPK.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockReadPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblBlockReadPK.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockReadPK.setText("Block Read PK");
        lblBlockReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockReadPK.setOpaque(true);

        lblBlockAddressPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressPK.setText("Block Address");

        txtBlockAddressPK.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtBlockAddressPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockReadPK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        btnBlockReadPK.setText("READ");
        btnBlockReadPK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockReadPK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockReadPKActionPerformed(evt);
            }
        });

        lblReadDataPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblReadDataPK.setText("Read Data");

        txtReadDataPK.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtReadDataPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtReadDataPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        chkBRHexPK.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        chkBRHexPK.setText("Hex");
        chkBRHexPK.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkBRHexPKItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout pnlBlockReadPKLayout = new javax.swing.GroupLayout(pnlBlockReadPK);
        pnlBlockReadPK.setLayout(pnlBlockReadPKLayout);
        pnlBlockReadPKLayout.setHorizontalGroup(
            pnlBlockReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblBlockReadPK, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGroup(pnlBlockReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadPKLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(lblReadDataPK)
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(chkBRHexPK))
                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadPKLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(txtReadDataPK))
                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockReadPKLayout.createSequentialGroup()
                    .addGap(10, 10, 10)
                    .addComponent(lblBlockAddressPK)
                    .addGap(4, 4, 4)
                    .addComponent(txtBlockAddressPK, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                    .addComponent(btnBlockReadPK, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );
        pnlBlockReadPKLayout.setVerticalGroup(
            pnlBlockReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockReadPKLayout.createSequentialGroup()
                .addComponent(lblBlockReadPK)
                .addGap(6, 6, 6)
                .addGroup(pnlBlockReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockAddressPK)
                    .addGroup(pnlBlockReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(txtBlockAddressPK, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnBlockReadPK, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(9, 9, 9)
                .addGroup(pnlBlockReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblReadDataPK)
                    .addComponent(chkBRHexPK))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtReadDataPK, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(14, 14, 14))
        );

        tabBlockRead.add(pnlBlockReadPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 140, -1, -1));

        tabBlockReadWrite.addTab("Block Read", tabBlockRead);

        pnlBlockWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlBlockWrite.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlBlockWritte.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlBlockWritte.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N

        txtWriteData.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtWriteData.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtWriteData.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressWrite.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtBlockAddressWrite.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockWrite.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        btnBlockWrite.setText("WRITE");
        btnBlockWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnBlockWrite.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockWrite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockWriteActionPerformed(evt);
            }
        });

        lblBlockWrite.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockWrite.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblBlockWrite.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockWrite.setText("Block Write");
        lblBlockWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockWrite.setOpaque(true);

        lblBlockAddressWrite.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWrite.setText("Block Address");

        lblWriteData.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblWriteData.setText("Write Data");

        chkBWHex.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        chkBWHex.setText("Hex");

        javax.swing.GroupLayout pnlBlockWritteLayout = new javax.swing.GroupLayout(pnlBlockWritte);
        pnlBlockWritte.setLayout(pnlBlockWritteLayout);
        pnlBlockWritteLayout.setHorizontalGroup(
            pnlBlockWritteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockWritteLayout.createSequentialGroup()
                .addGroup(pnlBlockWritteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlBlockWritteLayout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(pnlBlockWritteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockWritteLayout.createSequentialGroup()
                                .addComponent(lblBlockAddressWrite)
                                .addGap(4, 4, 4)
                                .addComponent(txtBlockAddressWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(btnBlockWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockWritteLayout.createSequentialGroup()
                                .addComponent(lblWriteData)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(chkBWHex, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addGap(0, 0, Short.MAX_VALUE))
            .addGroup(pnlBlockWritteLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(txtWriteData, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pnlBlockWritteLayout.setVerticalGroup(
            pnlBlockWritteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockWritteLayout.createSequentialGroup()
                .addComponent(lblBlockWrite)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockWritteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblWriteData)
                    .addComponent(chkBWHex))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 6, Short.MAX_VALUE)
                .addComponent(txtWriteData, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockWritteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockAddressWrite)
                    .addGroup(pnlBlockWritteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(txtBlockAddressWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnBlockWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pnlBlockWrite.add(pnlBlockWritte, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, -1));

        pnlBlockWritte1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlBlockWritte1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N

        txtWriteDataAKM1.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtWriteDataAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtWriteDataAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressWriteAKM1.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtBlockAddressWriteAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        btnBlockWriteAKM1.setText("WRITE");
        btnBlockWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnBlockWriteAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockWriteAKM1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockWriteAKM1ActionPerformed(evt);
            }
        });

        lblBlockWriteAKM1.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblBlockWriteAKM1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockWriteAKM1.setText("Block Write AKM1");
        lblBlockWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockWriteAKM1.setOpaque(true);

        lblBlockAddressWriteAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWriteAKM1.setText("Block Address");

        lblWriteDataAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblWriteDataAKM1.setText("Write Data");

        chkBWHexAKM1.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        chkBWHexAKM1.setText("Hex");

        javax.swing.GroupLayout pnlBlockWritte1Layout = new javax.swing.GroupLayout(pnlBlockWritte1);
        pnlBlockWritte1.setLayout(pnlBlockWritte1Layout);
        pnlBlockWritte1Layout.setHorizontalGroup(
            pnlBlockWritte1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockWritte1Layout.createSequentialGroup()
                .addGroup(pnlBlockWritte1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlBlockWritte1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(pnlBlockWritte1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(pnlBlockWritte1Layout.createSequentialGroup()
                                .addComponent(lblWriteDataAKM1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(chkBWHexAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(txtWriteDataAKM1)
                            .addGroup(pnlBlockWritte1Layout.createSequentialGroup()
                                .addComponent(lblBlockAddressWriteAKM1)
                                .addGap(4, 4, 4)
                                .addComponent(txtBlockAddressWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(btnBlockWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addGap(0, 0, 0))
        );
        pnlBlockWritte1Layout.setVerticalGroup(
            pnlBlockWritte1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockWritte1Layout.createSequentialGroup()
                .addComponent(lblBlockWriteAKM1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockWritte1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblWriteDataAKM1)
                    .addComponent(chkBWHexAKM1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 6, Short.MAX_VALUE)
                .addComponent(txtWriteDataAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockWritte1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockAddressWriteAKM1)
                    .addGroup(pnlBlockWritte1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(txtBlockAddressWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnBlockWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pnlBlockWrite.add(pnlBlockWritte1, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 10, -1, -1));

        pnlBlockWritteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlBlockWritteAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N

        txtWriteDataAKM2.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtWriteDataAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtWriteDataAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressWriteAKM2.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtBlockAddressWriteAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        btnBlockWriteAKM2.setText("WRITE");
        btnBlockWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnBlockWriteAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockWriteAKM2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockWriteAKM2ActionPerformed(evt);
            }
        });

        lblBlockWriteAKM2.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblBlockWriteAKM2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockWriteAKM2.setText("Block Write AKM2");
        lblBlockWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockWriteAKM2.setOpaque(true);

        lblBlockAddressWriteAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWriteAKM2.setText("Block Address");

        lblWriteDataAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblWriteDataAKM2.setText("Write Data");

        chkBWHexAKM2.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        chkBWHexAKM2.setText("Hex");

        javax.swing.GroupLayout pnlBlockWritteAKM2Layout = new javax.swing.GroupLayout(pnlBlockWritteAKM2);
        pnlBlockWritteAKM2.setLayout(pnlBlockWritteAKM2Layout);
        pnlBlockWritteAKM2Layout.setHorizontalGroup(
            pnlBlockWritteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockWritteAKM2Layout.createSequentialGroup()
                .addGroup(pnlBlockWritteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlBlockWritteAKM2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(pnlBlockWritteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(pnlBlockWritteAKM2Layout.createSequentialGroup()
                                .addComponent(lblBlockAddressWriteAKM2)
                                .addGap(4, 4, 4)
                                .addComponent(txtBlockAddressWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(btnBlockWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(pnlBlockWritteAKM2Layout.createSequentialGroup()
                                .addComponent(lblWriteDataAKM2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(chkBWHexAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addGap(0, 0, Short.MAX_VALUE))
            .addGroup(pnlBlockWritteAKM2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(txtWriteDataAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pnlBlockWritteAKM2Layout.setVerticalGroup(
            pnlBlockWritteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockWritteAKM2Layout.createSequentialGroup()
                .addComponent(lblBlockWriteAKM2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockWritteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblWriteDataAKM2)
                    .addComponent(chkBWHexAKM2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 6, Short.MAX_VALUE)
                .addComponent(txtWriteDataAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockWritteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockAddressWriteAKM2)
                    .addGroup(pnlBlockWritteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(txtBlockAddressWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnBlockWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pnlBlockWrite.add(pnlBlockWritteAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 140, -1, -1));

        pnlBlockWrittePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlBlockWrittePK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N

        txtWriteDataPK.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtWriteDataPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtWriteDataPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressWritePK.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtBlockAddressWritePK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockWritePK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        btnBlockWritePK.setText("WRITE");
        btnBlockWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnBlockWritePK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockWritePK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockWritePKActionPerformed(evt);
            }
        });

        lblBlockWritePK.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockWritePK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblBlockWritePK.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockWritePK.setText("Block Write PK");
        lblBlockWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockWritePK.setOpaque(true);

        lblBlockAddressWritePK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWritePK.setText("Block Address");

        lblWriteDataPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblWriteDataPK.setText("Write Data");

        chkBWHexPK.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        chkBWHexPK.setText("Hex");

        javax.swing.GroupLayout pnlBlockWrittePKLayout = new javax.swing.GroupLayout(pnlBlockWrittePK);
        pnlBlockWrittePK.setLayout(pnlBlockWrittePKLayout);
        pnlBlockWrittePKLayout.setHorizontalGroup(
            pnlBlockWrittePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockWrittePKLayout.createSequentialGroup()
                .addGroup(pnlBlockWrittePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlBlockWrittePKLayout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(pnlBlockWrittePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(pnlBlockWrittePKLayout.createSequentialGroup()
                                .addComponent(lblWriteDataPK)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(chkBWHexPK, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(txtWriteDataPK)
                            .addGroup(pnlBlockWrittePKLayout.createSequentialGroup()
                                .addComponent(lblBlockAddressWritePK)
                                .addGap(4, 4, 4)
                                .addComponent(txtBlockAddressWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(btnBlockWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addGap(0, 0, Short.MAX_VALUE))
        );
        pnlBlockWrittePKLayout.setVerticalGroup(
            pnlBlockWrittePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockWrittePKLayout.createSequentialGroup()
                .addComponent(lblBlockWritePK)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockWrittePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblWriteDataPK)
                    .addComponent(chkBWHexPK))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 6, Short.MAX_VALUE)
                .addComponent(txtWriteDataPK, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockWrittePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBlockAddressWritePK)
                    .addGroup(pnlBlockWrittePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(txtBlockAddressWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnBlockWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pnlBlockWrite.add(pnlBlockWrittePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 140, -1, -1));

        tabBlockReadWrite.addTab("Block Write", pnlBlockWrite);

        getContentPane().add(tabBlockReadWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 70, 530, 300));

        txtFunctionStatus.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFunctionStatus.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtFunctionStatus.setText("Function Status");
        getContentPane().add(txtFunctionStatus, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 390, 140, -1));

        txtFErrorCode.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorCode.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorCode, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 390, 70, -1));

        txtFErrorExplain.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorExplain.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorExplain, new org.netbeans.lib.awtextra.AbsoluteConstraints(210, 390, 350, -1));

        pack();
    }// </editor-fold>//GEN-END:initComponents

     private byte[] HexConvert(javax.swing.JTextField  txtTextBox){
       
         String sTextBox=txtTextBox.getText();                
         byte bCharCounter=0;
         byte bCounter=0;
         byte[]bHexArray=new byte[ARRAY_LENGTH];                  
       try{
           sTextBox=sTextBox.replaceAll("\\s", "");                                     
           while (bCharCounter<sTextBox.length()){                                 
               bHexArray[bCounter] =(byte)Short.parseShort(sTextBox.substring(bCharCounter,bCharCounter+2),16);                  bCounter++;                                           
               bCharCounter+=2;               
           } 
           if (bCounter<ARRAY_LENGTH)
       {
           throw new NumberFormatException ("You must enter 16 bytes !");
       }
           
        }
       
       catch(ArrayIndexOutOfBoundsException ex) {
            throw new ArrayIndexOutOfBoundsException(FORMAT);
       }catch(NumberFormatException nfe){
             throw new NumberFormatException(FORMAT);
       }
       
       return bHexArray;
    }
 private String ConvertToHex(boolean chkCheck){
     String sString="";
     
     if (chkCheck){
         for (int iCounter=0;iCounter<ARRAY_LENGTH;iCounter++){
             sString+=Integer.toHexString((((char) baReadBlock[iCounter] & 0xFF))).toUpperCase(); 
         }
     }
     else
     {
         sString+=new String(baReadBlock);
     }
     
     return sString;
 }           
    private void btnBlockReadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockReadActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress  = 0;          
          byte  bKeyIndex      = (byte)cboKeyIndex.getSelectedIndex();
          
        if (txtBlockAddress.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                            JOptionPane.WARNING_MESSAGE);
              txtBlockAddress.requestFocus();
              return;
          }          
          
          bBlockAddress=Byte.parseByte(txtBlockAddress.getText().trim());
          
          iFResult=Declarations.uFrFunctions.uFrInstance.BlockRead(baReadBlock, bBlockAddress,bAuthMode,bKeyIndex);
          if (iFResult==DL_OK){             
               txtReadData.setText(ConvertToHex(chkBRHex.isSelected()));
               Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
               M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
        }
         catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockReadActionPerformed

    private void btnBlockReadAKM1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockReadAKM1ActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress  = 0;          
          
        if (txtBlockAddressAKM1.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                            JOptionPane.WARNING_MESSAGE);
              txtBlockAddressAKM1.requestFocus();
              return;
          }
          
          bBlockAddress=Byte.parseByte(txtBlockAddressAKM1.getText().trim());
          iFResult=Declarations.uFrFunctions.uFrInstance.BlockRead_AKM1(baReadBlock, bBlockAddress,bAuthMode);
          if (iFResult==DL_OK){            
              txtReadDataAKM1.setText(ConvertToHex(chkBRHexAKM1.isSelected()));
              Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
               M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
      }
         catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockReadAKM1ActionPerformed

    private void btnBlockReadAKM2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockReadAKM2ActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress  = 0; 
          
          
        if (txtBlockAddressAKM2.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                            JOptionPane.WARNING_MESSAGE);
              txtBlockAddressAKM2.requestFocus();
              return;
          }
          
          bBlockAddress=Byte.parseByte(txtBlockAddressAKM2.getText().trim());
          iFResult=Declarations.uFrFunctions.uFrInstance.BlockRead_AKM2(baReadBlock, bBlockAddress,bAuthMode);
          
          if (iFResult==DL_OK){
          
             txtReadDataAKM2.setText(ConvertToHex(chkBRHexAKM2.isSelected()));
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
               M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
      }
         catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockReadAKM2ActionPerformed

    private void btnBlockReadPKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockReadPKActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress  = 0; 
          
        if (txtBlockAddressPK.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                            JOptionPane.WARNING_MESSAGE);
              txtBlockAddressPK.requestFocus();
              return;
          }
          
          bBlockAddress=Byte.parseByte(txtBlockAddressPK.getText().trim());
          iFResult=Declarations.uFrFunctions.uFrInstance.BlockRead_PK(baReadBlock,bBlockAddress,bAuthMode,new GLFunctions().PK_KEY(pnlPKKey));
          if (iFResult==DL_OK){           
               txtReadDataPK.setText(ConvertToHex(chkBRHexPK.isSelected()));
               Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
               M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
      }
         catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockReadPKActionPerformed

    private void btnBlockWriteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockWriteActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress  = 0; 
          byte[] baWriteData   =new byte[ARRAY_LENGTH];
          byte  bKeyIndex      = (byte)cboKeyIndex.getSelectedIndex();
          
        if (txtBlockAddressWrite.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                            JOptionPane.WARNING_MESSAGE);
              txtBlockAddressWrite.requestFocus();
              return;
          }
           if (txtWriteData.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
              txtWriteData.requestFocus();
              return;
          }
          
          bBlockAddress=Byte.parseByte(txtBlockAddressWrite.getText().trim());
          
          if (chkBWHex.isSelected()){
              baWriteData=HexConvert(txtWriteData);
          } 
          else
          {
            baWriteData=txtWriteData.getText().getBytes();  
          }
                    
          iFResult=Declarations.uFrFunctions.uFrInstance.BlockWrite(baWriteData, bBlockAddress,bAuthMode,bKeyIndex);
          if (iFResult==DL_OK){
               Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
               M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
      }
         catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockWriteActionPerformed

    private void btnBlockWriteAKM1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockWriteAKM1ActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress  = 0; 
          byte[] baWriteData   =new byte[ARRAY_LENGTH];
          
        if (txtBlockAddressWriteAKM1.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                            JOptionPane.WARNING_MESSAGE);
              txtBlockAddressWriteAKM1.requestFocus();
              return;
          }
           if (txtWriteDataAKM1.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
              txtWriteDataAKM1.requestFocus();
              return;
          }
          
          bBlockAddress=Byte.parseByte(txtBlockAddressWriteAKM1.getText().trim());
          
           if (chkBWHexAKM1.isSelected()){
              baWriteData=HexConvert(txtWriteDataAKM1);
          } 
          else
          {
             baWriteData =txtWriteDataAKM1.getText().getBytes();  
          }
          
          iFResult=Declarations.uFrFunctions.uFrInstance.BlockWrite_AKM1(baWriteData, bBlockAddress,bAuthMode);
          
          if (iFResult==DL_OK){
               Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
               M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
      }
         catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockWriteAKM1ActionPerformed

    private void btnBlockWriteAKM2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockWriteAKM2ActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress  = 0; 
          byte[] baWriteData   =new byte[ARRAY_LENGTH];
          
        if (txtBlockAddressWriteAKM2.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                            JOptionPane.WARNING_MESSAGE);
              txtBlockAddressWriteAKM2.requestFocus();
              return;
          }
           if (txtWriteDataAKM2.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
              txtWriteDataAKM2.requestFocus();
              return;
          }
          
          bBlockAddress=Byte.parseByte(txtBlockAddressWriteAKM2.getText().trim());
          
           if (chkBWHexAKM2.isSelected()){
              baWriteData=HexConvert(txtWriteDataAKM2);
          } 
          else
          {
            baWriteData=txtWriteDataAKM2.getText().getBytes();  
          }
          
          iFResult=Declarations.uFrFunctions.uFrInstance.BlockWrite_AKM2(baWriteData, bBlockAddress,bAuthMode);
          
         if (iFResult==DL_OK){
               Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
               M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
      }
         catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockWriteAKM2ActionPerformed

    private void btnBlockWritePKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockWritePKActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress  = 0; 
          byte[] baWriteData   =new byte[ARRAY_LENGTH];
          
        if (txtBlockAddressWritePK.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                            JOptionPane.WARNING_MESSAGE);
              txtBlockAddressWritePK.requestFocus();
              return;
          }
           if (txtWriteDataPK.getText().trim().isEmpty()) {
              JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
              txtWriteDataPK.requestFocus();
              return;
          }
          
          bBlockAddress=Byte.parseByte(txtBlockAddressWritePK.getText().trim());
          
           if (chkBWHexPK.isSelected()){
              baWriteData=HexConvert(txtWriteDataPK);
          } 
          else
          {
            baWriteData=txtWriteDataPK.getText().getBytes();  
          }
          
          
          iFResult=Declarations.uFrFunctions.uFrInstance.BlockWrite_PK(baWriteData, bBlockAddress,bAuthMode,new GLFunctions().PK_KEY(pnlPKKey));
         if (iFResult==DL_OK){
               Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
               M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
      }
         catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockWritePKActionPerformed

    private void chkBRHexItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkBRHexItemStateChanged
      //txtReadData.setText(new String(ConvertToHex(evt)));
    }//GEN-LAST:event_chkBRHexItemStateChanged

    private void chkBRHexAKM1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkBRHexAKM1ItemStateChanged
     //txtReadDataAKM1.setText(new String(ConvertToHex(evt)));
    }//GEN-LAST:event_chkBRHexAKM1ItemStateChanged

    private void chkBRHexAKM2ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkBRHexAKM2ItemStateChanged
     //txtReadDataAKM2.setText(new String(ConvertToHex(evt)));
    }//GEN-LAST:event_chkBRHexAKM2ItemStateChanged

    private void chkBRHexPKItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkBRHexPKItemStateChanged
      //txtReadDataPK.setText(new String(ConvertToHex(evt)));
    }//GEN-LAST:event_chkBRHexPKItemStateChanged


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnBlockRead;
    private javax.swing.JButton btnBlockReadAKM1;
    private javax.swing.JButton btnBlockReadAKM2;
    private javax.swing.JButton btnBlockReadPK;
    private javax.swing.JButton btnBlockWrite;
    private javax.swing.JButton btnBlockWriteAKM1;
    private javax.swing.JButton btnBlockWriteAKM2;
    private javax.swing.JButton btnBlockWritePK;
    private javax.swing.JComboBox cboKeyIndex;
    private javax.swing.JCheckBox chkBRHex;
    private javax.swing.JCheckBox chkBRHexAKM1;
    private javax.swing.JCheckBox chkBRHexAKM2;
    private javax.swing.JCheckBox chkBRHexPK;
    private javax.swing.JCheckBox chkBWHex;
    private javax.swing.JCheckBox chkBWHexAKM1;
    private javax.swing.JCheckBox chkBWHexAKM2;
    private javax.swing.JCheckBox chkBWHexPK;
    private javax.swing.JLabel lblBlockAddress;
    private javax.swing.JLabel lblBlockAddressAKM1;
    private javax.swing.JLabel lblBlockAddressAKM2;
    private javax.swing.JLabel lblBlockAddressPK;
    private javax.swing.JLabel lblBlockAddressWrite;
    private javax.swing.JLabel lblBlockAddressWriteAKM1;
    private javax.swing.JLabel lblBlockAddressWriteAKM2;
    private javax.swing.JLabel lblBlockAddressWritePK;
    private javax.swing.JLabel lblBlockRead;
    private javax.swing.JLabel lblBlockReadAKM1;
    private javax.swing.JLabel lblBlockReadAKM2;
    private javax.swing.JLabel lblBlockReadPK;
    private javax.swing.JLabel lblBlockWrite;
    private javax.swing.JLabel lblBlockWriteAKM1;
    private javax.swing.JLabel lblBlockWriteAKM2;
    private javax.swing.JLabel lblBlockWritePK;
    private javax.swing.JLabel lblKeyIndex;
    private javax.swing.JLabel lblPKKey;
    private javax.swing.JLabel lblReadData;
    private javax.swing.JLabel lblReadDataAKM1;
    private javax.swing.JLabel lblReadDataAKM2;
    private javax.swing.JLabel lblReadDataPK;
    private javax.swing.JLabel lblWriteData;
    private javax.swing.JLabel lblWriteDataAKM1;
    private javax.swing.JLabel lblWriteDataAKM2;
    private javax.swing.JLabel lblWriteDataPK;
    private javax.swing.JPanel pnlBlockRead;
    private javax.swing.JPanel pnlBlockReadAKM1;
    private javax.swing.JPanel pnlBlockReadAKM2;
    private javax.swing.JPanel pnlBlockReadPK;
    private javax.swing.JPanel pnlBlockWrite;
    private javax.swing.JPanel pnlBlockWritte;
    private javax.swing.JPanel pnlBlockWritte1;
    private javax.swing.JPanel pnlBlockWritteAKM2;
    private javax.swing.JPanel pnlBlockWrittePK;
    private javax.swing.JPanel pnlPKKey;
    private javax.swing.JRadioButton rbAUTH1A;
    private javax.swing.JRadioButton rbAUTH1B;
    private javax.swing.ButtonGroup rbtnRadioGroup;
    private javax.swing.JPanel tabBlockRead;
    private javax.swing.JTabbedPane tabBlockReadWrite;
    private javax.swing.JTextField txtBlockAddress;
    private javax.swing.JTextField txtBlockAddressAKM1;
    private javax.swing.JTextField txtBlockAddressAKM2;
    private javax.swing.JTextField txtBlockAddressPK;
    private javax.swing.JTextField txtBlockAddressWrite;
    private javax.swing.JTextField txtBlockAddressWriteAKM1;
    private javax.swing.JTextField txtBlockAddressWriteAKM2;
    private javax.swing.JTextField txtBlockAddressWritePK;
    private javax.swing.JTextField txtFErrorCode;
    private javax.swing.JTextField txtFErrorExplain;
    private javax.swing.JTextField txtFunctionStatus;
    private javax.swing.JTextField txtReadData;
    private javax.swing.JTextField txtReadDataAKM1;
    private javax.swing.JTextField txtReadDataAKM2;
    private javax.swing.JTextField txtReadDataPK;
    private javax.swing.JTextField txtWriteData;
    private javax.swing.JTextField txtWriteDataAKM1;
    private javax.swing.JTextField txtWriteDataAKM2;
    private javax.swing.JTextField txtWriteDataPK;
    // End of variables declaration//GEN-END:variables

}
