

package ufcoderadvancedapplet;

import com.sun.jna.ptr.ByteByReference;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

         
public class frmLinearFormatCard extends javax.swing.JInternalFrame 
{
    JTextField textfield;
    static final int 
         FUNCT_LIGHT_OK     = 4,
         FUNCT_SOUND_OK     = 0,//4 Tripple sound
         FUNCT_LIGHT_ERROR  = 2,
         FUNCT_SOUND_ERROR  = 0,//2 Long sound
         DL_OK              = 0;
    
    static final byte
         MIFARE_AUTHENT1A   = 0x60,  
         MIFARE_AUTHENT1B   = 0x61,
         MAX_BLOCK_BYTES    = 16;
    
    
    final static String ANY_DATA            = "You must enter any data !",
                        APPROPRIATE_FORMAT  = "You must enter the appropriate format !";
   
    

    
    public frmLinearFormatCard() {
        initComponents();        
        new GLFunctions().CreateTextBox(pnlKeyA,29,20,46,55,"txtLFKeyA");
        new GLFunctions().CreateTextBox(pnlKeyB,29,20,46,55,"txtLFKeyB");
        new GLFunctions().CreatePKBox(pnlPKKey,29,20,13,350,"txtPKKey");
    }
    

   
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        rbtnRadioButton = new javax.swing.ButtonGroup();
        pnlPKKey = new javax.swing.JPanel();
        rbAUTH1A = new javax.swing.JRadioButton();
        rbAUTH1B = new javax.swing.JRadioButton();
        lblKeyIndex = new javax.swing.JLabel();
        cboKeyIndex = new javax.swing.JComboBox();
        lblPKKey = new javax.swing.JLabel();
        pnlKeyA = new javax.swing.JPanel();
        lblKeyA = new javax.swing.JLabel();
        chkLFHexA = new javax.swing.JCheckBox();
        pnlKeyB = new javax.swing.JPanel();
        lblKeyB = new javax.swing.JLabel();
        chkLFHexB = new javax.swing.JCheckBox();
        tabLinearFormatCard = new javax.swing.JTabbedPane();
        tabLinearFormat = new javax.swing.JPanel();
        cboBlockAccessBits = new javax.swing.JComboBox();
        cboSectorTrailerAccessBits = new javax.swing.JComboBox();
        txtSectorTrailerByte9 = new javax.swing.JTextField();
        btnLinearFormat = new javax.swing.JButton();
        txtSectorFormatted = new javax.swing.JTextField();
        lblBlockAccessBits = new javax.swing.JLabel();
        lblSectorFormatted = new javax.swing.JLabel();
        lblSectorTrailerAccessBits = new javax.swing.JLabel();
        lblSectorTrailerByte9 = new javax.swing.JLabel();
        tabLinearFormatAKM1 = new javax.swing.JPanel();
        cboBlockAccessBitsAKM1 = new javax.swing.JComboBox();
        cboSectorTrailerAccessBitsAKM1 = new javax.swing.JComboBox();
        txtSectorTrailerByte9AKM1 = new javax.swing.JTextField();
        btnLinearFormatAKM1 = new javax.swing.JButton();
        lblBlockAccessBitsAKM1 = new javax.swing.JLabel();
        lblTrailerByte9AKM1 = new javax.swing.JLabel();
        lblSectorTrailerAccessBitsAKM1 = new javax.swing.JLabel();
        lblSectorFormattedAKM1 = new javax.swing.JLabel();
        txtSectorFormattedAKM1 = new javax.swing.JTextField();
        tabLinearFormatAKM2 = new javax.swing.JPanel();
        cboBlockAccessBitsAKM2 = new javax.swing.JComboBox();
        cboSectorTrailerAccessBitsAKM2 = new javax.swing.JComboBox();
        txtSectorTrailerByte9AKM2 = new javax.swing.JTextField();
        btnLinearFormatAKM2 = new javax.swing.JButton();
        lblBlockAccessBitsAKM2 = new javax.swing.JLabel();
        lblSectorTrailerAccessBitsAKM2 = new javax.swing.JLabel();
        lblTrailerByte9AKM2 = new javax.swing.JLabel();
        lblSectorFormattedAKM2 = new javax.swing.JLabel();
        txtSectorFormattedAKM2 = new javax.swing.JTextField();
        tabLinearFormatPK = new javax.swing.JPanel();
        cboBlockAccessBitsPK = new javax.swing.JComboBox();
        cboSectorTrailerAccessBitsPK = new javax.swing.JComboBox();
        txtSectorTrailerByte9PK = new javax.swing.JTextField();
        btnLinearFormatPK = new javax.swing.JButton();
        lblBlockAccessBitsPK = new javax.swing.JLabel();
        lblSectorTrailerAccessBitsPK = new javax.swing.JLabel();
        lblTrailerByte9PK = new javax.swing.JLabel();
        lblSectorFormattedPK = new javax.swing.JLabel();
        txtSectorFormattedPK = new javax.swing.JTextField();
        txtFunctionStatus = new javax.swing.JTextField();
        txtFErrorCode = new javax.swing.JTextField();
        txtFErrorExplain = new javax.swing.JTextField();

        setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        setTitle("frmLinearFormatCard");
        setName("frmLinearFormatCard"); // NOI18N
        setPreferredSize(new java.awt.Dimension(569, 449));
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlPKKey.setBackground(new java.awt.Color(255, 255, 255));
        pnlPKKey.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        rbAUTH1A.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioButton.add(rbAUTH1A);
        rbAUTH1A.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1A.setSelected(true);
        rbAUTH1A.setText("AUTH 1A");
        rbAUTH1A.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        rbAUTH1B.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioButton.add(rbAUTH1B);
        rbAUTH1B.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1B.setText("AUTH 1B");
        rbAUTH1B.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblKeyIndex.setText("Key Index");

        cboKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        cboKeyIndex.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", " " }));
        cboKeyIndex.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblPKKey.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblPKKey.setText("PK Key");

        javax.swing.GroupLayout pnlPKKeyLayout = new javax.swing.GroupLayout(pnlPKKey);
        pnlPKKey.setLayout(pnlPKKeyLayout);
        pnlPKKeyLayout.setHorizontalGroup(
            pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPKKeyLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(rbAUTH1A)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rbAUTH1B)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lblKeyIndex)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(10, 10, 10)
                .addComponent(lblPKKey)
                .addContainerGap(340, Short.MAX_VALUE))
        );
        pnlPKKeyLayout.setVerticalGroup(
            pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPKKeyLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblPKKey)
                    .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblKeyIndex)
                    .addComponent(rbAUTH1A)
                    .addComponent(rbAUTH1B))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        getContentPane().add(pnlPKKey, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 658, 40));

        pnlKeyA.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        lblKeyA.setBackground(new java.awt.Color(204, 204, 204));
        lblKeyA.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblKeyA.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblKeyA.setText("KEY A");
        lblKeyA.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblKeyA.setOpaque(true);

        chkLFHexA.setFont(new java.awt.Font("Verdana", 0, 12)); // NOI18N
        chkLFHexA.setText("Hex");
        chkLFHexA.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        chkLFHexA.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkLFHexAItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout pnlKeyALayout = new javax.swing.GroupLayout(pnlKeyA);
        pnlKeyA.setLayout(pnlKeyALayout);
        pnlKeyALayout.setHorizontalGroup(
            pnlKeyALayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblKeyA, javax.swing.GroupLayout.PREFERRED_SIZE, 259, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGroup(pnlKeyALayout.createSequentialGroup()
                .addGap(52, 52, 52)
                .addComponent(chkLFHexA))
        );
        pnlKeyALayout.setVerticalGroup(
            pnlKeyALayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlKeyALayout.createSequentialGroup()
                .addComponent(lblKeyA)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 48, Short.MAX_VALUE)
                .addComponent(chkLFHexA)
                .addContainerGap())
        );

        getContentPane().add(pnlKeyA, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 50, 260, 100));

        pnlKeyB.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        lblKeyB.setBackground(new java.awt.Color(204, 204, 204));
        lblKeyB.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblKeyB.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblKeyB.setText("KEY B");
        lblKeyB.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblKeyB.setOpaque(true);

        chkLFHexB.setFont(new java.awt.Font("Verdana", 0, 12)); // NOI18N
        chkLFHexB.setText("Hex");
        chkLFHexB.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        chkLFHexB.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkLFHexBItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout pnlKeyBLayout = new javax.swing.GroupLayout(pnlKeyB);
        pnlKeyB.setLayout(pnlKeyBLayout);
        pnlKeyBLayout.setHorizontalGroup(
            pnlKeyBLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblKeyB, javax.swing.GroupLayout.PREFERRED_SIZE, 259, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGroup(pnlKeyBLayout.createSequentialGroup()
                .addGap(52, 52, 52)
                .addComponent(chkLFHexB))
        );
        pnlKeyBLayout.setVerticalGroup(
            pnlKeyBLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlKeyBLayout.createSequentialGroup()
                .addComponent(lblKeyB)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 48, Short.MAX_VALUE)
                .addComponent(chkLFHexB)
                .addContainerGap())
        );

        getContentPane().add(pnlKeyB, new org.netbeans.lib.awtextra.AbsoluteConstraints(280, 50, 260, 100));

        tabLinearFormatCard.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N

        tabLinearFormat.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormat.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        cboBlockAccessBits.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboBlockAccessBits.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboBlockAccessBits.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboBlockAccessBits.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabLinearFormat.add(cboBlockAccessBits, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 30, 37, -1));

        cboSectorTrailerAccessBits.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboSectorTrailerAccessBits.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboSectorTrailerAccessBits.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboSectorTrailerAccessBits.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabLinearFormat.add(cboSectorTrailerAccessBits, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 60, 37, -1));

        txtSectorTrailerByte9.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtSectorTrailerByte9.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorTrailerByte9.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormat.add(txtSectorTrailerByte9, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 90, 37, -1));

        btnLinearFormat.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnLinearFormat.setText("FORMAT");
        btnLinearFormat.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnLinearFormat.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnLinearFormat.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnLinearFormatActionPerformed(evt);
            }
        });
        tabLinearFormat.add(btnLinearFormat, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 30, 181, 61));

        txtSectorFormatted.setEditable(false);
        txtSectorFormatted.setBackground(new java.awt.Color(204, 204, 204));
        txtSectorFormatted.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtSectorFormatted.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorFormatted.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormat.add(txtSectorFormatted, new org.netbeans.lib.awtextra.AbsoluteConstraints(460, 120, 45, 20));

        lblBlockAccessBits.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAccessBits.setText("Block Access Bits");
        tabLinearFormat.add(lblBlockAccessBits, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 30, -1, -1));

        lblSectorFormatted.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorFormatted.setText("Sector Formatted");
        tabLinearFormat.add(lblSectorFormatted, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 120, -1, -1));

        lblSectorTrailerAccessBits.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorTrailerAccessBits.setText("Sector Trailer Access Bits");
        tabLinearFormat.add(lblSectorTrailerAccessBits, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 60, -1, -1));

        lblSectorTrailerByte9.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorTrailerByte9.setText("Sector Trailer Byte 9");
        tabLinearFormat.add(lblSectorTrailerByte9, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 90, -1, -1));

        tabLinearFormatCard.addTab("Linear Format ", tabLinearFormat);

        tabLinearFormatAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormatAKM1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        cboBlockAccessBitsAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboBlockAccessBitsAKM1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboBlockAccessBitsAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboBlockAccessBitsAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabLinearFormatAKM1.add(cboBlockAccessBitsAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 30, 37, -1));

        cboSectorTrailerAccessBitsAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboSectorTrailerAccessBitsAKM1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboSectorTrailerAccessBitsAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboSectorTrailerAccessBitsAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabLinearFormatAKM1.add(cboSectorTrailerAccessBitsAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 60, 37, -1));

        txtSectorTrailerByte9AKM1.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtSectorTrailerByte9AKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorTrailerByte9AKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormatAKM1.add(txtSectorTrailerByte9AKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 90, 37, -1));

        btnLinearFormatAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnLinearFormatAKM1.setText("FORMAT");
        btnLinearFormatAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnLinearFormatAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnLinearFormatAKM1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnLinearFormatAKM1ActionPerformed(evt);
            }
        });
        tabLinearFormatAKM1.add(btnLinearFormatAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 30, 181, 61));

        lblBlockAccessBitsAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAccessBitsAKM1.setText("Block Access Bits");
        tabLinearFormatAKM1.add(lblBlockAccessBitsAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 30, -1, -1));

        lblTrailerByte9AKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblTrailerByte9AKM1.setText("Sector Trailer Byte 9");
        tabLinearFormatAKM1.add(lblTrailerByte9AKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 90, -1, -1));

        lblSectorTrailerAccessBitsAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorTrailerAccessBitsAKM1.setText("Sector Trailer Access Bits");
        tabLinearFormatAKM1.add(lblSectorTrailerAccessBitsAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 60, -1, -1));

        lblSectorFormattedAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorFormattedAKM1.setText("Sector Formatted");
        tabLinearFormatAKM1.add(lblSectorFormattedAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 120, -1, -1));

        txtSectorFormattedAKM1.setEditable(false);
        txtSectorFormattedAKM1.setBackground(new java.awt.Color(204, 204, 204));
        txtSectorFormattedAKM1.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtSectorFormattedAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorFormattedAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormatAKM1.add(txtSectorFormattedAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(460, 120, 45, 20));

        tabLinearFormatCard.addTab("Linear Format AKM1", tabLinearFormatAKM1);

        tabLinearFormatAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormatAKM2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        cboBlockAccessBitsAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboBlockAccessBitsAKM2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboBlockAccessBitsAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboBlockAccessBitsAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabLinearFormatAKM2.add(cboBlockAccessBitsAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 30, 37, -1));

        cboSectorTrailerAccessBitsAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboSectorTrailerAccessBitsAKM2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboSectorTrailerAccessBitsAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboSectorTrailerAccessBitsAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabLinearFormatAKM2.add(cboSectorTrailerAccessBitsAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 60, 37, -1));

        txtSectorTrailerByte9AKM2.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtSectorTrailerByte9AKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorTrailerByte9AKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormatAKM2.add(txtSectorTrailerByte9AKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 90, 37, -1));

        btnLinearFormatAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnLinearFormatAKM2.setText("FORMAT");
        btnLinearFormatAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnLinearFormatAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnLinearFormatAKM2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnLinearFormatAKM2ActionPerformed(evt);
            }
        });
        tabLinearFormatAKM2.add(btnLinearFormatAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 30, 181, 61));

        lblBlockAccessBitsAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAccessBitsAKM2.setText("Block Access Bits");
        tabLinearFormatAKM2.add(lblBlockAccessBitsAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 30, -1, -1));

        lblSectorTrailerAccessBitsAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorTrailerAccessBitsAKM2.setText("Sector Trailer Access Bits");
        tabLinearFormatAKM2.add(lblSectorTrailerAccessBitsAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 60, -1, -1));

        lblTrailerByte9AKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblTrailerByte9AKM2.setText("Sector Trailer Byte 9");
        tabLinearFormatAKM2.add(lblTrailerByte9AKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 90, -1, -1));

        lblSectorFormattedAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorFormattedAKM2.setText("Sector Formatted");
        tabLinearFormatAKM2.add(lblSectorFormattedAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 120, -1, -1));

        txtSectorFormattedAKM2.setEditable(false);
        txtSectorFormattedAKM2.setBackground(new java.awt.Color(204, 204, 204));
        txtSectorFormattedAKM2.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtSectorFormattedAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorFormattedAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormatAKM2.add(txtSectorFormattedAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(460, 120, 45, 20));

        tabLinearFormatCard.addTab("Linear Format AKM2", tabLinearFormatAKM2);

        tabLinearFormatPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormatPK.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        cboBlockAccessBitsPK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboBlockAccessBitsPK.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboBlockAccessBitsPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboBlockAccessBitsPK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabLinearFormatPK.add(cboBlockAccessBitsPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 30, 37, -1));

        cboSectorTrailerAccessBitsPK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboSectorTrailerAccessBitsPK.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboSectorTrailerAccessBitsPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboSectorTrailerAccessBitsPK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabLinearFormatPK.add(cboSectorTrailerAccessBitsPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 60, 37, -1));

        txtSectorTrailerByte9PK.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtSectorTrailerByte9PK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorTrailerByte9PK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormatPK.add(txtSectorTrailerByte9PK, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 90, 37, -1));

        btnLinearFormatPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnLinearFormatPK.setText("FORMAT");
        btnLinearFormatPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnLinearFormatPK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnLinearFormatPK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnLinearFormatPKActionPerformed(evt);
            }
        });
        tabLinearFormatPK.add(btnLinearFormatPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 30, 181, 61));

        lblBlockAccessBitsPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAccessBitsPK.setText("Block Access Bits");
        tabLinearFormatPK.add(lblBlockAccessBitsPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 30, -1, -1));

        lblSectorTrailerAccessBitsPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorTrailerAccessBitsPK.setText("Sector Trailer Access Bits");
        tabLinearFormatPK.add(lblSectorTrailerAccessBitsPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 60, -1, -1));

        lblTrailerByte9PK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblTrailerByte9PK.setText("Sector Trailer Byte 9");
        tabLinearFormatPK.add(lblTrailerByte9PK, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 90, -1, -1));

        lblSectorFormattedPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorFormattedPK.setText("Sector Formatted");
        tabLinearFormatPK.add(lblSectorFormattedPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 120, -1, -1));

        txtSectorFormattedPK.setEditable(false);
        txtSectorFormattedPK.setBackground(new java.awt.Color(204, 204, 204));
        txtSectorFormattedPK.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtSectorFormattedPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorFormattedPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabLinearFormatPK.add(txtSectorFormattedPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(460, 120, 45, -1));

        tabLinearFormatCard.addTab("Linear Format PK", tabLinearFormatPK);

        getContentPane().add(tabLinearFormatCard, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 160, 540, -1));

        txtFunctionStatus.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFunctionStatus.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtFunctionStatus.setText("Function Status");
        getContentPane().add(txtFunctionStatus, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 390, 140, -1));

        txtFErrorCode.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorCode.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorCode, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 390, 70, -1));

        txtFErrorExplain.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorExplain.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorExplain, new org.netbeans.lib.awtextra.AbsoluteConstraints(210, 390, 350, -1));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void chkLFHexAItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkLFHexAItemStateChanged
        new GLFunctions().HexBoxs(pnlKeyA,"txtLFKeyA",chkLFHexA);
        new GLFunctions().HEXBOX=chkLFHexA;
        new GLFunctions().TEXTFIELD="txtLFKeyA";
}//GEN-LAST:event_chkLFHexAItemStateChanged

    private void chkLFHexBItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkLFHexBItemStateChanged
        new GLFunctions().HexBoxs(pnlKeyB,"txtLFKeyB",chkLFHexB);
        new GLFunctions().HEXBOX=chkLFHexB;
        new GLFunctions().TEXTFIELD="txtLFKeyB";
}//GEN-LAST:event_chkLFHexBItemStateChanged

    private void btnLinearFormatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnLinearFormatActionPerformed
       frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult             = 0;
          byte  bAuthMode            = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress        = 0;          
          
          byte  bBlockAccessBits     = 0,
                bSectorAccessBits    = 0,
                bSectorTrailersByte9 = 0;
        
          ByteByReference bSectorsFormatted=new ByteByReference();
          byte  bKeyIndex            = (byte)cboKeyIndex.getSelectedIndex();
          
         if (txtSectorTrailerByte9.getText().trim().isEmpty())
         {
            JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR TRAILER BYTE 9","Warning", JOptionPane.WARNING_MESSAGE);
            txtSectorTrailerByte9.requestFocus();
            return;
         }
         
         txtSectorFormatted.setText("");         
         bBlockAccessBits     = (byte)cboBlockAccessBits.getSelectedIndex();
         bSectorAccessBits    = (byte)cboSectorTrailerAccessBits.getSelectedIndex();
         bSectorTrailersByte9 = Byte.parseByte(txtSectorTrailerByte9.getText().trim());

         iFResult=Declarations.uFrFunctions.uFrInstance.LinearFormatCard(new GLFunctions().KEY(pnlKeyA,"txtLFKeyA",chkLFHexA), bBlockAccessBits, bSectorAccessBits,bSectorTrailersByte9,new GLFunctions().KEY(pnlKeyB,"txtLFKeyB",chkLFHexB), bSectorsFormatted, bAuthMode, bKeyIndex);

         if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         txtSectorFormatted.setText(Byte.toString(bSectorsFormatted.getValue()));
      }
      catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }

    }//GEN-LAST:event_btnLinearFormatActionPerformed

    private void btnLinearFormatAKM1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnLinearFormatAKM1ActionPerformed
        frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult             = 0;
          byte  bAuthMode            = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress        = 0;          
          
          byte  bBlockAccessBits     = 0,
                bSectorAccessBits    = 0,
                bSectorTrailersByte9 = 0;
        
          ByteByReference bSectorsFormatted=new ByteByReference();
        
      
         if (txtSectorTrailerByte9AKM1.getText().trim().isEmpty())
         {
            JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR TRAILER BYTE 9","Warning", JOptionPane.WARNING_MESSAGE);
            txtSectorTrailerByte9AKM1.requestFocus();
            return;
         }
         
         txtSectorFormattedAKM1.setText("");         
         bBlockAccessBits      = (byte)cboBlockAccessBitsAKM1.getSelectedIndex();
         bSectorAccessBits     = (byte)cboSectorTrailerAccessBitsAKM1.getSelectedIndex();
         bSectorTrailersByte9  = Byte.parseByte(txtSectorTrailerByte9AKM1.getText().trim());

         iFResult=Declarations.uFrFunctions.uFrInstance.LinearFormatCard_AKM1(new GLFunctions().KEY(pnlKeyA,"txtLFKeyA",chkLFHexA), bBlockAccessBits, bSectorAccessBits,bSectorTrailersByte9,new GLFunctions().KEY(pnlKeyB,"txtLFKeyB",chkLFHexB), bSectorsFormatted, bAuthMode);

         if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         txtSectorFormattedAKM1.setText(Byte.toString(bSectorsFormatted.getValue()));
      }
      catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }

    }//GEN-LAST:event_btnLinearFormatAKM1ActionPerformed

    private void btnLinearFormatAKM2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnLinearFormatAKM2ActionPerformed
        frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult             = 0;
          byte  bAuthMode            = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress        = 0;          
          
          byte  bBlockAccessBits     = 0,
                bSectorAccessBits    = 0,
                bSectorTrailersByte9 = 0;
        ByteByReference bSectorsFormatted=new ByteByReference();
     
         if (txtSectorTrailerByte9AKM2.getText().trim().isEmpty())
         {
            JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR TRAILER BYTE 9","Warning", JOptionPane.WARNING_MESSAGE);
            txtSectorTrailerByte9AKM2.requestFocus();
            return;
         }
         
         txtSectorFormattedAKM2.setText("");         
         bBlockAccessBits     = (byte)cboBlockAccessBitsAKM2.getSelectedIndex();
         bSectorAccessBits    = (byte)cboSectorTrailerAccessBitsAKM2.getSelectedIndex();
         bSectorTrailersByte9 = Byte.parseByte(txtSectorTrailerByte9AKM2.getText().trim());

         iFResult=Declarations.uFrFunctions.uFrInstance.LinearFormatCard_AKM2(new GLFunctions().KEY(pnlKeyA,"txtLFKeyA",chkLFHexA), bBlockAccessBits, bSectorAccessBits,bSectorTrailersByte9,new GLFunctions().KEY(pnlKeyB,"txtLFKeyB",chkLFHexB), bSectorsFormatted, bAuthMode);

         if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         txtSectorFormattedAKM2.setText(Byte.toString(bSectorsFormatted.getValue()));
      }
      catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }

    }//GEN-LAST:event_btnLinearFormatAKM2ActionPerformed

    private void btnLinearFormatPKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnLinearFormatPKActionPerformed
        frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult             = 0;
          byte  bAuthMode            = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                              
          byte  bBlockAddress        = 0;          
          
          byte  bBlockAccessBits     = 0,
                bSectorAccessBits    = 0,
                bSectorTrailersByte9 = 0;
        ByteByReference bSectorsFormatted=new ByteByReference();
      
         if (txtSectorTrailerByte9PK.getText().trim().isEmpty())
         {
            JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR TRAILER BYTE 9","Warning", JOptionPane.WARNING_MESSAGE);
            txtSectorTrailerByte9PK.requestFocus();
            return;
         }
         
         txtSectorFormattedPK.setText("");         
         bBlockAccessBits     = (byte)cboBlockAccessBitsPK.getSelectedIndex();
         bSectorAccessBits    = (byte)cboSectorTrailerAccessBitsPK.getSelectedIndex();
         bSectorTrailersByte9 = Byte.parseByte(txtSectorTrailerByte9PK.getText().trim());

         iFResult=Declarations.uFrFunctions.uFrInstance.LinearFormatCard_PK(new GLFunctions().KEY(pnlKeyA,"txtLFKeyA",chkLFHexA), bBlockAccessBits, bSectorAccessBits,bSectorTrailersByte9,new GLFunctions().KEY(pnlKeyB,"txtLFKeyB",chkLFHexB), bSectorsFormatted, bAuthMode,new GLFunctions().PK_KEY(pnlPKKey));

         if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         txtSectorFormattedPK.setText(Byte.toString(bSectorsFormatted.getValue()));
      }
      catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }

    }//GEN-LAST:event_btnLinearFormatPKActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnLinearFormat;
    private javax.swing.JButton btnLinearFormatAKM1;
    private javax.swing.JButton btnLinearFormatAKM2;
    private javax.swing.JButton btnLinearFormatPK;
    private javax.swing.JComboBox cboBlockAccessBits;
    private javax.swing.JComboBox cboBlockAccessBitsAKM1;
    private javax.swing.JComboBox cboBlockAccessBitsAKM2;
    private javax.swing.JComboBox cboBlockAccessBitsPK;
    private javax.swing.JComboBox cboKeyIndex;
    private javax.swing.JComboBox cboSectorTrailerAccessBits;
    private javax.swing.JComboBox cboSectorTrailerAccessBitsAKM1;
    private javax.swing.JComboBox cboSectorTrailerAccessBitsAKM2;
    private javax.swing.JComboBox cboSectorTrailerAccessBitsPK;
    private javax.swing.JCheckBox chkLFHexA;
    private javax.swing.JCheckBox chkLFHexB;
    private javax.swing.JLabel lblBlockAccessBits;
    private javax.swing.JLabel lblBlockAccessBitsAKM1;
    private javax.swing.JLabel lblBlockAccessBitsAKM2;
    private javax.swing.JLabel lblBlockAccessBitsPK;
    private javax.swing.JLabel lblKeyA;
    private javax.swing.JLabel lblKeyB;
    private javax.swing.JLabel lblKeyIndex;
    private javax.swing.JLabel lblPKKey;
    private javax.swing.JLabel lblSectorFormatted;
    private javax.swing.JLabel lblSectorFormattedAKM1;
    private javax.swing.JLabel lblSectorFormattedAKM2;
    private javax.swing.JLabel lblSectorFormattedPK;
    private javax.swing.JLabel lblSectorTrailerAccessBits;
    private javax.swing.JLabel lblSectorTrailerAccessBitsAKM1;
    private javax.swing.JLabel lblSectorTrailerAccessBitsAKM2;
    private javax.swing.JLabel lblSectorTrailerAccessBitsPK;
    private javax.swing.JLabel lblSectorTrailerByte9;
    private javax.swing.JLabel lblTrailerByte9AKM1;
    private javax.swing.JLabel lblTrailerByte9AKM2;
    private javax.swing.JLabel lblTrailerByte9PK;
    private javax.swing.JPanel pnlKeyA;
    private javax.swing.JPanel pnlKeyB;
    private javax.swing.JPanel pnlPKKey;
    private javax.swing.JRadioButton rbAUTH1A;
    private javax.swing.JRadioButton rbAUTH1B;
    private javax.swing.ButtonGroup rbtnRadioButton;
    private javax.swing.JPanel tabLinearFormat;
    private javax.swing.JPanel tabLinearFormatAKM1;
    private javax.swing.JPanel tabLinearFormatAKM2;
    private javax.swing.JTabbedPane tabLinearFormatCard;
    private javax.swing.JPanel tabLinearFormatPK;
    private javax.swing.JTextField txtFErrorCode;
    private javax.swing.JTextField txtFErrorExplain;
    private javax.swing.JTextField txtFunctionStatus;
    private javax.swing.JTextField txtSectorFormatted;
    private javax.swing.JTextField txtSectorFormattedAKM1;
    private javax.swing.JTextField txtSectorFormattedAKM2;
    private javax.swing.JTextField txtSectorFormattedPK;
    private javax.swing.JTextField txtSectorTrailerByte9;
    private javax.swing.JTextField txtSectorTrailerByte9AKM1;
    private javax.swing.JTextField txtSectorTrailerByte9AKM2;
    private javax.swing.JTextField txtSectorTrailerByte9PK;
    // End of variables declaration//GEN-END:variables

   
}
