
package ufcoderadvancedapplet;

import javax.swing.JOptionPane;


public class frmSectorTrailerWrite extends javax.swing.JInternalFrame {
    static final int 
         FUNCT_LIGHT_OK     = 4,
         FUNCT_SOUND_OK     = 0,//4 Tripple sound
         FUNCT_LIGHT_ERROR  = 2,
         FUNCT_SOUND_ERROR  = 0,//2 Long sound
         DL_OK              = 0;
    
    static final byte
         MIFARE_AUTHENT1A   = 0x60,  
         MIFARE_AUTHENT1B   = 0x61,
         MAX_BLOCK_BYTES    = 16;
    
    
    final static String ANY_DATA            = "You must enter any data !",
                        APPROPRIATE_FORMAT  = "You must enter the appropriate format !";
    
    public frmSectorTrailerWrite() {
        initComponents();
        new GLFunctions().CreateTextBox(pnlKeyA,29,20,46,55,"txtSTKeyA");
        new GLFunctions().CreateTextBox(pnlKeyB,29,20,46,55,"txtSTKeyB");
        new GLFunctions().CreatePKBox(pnlPKKey,29,20,13,350,"txtPKKey");
    }

    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        rbtnRadioButton = new javax.swing.ButtonGroup();
        pnlPKKey = new javax.swing.JPanel();
        rbAUTH1A = new javax.swing.JRadioButton();
        rbAUTH1B = new javax.swing.JRadioButton();
        lblKeyIndex = new javax.swing.JLabel();
        cboKeyIndex = new javax.swing.JComboBox();
        lblPKKey = new javax.swing.JLabel();
        pnlKeyA = new javax.swing.JPanel();
        lblKeyA = new javax.swing.JLabel();
        chkSTHexA = new javax.swing.JCheckBox();
        pnlKeyB = new javax.swing.JPanel();
        lblKeyB = new javax.swing.JLabel();
        chkSTHexB = new javax.swing.JCheckBox();
        tabSectorTrailerWrite = new javax.swing.JTabbedPane();
        tabSectorTrailer = new javax.swing.JPanel();
        cboAddressingMode = new javax.swing.JComboBox();
        txtBlockOrSectorAddress = new javax.swing.JTextField();
        cboAccessBits0 = new javax.swing.JComboBox();
        cboAccessBits1 = new javax.swing.JComboBox();
        cboAccessBits2 = new javax.swing.JComboBox();
        cboTrailerAccessBits = new javax.swing.JComboBox();
        txtTrailerByte9 = new javax.swing.JTextField();
        btnWrite = new javax.swing.JButton();
        lblAddressingMode = new javax.swing.JLabel();
        lblBlockOrSectorAddress = new javax.swing.JLabel();
        lblAccessBits0 = new javax.swing.JLabel();
        lblAccessBits1 = new javax.swing.JLabel();
        lblAccessBits2 = new javax.swing.JLabel();
        lblTrailerAccessBits = new javax.swing.JLabel();
        lblTrailerByte9 = new javax.swing.JLabel();
        tabSectorTrailerAKM1 = new javax.swing.JPanel();
        lblAddressingModeAKM1 = new javax.swing.JLabel();
        cboAddressingModeAKM1 = new javax.swing.JComboBox();
        lblBlockOrSectorAddressAKM1 = new javax.swing.JLabel();
        txtBlockOrSectorAddressAKM1 = new javax.swing.JTextField();
        lblAccessBits0AKM1 = new javax.swing.JLabel();
        cboAccessBits0AKM1 = new javax.swing.JComboBox();
        lblAccessBits1AKM1 = new javax.swing.JLabel();
        cboAccessBits1AKM1 = new javax.swing.JComboBox();
        lblAccessBits2AKM1 = new javax.swing.JLabel();
        cboAccessBits2AKM1 = new javax.swing.JComboBox();
        lblTrailerAccessBitsAKM1 = new javax.swing.JLabel();
        cboTrailerAccessBitsAKM1 = new javax.swing.JComboBox();
        lblTrailerByte9AKM1 = new javax.swing.JLabel();
        txtTrailerByte9AKM1 = new javax.swing.JTextField();
        btnWriteAKM1 = new javax.swing.JButton();
        tabSectorTrailerAKM2 = new javax.swing.JPanel();
        lblAddressingModeAKM2 = new javax.swing.JLabel();
        cboAddressingModeAKM2 = new javax.swing.JComboBox();
        lblBlockOrSectorAddressAKM2 = new javax.swing.JLabel();
        txtBlockOrSectorAddressAKM2 = new javax.swing.JTextField();
        lblAccessBits0AKM2 = new javax.swing.JLabel();
        cboAccessBits0AKM2 = new javax.swing.JComboBox();
        lblAccessBits1AKM2 = new javax.swing.JLabel();
        cboAccessBits1AKM2 = new javax.swing.JComboBox();
        lblAccessBits2AKM2 = new javax.swing.JLabel();
        cboAccessBits2AKM2 = new javax.swing.JComboBox();
        lblTrailerAccessBitsAKM2 = new javax.swing.JLabel();
        cboTrailerAccessBitsAKM2 = new javax.swing.JComboBox();
        lblTrailerByte9AKM2 = new javax.swing.JLabel();
        txtTrailerByte9AKM2 = new javax.swing.JTextField();
        btnWriteAKM2 = new javax.swing.JButton();
        tabSectorTrailerPK = new javax.swing.JPanel();
        lblAddressingModePK = new javax.swing.JLabel();
        cboAddressingModePK = new javax.swing.JComboBox();
        lblBlockOrSectorAddressPK = new javax.swing.JLabel();
        txtBlockOrSectorAddressPK = new javax.swing.JTextField();
        lblAccessBits0PK = new javax.swing.JLabel();
        cboAccessBits0PK = new javax.swing.JComboBox();
        lblAccessBits1PK = new javax.swing.JLabel();
        cboAccessBits1PK = new javax.swing.JComboBox();
        lblAccessBits2PK = new javax.swing.JLabel();
        cboAccessBits2PK = new javax.swing.JComboBox();
        lblTrailerAccessBitsPK = new javax.swing.JLabel();
        cboTrailerAccessBitsPK = new javax.swing.JComboBox();
        lblTrailerByte9PK = new javax.swing.JLabel();
        txtTrailerByte9PK = new javax.swing.JTextField();
        btnWritePK = new javax.swing.JButton();
        txtFunctionStatus = new javax.swing.JTextField();
        txtFErrorCode = new javax.swing.JTextField();
        txtFErrorExplain = new javax.swing.JTextField();

        setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        setTitle("frmSectorTrailer Write");
        setName("frmSectorTrailerWrite"); // NOI18N
        setPreferredSize(new java.awt.Dimension(569, 449));
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlPKKey.setBackground(new java.awt.Color(255, 255, 255));
        pnlPKKey.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        rbAUTH1A.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioButton.add(rbAUTH1A);
        rbAUTH1A.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1A.setSelected(true);
        rbAUTH1A.setText("AUTH 1A");
        rbAUTH1A.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        rbAUTH1B.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioButton.add(rbAUTH1B);
        rbAUTH1B.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1B.setText("AUTH 1B");
        rbAUTH1B.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblKeyIndex.setText("Key Index");

        cboKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        cboKeyIndex.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", " " }));
        cboKeyIndex.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblPKKey.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblPKKey.setText("PK Key");

        javax.swing.GroupLayout pnlPKKeyLayout = new javax.swing.GroupLayout(pnlPKKey);
        pnlPKKey.setLayout(pnlPKKeyLayout);
        pnlPKKeyLayout.setHorizontalGroup(
            pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPKKeyLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(rbAUTH1A)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rbAUTH1B)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lblKeyIndex)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(10, 10, 10)
                .addComponent(lblPKKey)
                .addContainerGap(340, Short.MAX_VALUE))
        );
        pnlPKKeyLayout.setVerticalGroup(
            pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPKKeyLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblPKKey)
                    .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblKeyIndex)
                    .addComponent(rbAUTH1A)
                    .addComponent(rbAUTH1B))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        getContentPane().add(pnlPKKey, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 658, 40));

        pnlKeyA.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        lblKeyA.setBackground(new java.awt.Color(204, 204, 204));
        lblKeyA.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblKeyA.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblKeyA.setText("KEY A");
        lblKeyA.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblKeyA.setOpaque(true);

        chkSTHexA.setFont(new java.awt.Font("Verdana", 0, 12)); // NOI18N
        chkSTHexA.setText("Hex");
        chkSTHexA.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        chkSTHexA.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkSTHexAItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout pnlKeyALayout = new javax.swing.GroupLayout(pnlKeyA);
        pnlKeyA.setLayout(pnlKeyALayout);
        pnlKeyALayout.setHorizontalGroup(
            pnlKeyALayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblKeyA, javax.swing.GroupLayout.PREFERRED_SIZE, 258, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGroup(pnlKeyALayout.createSequentialGroup()
                .addGap(52, 52, 52)
                .addComponent(chkSTHexA))
        );
        pnlKeyALayout.setVerticalGroup(
            pnlKeyALayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlKeyALayout.createSequentialGroup()
                .addComponent(lblKeyA)
                .addGap(49, 49, 49)
                .addComponent(chkSTHexA))
        );

        getContentPane().add(pnlKeyA, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 50, 260, 100));

        pnlKeyB.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        lblKeyB.setBackground(new java.awt.Color(204, 204, 204));
        lblKeyB.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblKeyB.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblKeyB.setText("KEY B");
        lblKeyB.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblKeyB.setOpaque(true);

        chkSTHexB.setFont(new java.awt.Font("Verdana", 0, 12)); // NOI18N
        chkSTHexB.setText("Hex");
        chkSTHexB.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        chkSTHexB.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkSTHexBItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout pnlKeyBLayout = new javax.swing.GroupLayout(pnlKeyB);
        pnlKeyB.setLayout(pnlKeyBLayout);
        pnlKeyBLayout.setHorizontalGroup(
            pnlKeyBLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblKeyB, javax.swing.GroupLayout.PREFERRED_SIZE, 258, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGroup(pnlKeyBLayout.createSequentialGroup()
                .addGap(52, 52, 52)
                .addComponent(chkSTHexB))
        );
        pnlKeyBLayout.setVerticalGroup(
            pnlKeyBLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlKeyBLayout.createSequentialGroup()
                .addComponent(lblKeyB)
                .addGap(49, 49, 49)
                .addComponent(chkSTHexB))
        );

        getContentPane().add(pnlKeyB, new org.netbeans.lib.awtextra.AbsoluteConstraints(280, 50, 260, 100));

        tabSectorTrailerWrite.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N

        tabSectorTrailer.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailer.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        cboAddressingMode.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAddressingMode.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1" }));
        cboAddressingMode.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAddressingMode.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailer.add(cboAddressingMode, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 12, -1, -1));

        txtBlockOrSectorAddress.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtBlockOrSectorAddress.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockOrSectorAddress.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailer.add(txtBlockOrSectorAddress, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 44, 34, -1));

        cboAccessBits0.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits0.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits0.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits0.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailer.add(cboAccessBits0, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 69, -1, -1));

        cboAccessBits1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailer.add(cboAccessBits1, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 96, -1, -1));

        cboAccessBits2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailer.add(cboAccessBits2, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 123, -1, -1));

        cboTrailerAccessBits.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboTrailerAccessBits.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboTrailerAccessBits.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboTrailerAccessBits.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailer.add(cboTrailerAccessBits, new org.netbeans.lib.awtextra.AbsoluteConstraints(479, 12, -1, -1));

        txtTrailerByte9.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtTrailerByte9.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtTrailerByte9.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailer.add(txtTrailerByte9, new org.netbeans.lib.awtextra.AbsoluteConstraints(479, 44, 34, -1));

        btnWrite.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnWrite.setText("WRITE");
        btnWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnWrite.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnWrite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnWriteActionPerformed(evt);
            }
        });
        tabSectorTrailer.add(btnWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(356, 69, 157, 77));

        lblAddressingMode.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAddressingMode.setText("Addressing Mode");
        tabSectorTrailer.add(lblAddressingMode, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 15, -1, -1));

        lblBlockOrSectorAddress.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockOrSectorAddress.setText("Block or Sector Address");
        tabSectorTrailer.add(lblBlockOrSectorAddress, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 47, -1, -1));

        lblAccessBits0.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits0.setText("Access Bits 0");
        tabSectorTrailer.add(lblAccessBits0, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 72, -1, -1));

        lblAccessBits1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits1.setText("Access Bits 1");
        tabSectorTrailer.add(lblAccessBits1, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 99, -1, -1));

        lblAccessBits2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits2.setText("Access Bits 2");
        tabSectorTrailer.add(lblAccessBits2, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 126, -1, -1));

        lblTrailerAccessBits.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblTrailerAccessBits.setText("Trailer Access Bits");
        tabSectorTrailer.add(lblTrailerAccessBits, new org.netbeans.lib.awtextra.AbsoluteConstraints(356, 15, -1, -1));

        lblTrailerByte9.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblTrailerByte9.setText("Trailer Byte 9");
        tabSectorTrailer.add(lblTrailerByte9, new org.netbeans.lib.awtextra.AbsoluteConstraints(356, 47, -1, -1));

        tabSectorTrailerWrite.addTab("SectorTrailer Write", tabSectorTrailer);

        tabSectorTrailerAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailerAKM1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        lblAddressingModeAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAddressingModeAKM1.setText("Addressing Mode");
        tabSectorTrailerAKM1.add(lblAddressingModeAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(112, 15, -1, -1));

        cboAddressingModeAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAddressingModeAKM1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1" }));
        cboAddressingModeAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAddressingModeAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerAKM1.add(cboAddressingModeAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 12, -1, -1));

        lblBlockOrSectorAddressAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockOrSectorAddressAKM1.setText("Block or Sector Address");
        tabSectorTrailerAKM1.add(lblBlockOrSectorAddressAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(112, 47, -1, -1));

        txtBlockOrSectorAddressAKM1.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtBlockOrSectorAddressAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockOrSectorAddressAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailerAKM1.add(txtBlockOrSectorAddressAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 44, 34, -1));

        lblAccessBits0AKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits0AKM1.setText("Access Bits 0");
        tabSectorTrailerAKM1.add(lblAccessBits0AKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(112, 72, -1, -1));

        cboAccessBits0AKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits0AKM1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits0AKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits0AKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerAKM1.add(cboAccessBits0AKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 69, -1, -1));

        lblAccessBits1AKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits1AKM1.setText("Access Bits 1");
        tabSectorTrailerAKM1.add(lblAccessBits1AKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(112, 99, -1, -1));

        cboAccessBits1AKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits1AKM1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits1AKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits1AKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerAKM1.add(cboAccessBits1AKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 96, -1, -1));

        lblAccessBits2AKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits2AKM1.setText("Access Bits 2");
        tabSectorTrailerAKM1.add(lblAccessBits2AKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(112, 126, -1, -1));

        cboAccessBits2AKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits2AKM1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits2AKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits2AKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerAKM1.add(cboAccessBits2AKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 123, -1, -1));

        lblTrailerAccessBitsAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblTrailerAccessBitsAKM1.setText("Trailer Access Bits");
        tabSectorTrailerAKM1.add(lblTrailerAccessBitsAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(355, 15, -1, -1));

        cboTrailerAccessBitsAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboTrailerAccessBitsAKM1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboTrailerAccessBitsAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboTrailerAccessBitsAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerAKM1.add(cboTrailerAccessBitsAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(478, 12, -1, -1));

        lblTrailerByte9AKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblTrailerByte9AKM1.setText("Trailer Byte 9");
        tabSectorTrailerAKM1.add(lblTrailerByte9AKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(355, 47, -1, -1));

        txtTrailerByte9AKM1.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtTrailerByte9AKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtTrailerByte9AKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailerAKM1.add(txtTrailerByte9AKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(478, 44, 34, -1));

        btnWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnWriteAKM1.setText("WRITE");
        btnWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnWriteAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnWriteAKM1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnWriteAKM1ActionPerformed(evt);
            }
        });
        tabSectorTrailerAKM1.add(btnWriteAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(355, 69, 157, 77));

        tabSectorTrailerWrite.addTab("SectorTrailer AKM1", tabSectorTrailerAKM1);

        tabSectorTrailerAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailerAKM2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        lblAddressingModeAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAddressingModeAKM2.setText("Addressing Mode");
        tabSectorTrailerAKM2.add(lblAddressingModeAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 15, -1, -1));

        cboAddressingModeAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAddressingModeAKM2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1" }));
        cboAddressingModeAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAddressingModeAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerAKM2.add(cboAddressingModeAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 12, -1, -1));

        lblBlockOrSectorAddressAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockOrSectorAddressAKM2.setText("Block or Sector Address");
        tabSectorTrailerAKM2.add(lblBlockOrSectorAddressAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 47, -1, -1));

        txtBlockOrSectorAddressAKM2.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtBlockOrSectorAddressAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockOrSectorAddressAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailerAKM2.add(txtBlockOrSectorAddressAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 44, 34, -1));

        lblAccessBits0AKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits0AKM2.setText("Access Bits 0");
        tabSectorTrailerAKM2.add(lblAccessBits0AKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 72, -1, -1));

        cboAccessBits0AKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits0AKM2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits0AKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits0AKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerAKM2.add(cboAccessBits0AKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 69, -1, -1));

        lblAccessBits1AKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits1AKM2.setText("Access Bits 1");
        tabSectorTrailerAKM2.add(lblAccessBits1AKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 99, -1, -1));

        cboAccessBits1AKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits1AKM2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits1AKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits1AKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerAKM2.add(cboAccessBits1AKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 96, -1, -1));

        lblAccessBits2AKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits2AKM2.setText("Access Bits 2");
        tabSectorTrailerAKM2.add(lblAccessBits2AKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 126, -1, -1));

        cboAccessBits2AKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits2AKM2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits2AKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits2AKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerAKM2.add(cboAccessBits2AKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 123, -1, -1));

        lblTrailerAccessBitsAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblTrailerAccessBitsAKM2.setText("Trailer Access Bits");
        tabSectorTrailerAKM2.add(lblTrailerAccessBitsAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(356, 15, -1, -1));

        cboTrailerAccessBitsAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboTrailerAccessBitsAKM2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboTrailerAccessBitsAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboTrailerAccessBitsAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerAKM2.add(cboTrailerAccessBitsAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(479, 12, -1, -1));

        lblTrailerByte9AKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblTrailerByte9AKM2.setText("Trailer Byte 9");
        tabSectorTrailerAKM2.add(lblTrailerByte9AKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(356, 47, -1, -1));

        txtTrailerByte9AKM2.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtTrailerByte9AKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtTrailerByte9AKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailerAKM2.add(txtTrailerByte9AKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(479, 44, 34, -1));

        btnWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnWriteAKM2.setText("WRITE");
        btnWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnWriteAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnWriteAKM2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnWriteAKM2ActionPerformed(evt);
            }
        });
        tabSectorTrailerAKM2.add(btnWriteAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(356, 69, 157, 77));

        tabSectorTrailerWrite.addTab("SectorTrailer AKM2", tabSectorTrailerAKM2);

        tabSectorTrailerPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailerPK.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        lblAddressingModePK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAddressingModePK.setText("Addressing Mode");
        tabSectorTrailerPK.add(lblAddressingModePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 15, -1, -1));

        cboAddressingModePK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAddressingModePK.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1" }));
        cboAddressingModePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAddressingModePK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerPK.add(cboAddressingModePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 12, -1, -1));

        lblBlockOrSectorAddressPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockOrSectorAddressPK.setText("Block or Sector Address");
        tabSectorTrailerPK.add(lblBlockOrSectorAddressPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 47, -1, -1));

        txtBlockOrSectorAddressPK.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtBlockOrSectorAddressPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockOrSectorAddressPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailerPK.add(txtBlockOrSectorAddressPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 44, 34, -1));

        lblAccessBits0PK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits0PK.setText("Access Bits 0");
        tabSectorTrailerPK.add(lblAccessBits0PK, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 72, -1, -1));

        cboAccessBits0PK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits0PK.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits0PK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits0PK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerPK.add(cboAccessBits0PK, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 69, -1, -1));

        lblAccessBits1PK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits1PK.setText("Access Bits 1");
        tabSectorTrailerPK.add(lblAccessBits1PK, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 99, -1, -1));

        cboAccessBits1PK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits1PK.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits1PK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits1PK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerPK.add(cboAccessBits1PK, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 96, -1, -1));

        lblAccessBits2PK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblAccessBits2PK.setText("Access Bits 2");
        tabSectorTrailerPK.add(lblAccessBits2PK, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 126, -1, -1));

        cboAccessBits2PK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboAccessBits2PK.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboAccessBits2PK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboAccessBits2PK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerPK.add(cboAccessBits2PK, new org.netbeans.lib.awtextra.AbsoluteConstraints(261, 123, -1, -1));

        lblTrailerAccessBitsPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblTrailerAccessBitsPK.setText("Trailer Access Bits");
        tabSectorTrailerPK.add(lblTrailerAccessBitsPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(356, 15, -1, -1));

        cboTrailerAccessBitsPK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboTrailerAccessBitsPK.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        cboTrailerAccessBitsPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        cboTrailerAccessBitsPK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tabSectorTrailerPK.add(cboTrailerAccessBitsPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(479, 12, -1, -1));

        lblTrailerByte9PK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblTrailerByte9PK.setText("Trailer Byte 9");
        tabSectorTrailerPK.add(lblTrailerByte9PK, new org.netbeans.lib.awtextra.AbsoluteConstraints(356, 47, -1, -1));

        txtTrailerByte9PK.setFont(new java.awt.Font("Verdana", 1, 13)); // NOI18N
        txtTrailerByte9PK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtTrailerByte9PK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabSectorTrailerPK.add(txtTrailerByte9PK, new org.netbeans.lib.awtextra.AbsoluteConstraints(479, 44, 34, -1));

        btnWritePK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnWritePK.setText("WRITE");
        btnWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnWritePK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnWritePK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnWritePKActionPerformed(evt);
            }
        });
        tabSectorTrailerPK.add(btnWritePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(356, 69, 157, 77));

        tabSectorTrailerWrite.addTab("SectorTrailer PK", tabSectorTrailerPK);

        getContentPane().add(tabSectorTrailerWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(8, 166, 540, -1));

        txtFunctionStatus.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFunctionStatus.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtFunctionStatus.setText("Function Status");
        getContentPane().add(txtFunctionStatus, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 390, 140, -1));

        txtFErrorCode.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorCode.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorCode, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 390, 70, -1));

        txtFErrorExplain.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorExplain.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorExplain, new org.netbeans.lib.awtextra.AbsoluteConstraints(210, 390, 350, -1));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void chkSTHexAItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkSTHexAItemStateChanged
       new GLFunctions().HexBoxs(pnlKeyA,"txtSTKeyA",chkSTHexA);    
       new GLFunctions().HEXBOX=chkSTHexA;
       new GLFunctions().TEXTFIELD="txtSTKeyA";
    }//GEN-LAST:event_chkSTHexAItemStateChanged

    private void chkSTHexBItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkSTHexBItemStateChanged
       new GLFunctions().HexBoxs(pnlKeyB,"txtSTKeyB",chkSTHexB);   
       new GLFunctions(). HEXBOX=chkSTHexB;
       new GLFunctions().TEXTFIELD="txtSTKeyB";
    }//GEN-LAST:event_chkSTHexBItemStateChanged

    private void btnWriteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnWriteActionPerformed
       frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B); 
         
          byte  bAddressingMode          = 0,
                bBlockOrSectorAddress    = 0,
                bBlockAccessBits0        = 0,
                bBlockAccessBits1        = 0,
                bBlockAccessBits2        = 0,
                bSectorTrailerAccessBits = 0,
                bSectorTrailerByte9      = 0;
         
         byte  bKeyIndex                 = (byte)cboKeyIndex.getSelectedIndex();
         
           if (txtBlockOrSectorAddress.getText().trim().isEmpty())
           {
               JOptionPane.showMessageDialog(rootPane, "You must enter BLOCK OR SECTOR ADDRESS !", "Warning !", JOptionPane.WARNING_MESSAGE);
               txtBlockOrSectorAddress.requestFocus();
               return;
           }
             if (txtTrailerByte9.getText().trim().isEmpty())
           {
               JOptionPane.showMessageDialog(rootPane, "You must enter TRAILER BYTE 9 !", "Warning !", JOptionPane.WARNING_MESSAGE);
               txtTrailerByte9.requestFocus();
               return;
           }
           
           bAddressingMode=(byte)cboAddressingMode.getSelectedIndex();
           bBlockOrSectorAddress=Byte.parseByte(txtBlockOrSectorAddress.getText().trim());
           bBlockAccessBits0=(byte)cboAccessBits0.getSelectedIndex();
           bBlockAccessBits1=(byte)cboAccessBits1.getSelectedIndex();
           bBlockAccessBits2=(byte)cboAccessBits2.getSelectedIndex();
           bSectorTrailerAccessBits=(byte)cboTrailerAccessBits.getSelectedIndex();
           bSectorTrailerByte9=Byte.parseByte(txtTrailerByte9.getText().trim());
           
           iFResult=Declarations.uFrFunctions.uFrInstance.SectorTrailerWrite(bAddressingMode, bBlockOrSectorAddress, 
                   new GLFunctions().KEY(pnlKeyA,"txtSTKeyA",chkSTHexA),bBlockAccessBits0, bBlockAccessBits1, 
                   bBlockAccessBits2,bSectorTrailerAccessBits, bSectorTrailerByte9,
                   new GLFunctions().KEY(pnlKeyB,"txtSTKeyB",chkSTHexB),bAuthMode, bKeyIndex);
          
         if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
    }//GEN-LAST:event_btnWriteActionPerformed

    private void btnWriteAKM1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnWriteAKM1ActionPerformed
        frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B); 
         
          byte  bAddressingMode          = 0,
                bBlockOrSectorAddress    = 0,
                bBlockAccessBits0        = 0,
                bBlockAccessBits1        = 0,
                bBlockAccessBits2        = 0,
                bSectorTrailerAccessBits = 0,
                bSectorTrailerByte9      = 0;
          
           if (txtBlockOrSectorAddressAKM1.getText().trim().isEmpty())
           {
               JOptionPane.showMessageDialog(rootPane, "You must enter BLOCK OR SECTOR ADDRESS !", "Warning !", JOptionPane.WARNING_MESSAGE);
               txtBlockOrSectorAddressAKM1.requestFocus();
               return;
           }
             if (txtTrailerByte9AKM1.getText().trim().isEmpty())
           {
               JOptionPane.showMessageDialog(rootPane, "You must enter TRAILER BYTE 9 !", "Warning !", JOptionPane.WARNING_MESSAGE);
               txtTrailerByte9AKM1.requestFocus();
               return;
           }
           
           bAddressingMode=(byte)cboAddressingModeAKM1.getSelectedIndex();
           bBlockOrSectorAddress=Byte.parseByte(txtBlockOrSectorAddressAKM1.getText().trim());
           bBlockAccessBits0=(byte)cboAccessBits0AKM1.getSelectedIndex();
           bBlockAccessBits1=(byte)cboAccessBits1AKM1.getSelectedIndex();
           bBlockAccessBits2=(byte)cboAccessBits2AKM1.getSelectedIndex();
           bSectorTrailerAccessBits=(byte)cboTrailerAccessBitsAKM1.getSelectedIndex();
           bSectorTrailerByte9=Byte.parseByte(txtTrailerByte9AKM1.getText().trim());
           
           iFResult=Declarations.uFrFunctions.uFrInstance.SectorTrailerWrite_AKM1(bAddressingMode, bBlockOrSectorAddress, 
                   new GLFunctions().KEY(pnlKeyA,"txtSTKeyA",chkSTHexA),bBlockAccessBits0, bBlockAccessBits1,
                   bBlockAccessBits2,bSectorTrailerAccessBits, bSectorTrailerByte9,
                   new GLFunctions().KEY(pnlKeyB,"txtSTKeyB",chkSTHexB),bAuthMode);
          
           if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
    }//GEN-LAST:event_btnWriteAKM1ActionPerformed

    private void btnWriteAKM2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnWriteAKM2ActionPerformed
       frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B); 
         
          byte  bAddressingMode          = 0,
                bBlockOrSectorAddress    = 0,
                bBlockAccessBits0        = 0,
                bBlockAccessBits1        = 0,
                bBlockAccessBits2        = 0,
                bSectorTrailerAccessBits = 0,
                bSectorTrailerByte9      = 0;
          
           if (txtBlockOrSectorAddressAKM2.getText().trim().isEmpty())
           {
               JOptionPane.showMessageDialog(rootPane, "You must enter BLOCK OR SECTOR ADDRESS !", "Warning !", JOptionPane.WARNING_MESSAGE);
               txtBlockOrSectorAddressAKM2.requestFocus();
               return;
           }
             if (txtTrailerByte9AKM2.getText().trim().isEmpty())
           {
               JOptionPane.showMessageDialog(rootPane, "You must enter TRAILER BYTE 9 !", "Warning !", JOptionPane.WARNING_MESSAGE);
               txtTrailerByte9AKM2.requestFocus();
               return;
           }
           
           bAddressingMode=(byte)cboAddressingModeAKM2.getSelectedIndex();
           bBlockOrSectorAddress=Byte.parseByte(txtBlockOrSectorAddressAKM2.getText().trim());
           bBlockAccessBits0=(byte)cboAccessBits0AKM2.getSelectedIndex();
           bBlockAccessBits1=(byte)cboAccessBits1AKM2.getSelectedIndex();
           bBlockAccessBits2=(byte)cboAccessBits2AKM2.getSelectedIndex();
           bSectorTrailerAccessBits=(byte)cboTrailerAccessBitsAKM2.getSelectedIndex();
           bSectorTrailerByte9=Byte.parseByte(txtTrailerByte9AKM2.getText().trim());
           
           iFResult=Declarations.uFrFunctions.uFrInstance.SectorTrailerWrite_AKM2(bAddressingMode, bBlockOrSectorAddress, 
                   new GLFunctions().KEY(pnlKeyA,"txtSTKeyA",chkSTHexA),bBlockAccessBits0, bBlockAccessBits1, 
                   bBlockAccessBits2,bSectorTrailerAccessBits, bSectorTrailerByte9,
                   new GLFunctions().KEY(pnlKeyB,"txtSTKeyB",chkSTHexB),bAuthMode);
                                                                                                                                                          
         if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
    }//GEN-LAST:event_btnWriteAKM2ActionPerformed

    private void btnWritePKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnWritePKActionPerformed
       frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B); 
         
          byte  bAddressingMode          = 0,
                bBlockOrSectorAddress    = 0,
                bBlockAccessBits0        = 0,
                bBlockAccessBits1        = 0,
                bBlockAccessBits2        = 0,
                bSectorTrailerAccessBits = 0,
                bSectorTrailerByte9      = 0;
          
           if (txtBlockOrSectorAddressPK.getText().trim().isEmpty())
           {
               JOptionPane.showMessageDialog(rootPane, "You must enter BLOCK OR SECTOR ADDRESS !", "Warning !", JOptionPane.WARNING_MESSAGE);
               txtBlockOrSectorAddressPK.requestFocus();
               return;
           }
             if (txtTrailerByte9PK.getText().trim().isEmpty())
           {
               JOptionPane.showMessageDialog(rootPane, "You must enter TRAILER BYTE 9 !", "Warning !", JOptionPane.WARNING_MESSAGE);
               txtTrailerByte9PK.requestFocus();
               return;
           }
           
           bAddressingMode=(byte)cboAddressingModePK.getSelectedIndex();
           bBlockOrSectorAddress=Byte.parseByte(txtBlockOrSectorAddressPK.getText().trim());
           bBlockAccessBits0=(byte)cboAccessBits0PK.getSelectedIndex();
           bBlockAccessBits1=(byte)cboAccessBits1PK.getSelectedIndex();
           bBlockAccessBits2=(byte)cboAccessBits2PK.getSelectedIndex();
           bSectorTrailerAccessBits=(byte)cboTrailerAccessBitsPK.getSelectedIndex();
           bSectorTrailerByte9=Byte.parseByte(txtTrailerByte9PK.getText().trim());
           
           iFResult=Declarations.uFrFunctions.uFrInstance.SectorTrailerWrite_PK(bAddressingMode, bBlockOrSectorAddress, 
                   new GLFunctions().KEY(pnlKeyA,"txtSTKeyA",chkSTHexA),bBlockAccessBits0, bBlockAccessBits1, 
                   bBlockAccessBits2,bSectorTrailerAccessBits, bSectorTrailerByte9,
                   new GLFunctions().KEY(pnlKeyB,"txtSTKeyB",chkSTHexB),bAuthMode,new GLFunctions().PK_KEY(pnlPKKey));
                                                                         
                                                                         
        
         if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
    }//GEN-LAST:event_btnWritePKActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnWrite;
    private javax.swing.JButton btnWriteAKM1;
    private javax.swing.JButton btnWriteAKM2;
    private javax.swing.JButton btnWritePK;
    private javax.swing.JComboBox cboAccessBits0;
    private javax.swing.JComboBox cboAccessBits0AKM1;
    private javax.swing.JComboBox cboAccessBits0AKM2;
    private javax.swing.JComboBox cboAccessBits0PK;
    private javax.swing.JComboBox cboAccessBits1;
    private javax.swing.JComboBox cboAccessBits1AKM1;
    private javax.swing.JComboBox cboAccessBits1AKM2;
    private javax.swing.JComboBox cboAccessBits1PK;
    private javax.swing.JComboBox cboAccessBits2;
    private javax.swing.JComboBox cboAccessBits2AKM1;
    private javax.swing.JComboBox cboAccessBits2AKM2;
    private javax.swing.JComboBox cboAccessBits2PK;
    private javax.swing.JComboBox cboAddressingMode;
    private javax.swing.JComboBox cboAddressingModeAKM1;
    private javax.swing.JComboBox cboAddressingModeAKM2;
    private javax.swing.JComboBox cboAddressingModePK;
    private javax.swing.JComboBox cboKeyIndex;
    private javax.swing.JComboBox cboTrailerAccessBits;
    private javax.swing.JComboBox cboTrailerAccessBitsAKM1;
    private javax.swing.JComboBox cboTrailerAccessBitsAKM2;
    private javax.swing.JComboBox cboTrailerAccessBitsPK;
    private javax.swing.JCheckBox chkSTHexA;
    private javax.swing.JCheckBox chkSTHexB;
    private javax.swing.JLabel lblAccessBits0;
    private javax.swing.JLabel lblAccessBits0AKM1;
    private javax.swing.JLabel lblAccessBits0AKM2;
    private javax.swing.JLabel lblAccessBits0PK;
    private javax.swing.JLabel lblAccessBits1;
    private javax.swing.JLabel lblAccessBits1AKM1;
    private javax.swing.JLabel lblAccessBits1AKM2;
    private javax.swing.JLabel lblAccessBits1PK;
    private javax.swing.JLabel lblAccessBits2;
    private javax.swing.JLabel lblAccessBits2AKM1;
    private javax.swing.JLabel lblAccessBits2AKM2;
    private javax.swing.JLabel lblAccessBits2PK;
    private javax.swing.JLabel lblAddressingMode;
    private javax.swing.JLabel lblAddressingModeAKM1;
    private javax.swing.JLabel lblAddressingModeAKM2;
    private javax.swing.JLabel lblAddressingModePK;
    private javax.swing.JLabel lblBlockOrSectorAddress;
    private javax.swing.JLabel lblBlockOrSectorAddressAKM1;
    private javax.swing.JLabel lblBlockOrSectorAddressAKM2;
    private javax.swing.JLabel lblBlockOrSectorAddressPK;
    private javax.swing.JLabel lblKeyA;
    private javax.swing.JLabel lblKeyB;
    private javax.swing.JLabel lblKeyIndex;
    private javax.swing.JLabel lblPKKey;
    private javax.swing.JLabel lblTrailerAccessBits;
    private javax.swing.JLabel lblTrailerAccessBitsAKM1;
    private javax.swing.JLabel lblTrailerAccessBitsAKM2;
    private javax.swing.JLabel lblTrailerAccessBitsPK;
    private javax.swing.JLabel lblTrailerByte9;
    private javax.swing.JLabel lblTrailerByte9AKM1;
    private javax.swing.JLabel lblTrailerByte9AKM2;
    private javax.swing.JLabel lblTrailerByte9PK;
    private javax.swing.JPanel pnlKeyA;
    private javax.swing.JPanel pnlKeyB;
    private javax.swing.JPanel pnlPKKey;
    private javax.swing.JRadioButton rbAUTH1A;
    private javax.swing.JRadioButton rbAUTH1B;
    private javax.swing.ButtonGroup rbtnRadioButton;
    private javax.swing.JPanel tabSectorTrailer;
    private javax.swing.JPanel tabSectorTrailerAKM1;
    private javax.swing.JPanel tabSectorTrailerAKM2;
    private javax.swing.JPanel tabSectorTrailerPK;
    private javax.swing.JTabbedPane tabSectorTrailerWrite;
    private javax.swing.JTextField txtBlockOrSectorAddress;
    private javax.swing.JTextField txtBlockOrSectorAddressAKM1;
    private javax.swing.JTextField txtBlockOrSectorAddressAKM2;
    private javax.swing.JTextField txtBlockOrSectorAddressPK;
    private javax.swing.JTextField txtFErrorCode;
    private javax.swing.JTextField txtFErrorExplain;
    private javax.swing.JTextField txtFunctionStatus;
    private javax.swing.JTextField txtTrailerByte9;
    private javax.swing.JTextField txtTrailerByte9AKM1;
    private javax.swing.JTextField txtTrailerByte9AKM2;
    private javax.swing.JTextField txtTrailerByte9PK;
    // End of variables declaration//GEN-END:variables

}
