/**
 * @autor   D-Logic Team
 * @version 2.1
 */



package ufcoderadvancedapplet;


import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.ptr.IntByReference;
import java.awt.Color;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

class Provere{
    private boolean HEX=false;
    public void SetHexValue(boolean hex_true_false)
    {
       this.HEX=hex_true_false;
    }
    public boolean GetHexValue(){
        return HEX;
    }
}


public class frmuFrAdvancedApplet extends javax.swing.JApplet implements KeyListener,FocusListener
{

    
    
    
static final int 
         FUNCT_LIGHT_OK     = 4,
         FUNCT_SOUND_OK     = 0,//4 Tripple sound
         FUNCT_LIGHT_ERROR  = 2,
         FUNCT_SOUND_ERROR  = 0,//2 Long sound
         DL_OK              = 0,
         SLEEP_VALUE        = 800;

    boolean boCONN  = false;
    public boolean bFunctionStart,bLoopStart;
    static byte bTypeOfCard  ;
   
    ExecutorService exec = Executors.newCachedThreadPool();
    
    
    static String[] iaErrorCodes = new String[200];
    
    Declarations.DLCARDTYPE   DCT;
    Declarations.ERRORCODES   EC;
    Declarations.ERRORCODES[] ERRCODES = Declarations.ERRORCODES.values();
    
    private void FillEcArray(){        
        for (Declarations.ERRORCODES ECC : EC.values()) {               
               iaErrorCodes[ECC.getValue()]=ECC.name();               
            }
    }
  
   public void SetStatusBar(JTextField txtErrorCode, JTextField txtErrorExplain, int iResultValue) {
        
                txtErrorCode   .setText("0x" + Integer.toHexString(iResultValue).toUpperCase());
                txtErrorExplain.setText(iaErrorCodes[iResultValue]);           
    }
                    
   public void SetFunct(boolean bValue){
          bFunctionStart=bValue;            
   }  
   public boolean GetFunct(){
       return bFunctionStart;          
}   
  
   public void SetLoop(boolean bValue){
       bLoopStart = bValue;
   }
   public boolean GetLoop(){
       return bLoopStart;
   }

private JTextField textfield;
Provere P=new Provere();

     public void CreateTextBox(JPanel pnlContainer,int textfield_width,int textfield_height,
                            int textfield_top,int textfield_left,String textfield_name )
    {
           JTextField textfield;
           for(int br=0;br<6;br++)
           {
                        textfield=new JTextField();
                        textfield.setBounds(textfield_left+(textfield_width*br+2),textfield_top,textfield_width,textfield_height);
                        textfield.setBorder(javax.swing.BorderFactory.createLineBorder(Color.BLACK));
                        textfield.setName(textfield_name);
                        textfield.setHorizontalAlignment(javax.swing.JTextField.CENTER);
                        textfield.setFont(new java.awt.Font("Verdana",1,11));                        
                        textfield.addFocusListener(this);
                        textfield.addKeyListener(this);                    
                        textfield.setText("255");                        
                        textfield.setEditable(true);                        
                        textfield.setVisible(true);
                        pnlContainer.add(textfield);
           }
           pnlContainer.repaint();
    }
    
      public void CreatePKBox(JPanel pnlContainer,int txtTextField_width,int txtTextField_height,
                            int txtTextField_top,int txtTextField_left,String txtTextField_name )
    {
           JTextField txtTextField;
           for(int br=0;br<6;br++)
           {
                        txtTextField=new JTextField();
                        txtTextField.setBounds(txtTextField_left+(txtTextField_width*br+2),txtTextField_top,txtTextField_width,txtTextField_height);
                        txtTextField.setBorder(javax.swing.BorderFactory.createLineBorder(Color.BLACK));
                        txtTextField.setName(txtTextField_name);
                        txtTextField.setHorizontalAlignment(javax.swing.JTextField.CENTER);
                        txtTextField.setFont(new java.awt.Font("Verdana",1,11)); 
                        txtTextField.addFocusListener(this);
                        txtTextField.addKeyListener(this);
                        txtTextField.setText("255");
                        txtTextField.setVisible(true);
                        pnlContainer.add(txtTextField);
           }
           pnlContainer.repaint();
    }
      


    @Override
    public void keyTyped(KeyEvent e) {
        
        }
    
    @Override
    public void keyPressed(KeyEvent e) {
       
    }

    @Override
    public void keyReleased(KeyEvent e) {
        
    }

    @Override
    public void focusGained(FocusEvent e) {
        
    }

    @Override
    public void focusLost(FocusEvent e) {
    
    }
  
class MainLoopThread extends Thread {
    
   byte[]  baReadUserData       =new byte[16];

   IntByReference iReaderType   = new IntByReference();
   IntByReference iReaderSerial = new IntByReference();
   ByteByReference bDLCardType  = new ByteByReference();
   ByteByReference bCardType    = new ByteByReference();
   ByteByReference bCardUIDSize = new ByteByReference();
   IntByReference  iCardSerial  = new IntByReference();    
   byte[]  baCardUID            = new byte[9];
   int     iRResult ;
   int     iCResult ;
    
   
    private  void MainLoop()
    {
       SetLoop(true);
       String sBuffer = ""; 
        if (!boCONN) {
            if ((iRResult = Declarations.uFrFunctions.uFrInstance.ReaderOpen()) == DL_OK) {
                 boCONN   = true;
                 txtConnected.setText("CONNECTED");
                 SetStatusBar(txtRErrorCode, txtRErrorExplain, iRResult);                                
            } else {
                 txtConnected   .setText("NOT CONNECTED");
                 txtReaderType  .setText(null);
                 txtReaderSerial.setText(null);
                 txtCardType    .setText(null);
                 txtCardSerial  .setText(null);
                 txtCardUIDSize .setText(null);
                 SetStatusBar(txtRErrorCode, txtRErrorExplain, iRResult);
            }
        }
        if (boCONN) 
        {
            iRResult = Declarations.uFrFunctions.uFrInstance.GetReaderType(iReaderType);
            if (iRResult == DL_OK) 
            {
                txtReaderType.setText("0x" + Integer.toHexString(iReaderType.getValue()).toUpperCase());
                iRResult = Declarations.uFrFunctions.uFrInstance.GetReaderSerialNumber(iReaderSerial);
                if (iRResult == DL_OK) 
                {
                     txtReaderSerial.setText("0x" + Integer.toHexString(iReaderSerial.getValue()).toUpperCase());
                     SetStatusBar(txtRErrorCode, txtRErrorExplain, iRResult);
                         
                         iCResult = Declarations.uFrFunctions.uFrInstance.GetDlogicCardType(bDLCardType);
                         if (iCResult  == DL_OK) 
                         {
                              if (bDLCardType.getValue()<=0x0A)
                                 SetMeniEnabled(false);
                              else
                                  SetMeniEnabled(true);
                                  
                              Declarations.uFrFunctions.uFrInstance.GetCardIdEx(bCardType,baCardUID,bCardUIDSize);
                              for (byte bCount = 0; bCount < bCardUIDSize.getValue(); ++bCount) {
                                   sBuffer += Integer.toHexString((((char) baCardUID[bCount] & 0xFF))); 
                              }
                              txtCardType   .setText("0x" + Integer.toHexString(bDLCardType.getValue()));
                              txtCardSerial .setText("0x" + sBuffer.toUpperCase());
                              txtCardUIDSize.setText("0x" + Integer.toHexString(bCardUIDSize.getValue()).toUpperCase()); 
                              bTypeOfCard  = bDLCardType.getValue();
                              SetStatusBar(txtCErrorCode, txtCErrorExplain, iCResult);
                           } else {                                  
                                   txtCardType   .setText(null);
                                   txtCardSerial .setText(null);
                                   txtCardUIDSize.setText(null);
                                   bTypeOfCard  = bDLCardType.getValue();
                                   SetMeniEnabled(true);
                                   SetStatusBar(txtCErrorCode, txtCErrorExplain, iCResult);
                                  }
                } 
            } else {
                     Declarations.uFrFunctions.uFrInstance.ReaderClose();
                     SetMeniEnabled(true);
                     boCONN = false;
                   }            
                   
            if ((iRResult = Declarations.uFrFunctions.uFrInstance.ReadUserData(baReadUserData)) == DL_OK)                
                            txtUserData.setText(new String(baReadUserData));            
        }        
        SetLoop(false);        
    }

        private void SetMeniEnabled(boolean isEnable) {
            mnuBlockInSectorReadWrite.setEnabled(isEnable);
            mnuLinearFormatCard.setEnabled(isEnable);
            mnuSectorTrailerWrite.setEnabled(isEnable);
            mnuValueBlockInSectorIncrDecr.setEnabled(isEnable);
            mnuValueBlockInSectorReadWrite.setEnabled(isEnable);
            mnuValueBlockIncrDecr.setEnabled(isEnable);
            mnuValueBlockReadWrite.setEnabled(isEnable);
        }
    
            @Override
            public void run() {
                try {
                    while (!Thread.interrupted()) { 
                        if (!GetFunct())  
                          { 
                              MainLoop(); 
                          }                                                                                                                                                                                                                       
                            TimeUnit.MILLISECONDS.sleep(SLEEP_VALUE);                            
                    }
                } catch (InterruptedException InEx) {
                    Logger.getLogger(frmuFrAdvancedApplet.class.getName()).log(Level.SEVERE, null, InEx);
                }
            }
        }
   
    @Override
    public void init()
    {
       try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Windows".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(frmuFrAdvancedApplet.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(frmuFrAdvancedApplet.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(frmuFrAdvancedApplet.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(frmuFrAdvancedApplet.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        try {
            java.awt.EventQueue.invokeAndWait(new Runnable() {

                @Override
                public void run() {
                    initComponents();
                   
                }
            });
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        
    }
    
    @Override
    public void start(){
         FillEcArray();        
         new GLFunctions().CreateTextBox(tabReaderKey, 30, 18,10,55, "txtReaderKey");                    
         new GLFunctions().AddFrame(new frmLinearReadWrite(), pnlDesktopPanel,lblHeader,"Linear Read/Write (AKM1,AKM2,PK)");
         //exec.execute(new MainLoopThread());
         
         MainLoopThread ml = new MainLoopThread();
                        ml.setPriority(Thread.NORM_PRIORITY);                        
                        exec.execute(ml);
    }
    @Override
    public void stop()
                {
                    exec.shutdownNow();                    
                }
    
    public void close(){
        System.exit(0);
    }
    
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSeparator1 = new javax.swing.JSeparator();
        jSeparator3 = new javax.swing.JSeparator();
        jSeparator4 = new javax.swing.JSeparator();
        jSeparator5 = new javax.swing.JSeparator();
        jSeparator6 = new javax.swing.JSeparator();
        pnlReaderType = new javax.swing.JPanel();
        lblReaderType = new javax.swing.JLabel();
        txtReaderType = new javax.swing.JTextField();
        lblReaderSerial = new javax.swing.JLabel();
        txtReaderSerial = new javax.swing.JTextField();
        lblCardType = new javax.swing.JLabel();
        txtCardType = new javax.swing.JTextField();
        lblCardSerial = new javax.swing.JLabel();
        txtCardSerial = new javax.swing.JTextField();
        lblLightMode = new javax.swing.JLabel();
        cboLightMode = new javax.swing.JComboBox();
        cboSoundMode = new javax.swing.JComboBox();
        lblSoundMode = new javax.swing.JLabel();
        btnReaderUISignal = new javax.swing.JButton();
        btnSoftRestart = new javax.swing.JButton();
        btnReaderReset = new javax.swing.JButton();
        pgUserData = new javax.swing.JTabbedPane();
        tabReaderKey = new javax.swing.JPanel();
        chkReaderKey = new javax.swing.JCheckBox();
        cboKeyIndex = new javax.swing.JComboBox();
        btnSaveKeyIndex = new javax.swing.JButton();
        lblKeyIndex1 = new javax.swing.JLabel();
        tabUserData = new javax.swing.JPanel();
        lblUserData = new javax.swing.JLabel();
        txtUserData = new javax.swing.JTextField();
        lblNewUserData = new javax.swing.JLabel();
        txtNewUserData = new javax.swing.JTextField();
        btnSaveUserData = new javax.swing.JButton();
        lblCardUIDSize = new javax.swing.JLabel();
        txtCardUIDSize = new javax.swing.JTextField();
        txtRErrorExplain = new javax.swing.JTextField();
        txtConnected = new javax.swing.JTextField();
        txtRErrorCode = new javax.swing.JTextField();
        jSeparator2 = new javax.swing.JSeparator();
        pnlDesktopPanel = new javax.swing.JDesktopPane();
        lblHeader = new javax.swing.JLabel();
        txtCardStatus = new javax.swing.JTextField();
        txtCErrorCode = new javax.swing.JTextField();
        txtCErrorExplain = new javax.swing.JTextField();
        mnuMeni = new javax.swing.JMenuBar();
        mnuFunctions = new javax.swing.JMenu();
        mnuLinearReadWriteItems = new javax.swing.JMenuItem();
        separ1 = new javax.swing.JPopupMenu.Separator();
        mnuBlockReadWrite = new javax.swing.JMenuItem();
        mnuBlockInSectorReadWrite = new javax.swing.JMenuItem();
        separ2 = new javax.swing.JPopupMenu.Separator();
        mnuValueBlockReadWrite = new javax.swing.JMenuItem();
        mnuValueBlockIncrDecr = new javax.swing.JMenuItem();
        separ3 = new javax.swing.JPopupMenu.Separator();
        mnuValueBlockInSectorReadWrite = new javax.swing.JMenuItem();
        mnuValueBlockInSectorIncrDecr = new javax.swing.JMenuItem();
        separ4 = new javax.swing.JPopupMenu.Separator();
        mnuSectorTrailerWrite = new javax.swing.JMenuItem();
        mnuLinearFormatCard = new javax.swing.JMenuItem();
        jSeparator7 = new javax.swing.JPopupMenu.Separator();
        mnuReaderHardFirmwareVersionItem = new javax.swing.JMenuItem();
        separ5 = new javax.swing.JPopupMenu.Separator();
        mnuViewAll = new javax.swing.JMenuItem();
        mnuExitItem = new javax.swing.JMenuItem();

        setPreferredSize(new java.awt.Dimension(599, 845));
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlReaderType.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlReaderType.setAlignmentX(2.0F);
        pnlReaderType.setAlignmentY(2.0F);
        pnlReaderType.setPreferredSize(new java.awt.Dimension(618, 299));
        pnlReaderType.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        lblReaderType.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblReaderType.setText("Reader Type");
        pnlReaderType.add(lblReaderType, new org.netbeans.lib.awtextra.AbsoluteConstraints(61, 14, 98, -1));

        txtReaderType.setEditable(false);
        txtReaderType.setBackground(new java.awt.Color(255, 255, 255));
        txtReaderType.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtReaderType.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        pnlReaderType.add(txtReaderType, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 10, 110, -1));

        lblReaderSerial.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblReaderSerial.setText("Reader Serial");
        pnlReaderType.add(lblReaderSerial, new org.netbeans.lib.awtextra.AbsoluteConstraints(60, 37, 98, -1));

        txtReaderSerial.setEditable(false);
        txtReaderSerial.setBackground(new java.awt.Color(255, 255, 255));
        txtReaderSerial.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtReaderSerial.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        pnlReaderType.add(txtReaderSerial, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 33, 110, -1));

        lblCardType.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblCardType.setText("Card Type");
        pnlReaderType.add(lblCardType, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 14, 79, -1));

        txtCardType.setEditable(false);
        txtCardType.setBackground(new java.awt.Color(255, 255, 255));
        txtCardType.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtCardType.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        pnlReaderType.add(txtCardType, new org.netbeans.lib.awtextra.AbsoluteConstraints(420, 10, 40, -1));

        lblCardSerial.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblCardSerial.setText("Card Serial");
        pnlReaderType.add(lblCardSerial, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 37, 79, -1));

        txtCardSerial.setEditable(false);
        txtCardSerial.setBackground(new java.awt.Color(255, 255, 255));
        txtCardSerial.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtCardSerial.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        pnlReaderType.add(txtCardSerial, new org.netbeans.lib.awtextra.AbsoluteConstraints(420, 33, 140, -1));

        lblLightMode.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblLightMode.setText("Light Mode");
        pnlReaderType.add(lblLightMode, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 87, 79, -1));

        cboLightMode.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboLightMode.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "None", "Long Green", "Long Red", "Alternation", "Flash" }));
        pnlReaderType.add(cboLightMode, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 84, 129, -1));

        cboSoundMode.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        cboSoundMode.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "None", "Short", "Long", "Double Short", "Tripple Short", "Tripplet Melody" }));
        cboSoundMode.setOpaque(false);
        pnlReaderType.add(cboSoundMode, new org.netbeans.lib.awtextra.AbsoluteConstraints(113, 111, 129, -1));

        lblSoundMode.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSoundMode.setText("Sound Mode");
        pnlReaderType.add(lblSoundMode, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 114, 79, -1));

        btnReaderUISignal.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        btnReaderUISignal.setText("Reader UI Signal");
        btnReaderUISignal.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnReaderUISignal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnReaderUISignalActionPerformed(evt);
            }
        });
        pnlReaderType.add(btnReaderUISignal, new org.netbeans.lib.awtextra.AbsoluteConstraints(280, 80, -1, 50));

        btnSoftRestart.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        btnSoftRestart.setText("Soft Restart");
        btnSoftRestart.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnSoftRestart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSoftRestartActionPerformed(evt);
            }
        });
        pnlReaderType.add(btnSoftRestart, new org.netbeans.lib.awtextra.AbsoluteConstraints(460, 80, 110, 27));

        btnReaderReset.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        btnReaderReset.setText("Reader Reset");
        btnReaderReset.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnReaderReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnReaderResetActionPerformed(evt);
            }
        });
        pnlReaderType.add(btnReaderReset, new org.netbeans.lib.awtextra.AbsoluteConstraints(460, 110, 110, 29));

        tabReaderKey.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        chkReaderKey.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        chkReaderKey.setText("Hex");
        chkReaderKey.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        chkReaderKey.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkReaderKeyItemStateChanged(evt);
            }
        });

        cboKeyIndex.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        cboKeyIndex.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", " " }));
        cboKeyIndex.setToolTipText("Choise key index");
        cboKeyIndex.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        btnSaveKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        btnSaveKeyIndex.setText("Save Key");
        btnSaveKeyIndex.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnSaveKeyIndex.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveKeyIndexActionPerformed(evt);
            }
        });

        lblKeyIndex1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblKeyIndex1.setText("Key Index");

        javax.swing.GroupLayout tabReaderKeyLayout = new javax.swing.GroupLayout(tabReaderKey);
        tabReaderKey.setLayout(tabReaderKeyLayout);
        tabReaderKeyLayout.setHorizontalGroup(
            tabReaderKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(tabReaderKeyLayout.createSequentialGroup()
                .addGap(50, 50, 50)
                .addComponent(chkReaderKey)
                .addGap(242, 242, 242)
                .addGroup(tabReaderKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblKeyIndex1)
                    .addGroup(tabReaderKeyLayout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(21, 21, 21)
                .addComponent(btnSaveKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        tabReaderKeyLayout.setVerticalGroup(
            tabReaderKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(tabReaderKeyLayout.createSequentialGroup()
                .addGap(36, 36, 36)
                .addComponent(chkReaderKey))
            .addGroup(tabReaderKeyLayout.createSequentialGroup()
                .addComponent(lblKeyIndex1)
                .addGap(5, 5, 5)
                .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(tabReaderKeyLayout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(btnSaveKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pgUserData.addTab("Reader Key", tabReaderKey);

        tabUserData.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabUserData.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        lblUserData.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblUserData.setText("User Data");
        tabUserData.add(lblUserData, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 10, -1, -1));

        txtUserData.setEditable(false);
        txtUserData.setBackground(new java.awt.Color(204, 204, 204));
        txtUserData.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        txtUserData.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tabUserData.add(txtUserData, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 30, 130, -1));

        lblNewUserData.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblNewUserData.setText("New User Data");
        tabUserData.add(lblNewUserData, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 10, -1, -1));

        txtNewUserData.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        txtNewUserData.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tabUserData.add(txtNewUserData, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 30, 130, -1));

        btnSaveUserData.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        btnSaveUserData.setText("Save User Data");
        btnSaveUserData.setToolTipText("");
        btnSaveUserData.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnSaveUserData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveUserDataActionPerformed(evt);
            }
        });
        tabUserData.add(btnSaveUserData, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 10, 130, 35));

        pgUserData.addTab("User Data", tabUserData);

        pnlReaderType.add(pgUserData, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 150, 560, -1));

        lblCardUIDSize.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblCardUIDSize.setText("UIDS");
        lblCardUIDSize.setToolTipText("");
        pnlReaderType.add(lblCardUIDSize, new org.netbeans.lib.awtextra.AbsoluteConstraints(479, 14, 30, -1));

        txtCardUIDSize.setEditable(false);
        txtCardUIDSize.setBackground(new java.awt.Color(255, 255, 255));
        txtCardUIDSize.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtCardUIDSize.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtCardUIDSize.setToolTipText("Card UID Size");
        pnlReaderType.add(txtCardUIDSize, new org.netbeans.lib.awtextra.AbsoluteConstraints(520, 10, 40, -1));

        txtRErrorExplain.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtRErrorExplain.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        pnlReaderType.add(txtRErrorExplain, new org.netbeans.lib.awtextra.AbsoluteConstraints(220, 240, 370, -1));

        txtConnected.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtConnected.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        pnlReaderType.add(txtConnected, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 240, 140, -1));

        txtRErrorCode.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtRErrorCode.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        pnlReaderType.add(txtRErrorCode, new org.netbeans.lib.awtextra.AbsoluteConstraints(150, 240, 70, -1));

        jSeparator2.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        pnlReaderType.add(jSeparator2, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 65, 540, -1));

        getContentPane().add(pnlReaderType, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 600, 270));

        pnlDesktopPanel.setBackground(new java.awt.Color(153, 153, 153));
        pnlDesktopPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlDesktopPanel.setAutoscrolls(true);
        pnlDesktopPanel.setPreferredSize(new java.awt.Dimension(572, 450));

        lblHeader.setBackground(java.awt.Color.lightGray);
        lblHeader.setFont(new java.awt.Font("Verdana", 1, 17)); // NOI18N
        lblHeader.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblHeader.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblHeader.setOpaque(true);
        pnlDesktopPanel.add(lblHeader);
        lblHeader.setBounds(0, 0, 599, 28);
        pnlDesktopPanel.setLayer(lblHeader, javax.swing.JLayeredPane.MODAL_LAYER);

        getContentPane().add(pnlDesktopPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 270, 600, 450));

        txtCardStatus.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtCardStatus.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtCardStatus.setText("CARD STATUS");
        getContentPane().add(txtCardStatus, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 720, 150, -1));

        txtCErrorCode.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtCErrorCode.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtCErrorCode, new org.netbeans.lib.awtextra.AbsoluteConstraints(150, 720, 70, -1));

        txtCErrorExplain.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtCErrorExplain.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtCErrorExplain, new org.netbeans.lib.awtextra.AbsoluteConstraints(220, 720, 380, -1));

        mnuMeni.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));
        mnuMeni.setFont(new java.awt.Font("Verdana", 0, 12)); // NOI18N

        mnuFunctions.setText("Functions");
        mnuFunctions.setFont(new java.awt.Font("Verdana", 0, 12)); // NOI18N

        mnuLinearReadWriteItems.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        mnuLinearReadWriteItems.setText("Linear Read/Write");
        mnuLinearReadWriteItems.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuLinearReadWriteItemsActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuLinearReadWriteItems);
        mnuFunctions.add(separ1);

        mnuBlockReadWrite.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        mnuBlockReadWrite.setText("Block Read/Write");
        mnuBlockReadWrite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuBlockReadWriteActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuBlockReadWrite);

        mnuBlockInSectorReadWrite.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        mnuBlockInSectorReadWrite.setText("BlockInSector Read/Write");
        mnuBlockInSectorReadWrite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuBlockInSectorReadWriteActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuBlockInSectorReadWrite);
        mnuFunctions.add(separ2);

        mnuValueBlockReadWrite.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        mnuValueBlockReadWrite.setText("ValueBlock Read/Write");
        mnuValueBlockReadWrite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuValueBlockReadWriteActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuValueBlockReadWrite);

        mnuValueBlockIncrDecr.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        mnuValueBlockIncrDecr.setText("ValueBlock Increment/Decrement");
        mnuValueBlockIncrDecr.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuValueBlockIncrDecrActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuValueBlockIncrDecr);
        mnuFunctions.add(separ3);

        mnuValueBlockInSectorReadWrite.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        mnuValueBlockInSectorReadWrite.setText("ValueBlockInSector Read/Write");
        mnuValueBlockInSectorReadWrite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuValueBlockInSectorReadWriteActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuValueBlockInSectorReadWrite);

        mnuValueBlockInSectorIncrDecr.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        mnuValueBlockInSectorIncrDecr.setText("ValueBlockInSector Increment/Decrement");
        mnuValueBlockInSectorIncrDecr.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuValueBlockInSectorIncrDecrActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuValueBlockInSectorIncrDecr);
        mnuFunctions.add(separ4);

        mnuSectorTrailerWrite.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        mnuSectorTrailerWrite.setText("Sector Trailer Write");
        mnuSectorTrailerWrite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuSectorTrailerWriteActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuSectorTrailerWrite);

        mnuLinearFormatCard.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        mnuLinearFormatCard.setText("Linear Format Card");
        mnuLinearFormatCard.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuLinearFormatCardActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuLinearFormatCard);
        mnuFunctions.add(jSeparator7);

        mnuReaderHardFirmwareVersionItem.setText("Reader Hardware/Firmware version");
        mnuReaderHardFirmwareVersionItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuReaderHardFirmwareVersionItemActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuReaderHardFirmwareVersionItem);
        mnuFunctions.add(separ5);

        mnuViewAll.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        mnuViewAll.setText("View All");
        mnuViewAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuViewAllActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuViewAll);

        mnuExitItem.setText("Exit");
        mnuExitItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuExitItemActionPerformed(evt);
            }
        });
        mnuFunctions.add(mnuExitItem);

        mnuMeni.add(mnuFunctions);

        setJMenuBar(mnuMeni);
    }// </editor-fold>//GEN-END:initComponents

    private void mnuLinearReadWriteItemsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuLinearReadWriteItemsActionPerformed
       frmLinearReadWrite LRW=new frmLinearReadWrite();
       new GLFunctions().AddFrame(LRW, pnlDesktopPanel,lblHeader,"Linear Read/Write (AKM1,AKM2,PK)");
    }//GEN-LAST:event_mnuLinearReadWriteItemsActionPerformed

    private void mnuBlockReadWriteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuBlockReadWriteActionPerformed
        frmBlockReadWrite BRW=new frmBlockReadWrite();
        new GLFunctions().AddFrame(BRW, pnlDesktopPanel,lblHeader,"Block Read/Write (AKM1,AKM2,PK)");
    }//GEN-LAST:event_mnuBlockReadWriteActionPerformed

    private void mnuBlockInSectorReadWriteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuBlockInSectorReadWriteActionPerformed
        frmBlockInSectorReadWrite BSRW=new frmBlockInSectorReadWrite();
        new GLFunctions().AddFrame(BSRW, pnlDesktopPanel,lblHeader,"BlockInSector Read/Write (AKM1,AKM2,PK)");
    }//GEN-LAST:event_mnuBlockInSectorReadWriteActionPerformed

    private void mnuValueBlockReadWriteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuValueBlockReadWriteActionPerformed
        frmValueBlockReadWrite VBRW=new frmValueBlockReadWrite();
        new GLFunctions().AddFrame(VBRW, pnlDesktopPanel,lblHeader,"ValueBlock Read/Write (AKM1,AKM2,PK)");
    }//GEN-LAST:event_mnuValueBlockReadWriteActionPerformed

    private void mnuValueBlockIncrDecrActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuValueBlockIncrDecrActionPerformed
        frmValueBlockIncrementDecrement VBID=new frmValueBlockIncrementDecrement();
        new GLFunctions().AddFrame(VBID, pnlDesktopPanel,lblHeader,"ValueBlock Increment/Decrement (AKM1,AKM2,PK)");
    }//GEN-LAST:event_mnuValueBlockIncrDecrActionPerformed

    private void mnuValueBlockInSectorReadWriteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuValueBlockInSectorReadWriteActionPerformed
        frmValueBlockInSectorReadWrite VBSRW=new frmValueBlockInSectorReadWrite();
        new GLFunctions().AddFrame(VBSRW, pnlDesktopPanel,lblHeader,"ValueBlockInSector Read/Write (AKM1,AKM2,PK)");
    }//GEN-LAST:event_mnuValueBlockInSectorReadWriteActionPerformed

    private void mnuValueBlockInSectorIncrDecrActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuValueBlockInSectorIncrDecrActionPerformed
        frmValueBlockInSectorIncrementDecrement VBSID=new frmValueBlockInSectorIncrementDecrement();
        new GLFunctions().AddFrame(VBSID, pnlDesktopPanel,lblHeader,"ValueBlockInSector Increment/Decrement (AKM1,AKM2,PK)");
    }//GEN-LAST:event_mnuValueBlockInSectorIncrDecrActionPerformed

    private void mnuSectorTrailerWriteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuSectorTrailerWriteActionPerformed
        frmSectorTrailerWrite STW=new frmSectorTrailerWrite();
        new GLFunctions().AddFrame(STW, pnlDesktopPanel,lblHeader,"Sector Trailer Write (AKM1,AKM2,PK)");
    }//GEN-LAST:event_mnuSectorTrailerWriteActionPerformed

    private void mnuLinearFormatCardActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuLinearFormatCardActionPerformed
        frmLinearFormatCard LFC=new frmLinearFormatCard();
        new GLFunctions().AddFrame(LFC, pnlDesktopPanel,lblHeader,"Linear Format Card (AKM1,AKM2,PK)");
    }//GEN-LAST:event_mnuLinearFormatCardActionPerformed

    private void mnuViewAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuViewAllActionPerformed
        frmViewAll VALL=new frmViewAll();
        new GLFunctions().AddFrame(VALL, pnlDesktopPanel,lblHeader,"VIEW ALL");
    }//GEN-LAST:event_mnuViewAllActionPerformed

    private void btnReaderResetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnReaderResetActionPerformed
        if (GetFunct() || GetLoop()) {
            return;
        }
        
        try {
            SetFunct(true);
            
            int iFResult;
            iFResult = Declarations.uFrFunctions.uFrInstance.ReaderReset();
            if (iFResult == DL_OK) {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR, FUNCT_SOUND_ERROR);
            }
        } finally {
            SetFunct(false);
        }
    }//GEN-LAST:event_btnReaderResetActionPerformed

    private void btnSoftRestartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSoftRestartActionPerformed
        if (GetFunct() || GetLoop()) {
            return;
        }
        try {
            SetFunct(true);
            int iFResult;
            
            iFResult = Declarations.uFrFunctions.uFrInstance.ReaderSoftRestart();
            if (iFResult == DL_OK) {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR, FUNCT_SOUND_ERROR);
            }
        } finally {
            SetFunct(false);
        }
    }//GEN-LAST:event_btnSoftRestartActionPerformed

    private void btnReaderUISignalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnReaderUISignalActionPerformed
         if (GetFunct() || GetLoop()) {
            return;
        }
        try {
            SetFunct(true);            
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(cboLightMode.getSelectedIndex(), cboSoundMode.getSelectedIndex());           
        } finally {
            SetFunct(false);
        }
    }//GEN-LAST:event_btnReaderUISignalActionPerformed

    private void chkReaderKeyItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkReaderKeyItemStateChanged
      new GLFunctions().HexBoxs(tabReaderKey,"txtReaderKey",chkReaderKey);
      new GLFunctions().HEXBOX=chkReaderKey;
      new GLFunctions().TEXTFIELD="txtReaderKey";
       
    }//GEN-LAST:event_chkReaderKeyItemStateChanged

    private void btnSaveKeyIndexActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveKeyIndexActionPerformed
        if (GetFunct() || GetLoop()) {
            return;
        }
        try {
            SetFunct(true);
            int iFResult;                    
            byte bKeyIndex;
               
            bKeyIndex=(byte)Integer.parseInt(cboKeyIndex.getSelectedItem().toString());
            iFResult=Declarations.uFrFunctions.uFrInstance.ReaderKeyWrite(new GLFunctions().KEY(tabReaderKey,"txtReaderKey", chkReaderKey), bKeyIndex);
           if (iFResult == DL_OK) {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR, FUNCT_SOUND_ERROR);
            }
        } finally {
            SetFunct(false);
        }
    }//GEN-LAST:event_btnSaveKeyIndexActionPerformed

    private void btnSaveUserDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveUserDataActionPerformed
       if (GetFunct() || GetLoop()) {
            return;
        }
        try {
            SetFunct(true);
            int iFResult;
            
        if (txtNewUserData.getText().trim().isEmpty())
       {
           JOptionPane.showMessageDialog(rootPane,"You must enter any data !","Warning !", JOptionPane.WARNING_MESSAGE);
           txtNewUserData.requestFocus();
           return;
       }
       
        byte[] baNewUserdata = new byte[16];
               baNewUserdata = txtNewUserData.getText().getBytes();
     
               iFResult=Declarations.uFrFunctions.uFrInstance.WriteUserData(baNewUserdata);
       
               if (iFResult == DL_OK) {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR, FUNCT_SOUND_ERROR);
            }
        } finally {
            SetFunct(false);
        }
    }//GEN-LAST:event_btnSaveUserDataActionPerformed

    private void mnuExitItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuExitItemActionPerformed
       exec.shutdownNow();
       System.exit(0);
    }//GEN-LAST:event_mnuExitItemActionPerformed

    private void mnuReaderHardFirmwareVersionItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuReaderHardFirmwareVersionItemActionPerformed
        if (GetFunct() || GetLoop()) return;
        
        int result;
        ByteByReference hardwMajor = new ByteByReference(),hardwMinor = new ByteByReference();
        ByteByReference firmwMajor = new ByteByReference(),firmwMinor = new ByteByReference();
        try
        {
            SetFunct(true);
            result = Declarations.uFrFunctions.uFrInstance.GetReaderHardwareVersion(hardwMajor, hardwMinor);
            if (result == DL_OK) {
                          result=Declarations.uFrFunctions.uFrInstance.GetReaderFirmwareVersion(firmwMajor, firmwMinor);
                          if (result == DL_OK){
                              JOptionPane.showMessageDialog(rootPane,"Hardware version : " + hardwMajor.getValue()+"." + hardwMinor.getValue()+"\nFirmware version : " +                                  firmwMajor.getValue()+"." + firmwMinor.getValue(),"Hardware/Firmware Version",JOptionPane.INFORMATION_MESSAGE);
                          }
            }
            
        }finally{
            SetFunct(false);
        }
    }//GEN-LAST:event_mnuReaderHardFirmwareVersionItemActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnReaderReset;
    private javax.swing.JButton btnReaderUISignal;
    private javax.swing.JButton btnSaveKeyIndex;
    private javax.swing.JButton btnSaveUserData;
    private javax.swing.JButton btnSoftRestart;
    private javax.swing.JComboBox cboKeyIndex;
    private javax.swing.JComboBox cboLightMode;
    private javax.swing.JComboBox cboSoundMode;
    public javax.swing.JCheckBox chkReaderKey;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JSeparator jSeparator5;
    private javax.swing.JSeparator jSeparator6;
    private javax.swing.JPopupMenu.Separator jSeparator7;
    private javax.swing.JLabel lblCardSerial;
    private javax.swing.JLabel lblCardType;
    private javax.swing.JLabel lblCardUIDSize;
    private javax.swing.JLabel lblHeader;
    private javax.swing.JLabel lblKeyIndex1;
    private javax.swing.JLabel lblLightMode;
    private javax.swing.JLabel lblNewUserData;
    private javax.swing.JLabel lblReaderSerial;
    private javax.swing.JLabel lblReaderType;
    private javax.swing.JLabel lblSoundMode;
    private javax.swing.JLabel lblUserData;
    private javax.swing.JMenuItem mnuBlockInSectorReadWrite;
    private javax.swing.JMenuItem mnuBlockReadWrite;
    private javax.swing.JMenuItem mnuExitItem;
    private javax.swing.JMenu mnuFunctions;
    private javax.swing.JMenuItem mnuLinearFormatCard;
    private javax.swing.JMenuItem mnuLinearReadWriteItems;
    private javax.swing.JMenuBar mnuMeni;
    private javax.swing.JMenuItem mnuReaderHardFirmwareVersionItem;
    private javax.swing.JMenuItem mnuSectorTrailerWrite;
    private javax.swing.JMenuItem mnuValueBlockInSectorIncrDecr;
    private javax.swing.JMenuItem mnuValueBlockInSectorReadWrite;
    private javax.swing.JMenuItem mnuValueBlockIncrDecr;
    private javax.swing.JMenuItem mnuValueBlockReadWrite;
    private javax.swing.JMenuItem mnuViewAll;
    private javax.swing.JTabbedPane pgUserData;
    private javax.swing.JDesktopPane pnlDesktopPanel;
    private javax.swing.JPanel pnlReaderType;
    private javax.swing.JPopupMenu.Separator separ1;
    private javax.swing.JPopupMenu.Separator separ2;
    private javax.swing.JPopupMenu.Separator separ3;
    private javax.swing.JPopupMenu.Separator separ4;
    private javax.swing.JPopupMenu.Separator separ5;
    private javax.swing.JPanel tabReaderKey;
    private javax.swing.JPanel tabUserData;
    private javax.swing.JTextField txtCErrorCode;
    private javax.swing.JTextField txtCErrorExplain;
    private javax.swing.JTextField txtCardSerial;
    private javax.swing.JTextField txtCardStatus;
    private javax.swing.JTextField txtCardType;
    private javax.swing.JTextField txtCardUIDSize;
    private javax.swing.JTextField txtConnected;
    private javax.swing.JTextField txtNewUserData;
    private javax.swing.JTextField txtRErrorCode;
    private javax.swing.JTextField txtRErrorExplain;
    private javax.swing.JTextField txtReaderSerial;
    private javax.swing.JTextField txtReaderType;
    private javax.swing.JTextField txtUserData;
    // End of variables declaration//GEN-END:variables

}
