

package ufcoderadvancedapplet;

import javax.swing.JOptionPane;

public class frmBlockInSectorReadWrite extends javax.swing.JInternalFrame {
  
    static final int 
         FUNCT_LIGHT_OK     = 4,
         FUNCT_SOUND_OK     = 0,//4 Tripple sound
         FUNCT_LIGHT_ERROR  = 2,
         FUNCT_SOUND_ERROR  = 0,//2 Long sound
         DL_OK              = 0;
    
    static final byte
         MIFARE_AUTHENT1A   = 0x60,  
         MIFARE_AUTHENT1B   = 0x61,
         MAX_BLOCK_BYTES    = 16;
    
    
    final static String ANY_DATA            = "You must enter any data !",
                        APPROPRIATE_FORMAT  = "You must enter the appropriate format !";
    
    
    
     
    public frmBlockInSectorReadWrite() {
        initComponents();
        new GLFunctions().CreatePKBox(pnlPKKey,29,20,13,350,"txtPKKey");
    }

    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        rbtnRadioButton = new javax.swing.ButtonGroup();
        pnlPKKey = new javax.swing.JPanel();
        rbAUTH1A = new javax.swing.JRadioButton();
        rbAUTH1B = new javax.swing.JRadioButton();
        lblKeyIndex = new javax.swing.JLabel();
        cboKeyIndex = new javax.swing.JComboBox();
        lblPKKey = new javax.swing.JLabel();
        tabBlockInSectorReadWrite = new javax.swing.JTabbedPane();
        tabBlockInSectorRead = new javax.swing.JPanel();
        pnlBlockInSectorRead = new javax.swing.JPanel();
        txtSectorAddressRead = new javax.swing.JTextField();
        txtBlockAddressRead = new javax.swing.JTextField();
        btnBlockInSectorRead = new javax.swing.JButton();
        txtBlockInSectorRead = new javax.swing.JTextField();
        lblBlockInSectorRead = new javax.swing.JLabel();
        lblSectorAddressRead = new javax.swing.JLabel();
        lblBlockAddressRead = new javax.swing.JLabel();
        lblBlockInSectorReadData = new javax.swing.JLabel();
        pnlBlockInSectorReadAKM1 = new javax.swing.JPanel();
        txtSectorAddressReadAKM1 = new javax.swing.JTextField();
        txtBlockAddressReadAKM1 = new javax.swing.JTextField();
        btnBlockInSectorReadAKM1 = new javax.swing.JButton();
        txtBlockInSectorReadAKM1 = new javax.swing.JTextField();
        lblBlockInSectorReadAKM1 = new javax.swing.JLabel();
        lblSectorAddressReadAKM1 = new javax.swing.JLabel();
        lblBlockAddressReadAKM1 = new javax.swing.JLabel();
        lblBlockInSectorReadDataAKM1 = new javax.swing.JLabel();
        pnlBlockInSectorReadAKM2 = new javax.swing.JPanel();
        txtSectorAddressReadAKM2 = new javax.swing.JTextField();
        txtBlockAddressReadAKM2 = new javax.swing.JTextField();
        btnBlockInSectorReadAKM2 = new javax.swing.JButton();
        txtBlockInSectorReadAKM2 = new javax.swing.JTextField();
        lblBlockInSectorReadAKM2 = new javax.swing.JLabel();
        lblSectorAddressReadAKM2 = new javax.swing.JLabel();
        lblBlockAddressReadAKM2 = new javax.swing.JLabel();
        lblBlockInSectorReadDataAKM2 = new javax.swing.JLabel();
        pnlBlockInSectorReadPK = new javax.swing.JPanel();
        txtSectorAddressReadPK = new javax.swing.JTextField();
        txtBlockAddressReadPK = new javax.swing.JTextField();
        btnBlockInSectorReadPK = new javax.swing.JButton();
        txtBlockInSectorReadPK = new javax.swing.JTextField();
        lblBlockInSectorReadPK = new javax.swing.JLabel();
        lblSectorAddressReadPK = new javax.swing.JLabel();
        lblBlockAddressReadPK = new javax.swing.JLabel();
        lblBlockInSectorReadDataPK = new javax.swing.JLabel();
        tabBlockInSectorWrite = new javax.swing.JPanel();
        pnlBlockInSectorWrite = new javax.swing.JPanel();
        txtBlockInSectorWrite = new javax.swing.JTextField();
        txtSectorAddressWrite = new javax.swing.JTextField();
        txtBlockAddressWrite = new javax.swing.JTextField();
        btnBlockInSectorWrite = new javax.swing.JButton();
        lblBlockInSectorWrite = new javax.swing.JLabel();
        lblSectorAddressWrite = new javax.swing.JLabel();
        lblBlockAddressWrite = new javax.swing.JLabel();
        lblBlockInSectorWriteData = new javax.swing.JLabel();
        pnlBlockInSectorWriteAKM1 = new javax.swing.JPanel();
        txtBlockInSectorWriteAKM1 = new javax.swing.JTextField();
        txtSectorAddressWriteAKM1 = new javax.swing.JTextField();
        txtBlockAddressWriteAKM1 = new javax.swing.JTextField();
        btnBlockInSectorWriteAKM1 = new javax.swing.JButton();
        lblBlockInSectorWriteAKM1 = new javax.swing.JLabel();
        lblSectorAddressWriteAKM1 = new javax.swing.JLabel();
        lblBlockAddressWriteAKM1 = new javax.swing.JLabel();
        lblBlockInSectorWriteDataAKM1 = new javax.swing.JLabel();
        pnlBlockInSectorWriteAKM2 = new javax.swing.JPanel();
        txtBlockInSectorWriteAKM2 = new javax.swing.JTextField();
        txtSectorAddressWriteAKM2 = new javax.swing.JTextField();
        txtBlockAddressWriteAKM2 = new javax.swing.JTextField();
        btnBlockInSectorWriteAKM2 = new javax.swing.JButton();
        lblBlockInSectorWriteAKM2 = new javax.swing.JLabel();
        lblSectorAddressWriteAKM2 = new javax.swing.JLabel();
        lblBlockAddressWriteAKM2 = new javax.swing.JLabel();
        lblBlockInSectorWriteDataAKM2 = new javax.swing.JLabel();
        pnlBlockInSectorWritePK = new javax.swing.JPanel();
        txtBlockInSectorWritePK = new javax.swing.JTextField();
        txtSectorAddressWritePK = new javax.swing.JTextField();
        txtBlockAddressWritePK = new javax.swing.JTextField();
        btnBlockInSectorWritePK = new javax.swing.JButton();
        lblBlockInSectorWritePK = new javax.swing.JLabel();
        lblSectorAddressWritePK = new javax.swing.JLabel();
        lblBlockAddressWritePK = new javax.swing.JLabel();
        lblBlockInSectorWriteDataPK = new javax.swing.JLabel();
        txtFunctionStatus = new javax.swing.JTextField();
        txtFErrorCode = new javax.swing.JTextField();
        txtFErrorExplain = new javax.swing.JTextField();

        setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        setTitle("frmBlockInSectorReadWrite");
        setAutoscrolls(true);
        setName("frmBlockInSectorReadWrite"); // NOI18N
        setPreferredSize(new java.awt.Dimension(569, 449));
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlPKKey.setBackground(new java.awt.Color(255, 255, 255));
        pnlPKKey.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlPKKey.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        rbAUTH1A.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioButton.add(rbAUTH1A);
        rbAUTH1A.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1A.setSelected(true);
        rbAUTH1A.setText("AUTH 1A");
        rbAUTH1A.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        pnlPKKey.add(rbAUTH1A, new org.netbeans.lib.awtextra.AbsoluteConstraints(7, 11, -1, -1));

        rbAUTH1B.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioButton.add(rbAUTH1B);
        rbAUTH1B.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1B.setText("AUTH 1B");
        rbAUTH1B.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        pnlPKKey.add(rbAUTH1B, new org.netbeans.lib.awtextra.AbsoluteConstraints(82, 11, -1, -1));

        lblKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblKeyIndex.setText("Key Index");
        pnlPKKey.add(lblKeyIndex, new org.netbeans.lib.awtextra.AbsoluteConstraints(163, 15, -1, -1));

        cboKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        cboKeyIndex.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", " " }));
        cboKeyIndex.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        pnlPKKey.add(cboKeyIndex, new org.netbeans.lib.awtextra.AbsoluteConstraints(226, 12, -1, -1));

        lblPKKey.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblPKKey.setText("PK Key");
        pnlPKKey.add(lblPKKey, new org.netbeans.lib.awtextra.AbsoluteConstraints(276, 15, -1, -1));

        getContentPane().add(pnlPKKey, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 560, 40));

        tabBlockInSectorReadWrite.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        tabBlockInSectorReadWrite.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N

        tabBlockInSectorRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabBlockInSectorRead.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        tabBlockInSectorRead.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlBlockInSectorRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtSectorAddressRead.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtSectorAddressRead.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorAddressRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressRead.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressRead.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockInSectorRead.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnBlockInSectorRead.setText("READ");
        btnBlockInSectorRead.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockInSectorRead.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockInSectorReadActionPerformed(evt);
            }
        });

        txtBlockInSectorRead.setEditable(false);
        txtBlockInSectorRead.setBackground(new java.awt.Color(255, 255, 255));
        txtBlockInSectorRead.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockInSectorRead.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockInSectorRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        lblBlockInSectorRead.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockInSectorRead.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblBlockInSectorRead.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockInSectorRead.setText("BlockInSector Read");
        lblBlockInSectorRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockInSectorRead.setOpaque(true);

        lblSectorAddressRead.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorAddressRead.setText("Sector Address");

        lblBlockAddressRead.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressRead.setText("Block Address");

        lblBlockInSectorReadData.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockInSectorReadData.setText("Read Data");

        javax.swing.GroupLayout pnlBlockInSectorReadLayout = new javax.swing.GroupLayout(pnlBlockInSectorRead);
        pnlBlockInSectorRead.setLayout(pnlBlockInSectorReadLayout);
        pnlBlockInSectorReadLayout.setHorizontalGroup(
            pnlBlockInSectorReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblBlockInSectorRead, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(pnlBlockInSectorReadLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlBlockInSectorReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(txtBlockInSectorRead, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockInSectorReadLayout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSectorAddressRead)
                            .addComponent(lblBlockAddressRead))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtSectorAddressRead, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtBlockAddressRead, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBlockInSectorRead, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(lblBlockInSectorReadData, javax.swing.GroupLayout.Alignment.LEADING))
                .addContainerGap())
        );
        pnlBlockInSectorReadLayout.setVerticalGroup(
            pnlBlockInSectorReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockInSectorReadLayout.createSequentialGroup()
                .addComponent(lblBlockInSectorRead)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockInSectorReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlBlockInSectorReadLayout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblSectorAddressRead)
                            .addComponent(txtSectorAddressRead, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorReadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblBlockAddressRead)
                            .addComponent(txtBlockAddressRead, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(btnBlockInSectorRead, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addComponent(lblBlockInSectorReadData)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtBlockInSectorRead, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        tabBlockInSectorRead.add(pnlBlockInSectorRead, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, -1));

        pnlBlockInSectorReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtSectorAddressReadAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtSectorAddressReadAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorAddressReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressReadAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressReadAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockInSectorReadAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnBlockInSectorReadAKM1.setText("READ");
        btnBlockInSectorReadAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockInSectorReadAKM1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockInSectorReadAKM1ActionPerformed(evt);
            }
        });

        txtBlockInSectorReadAKM1.setEditable(false);
        txtBlockInSectorReadAKM1.setBackground(new java.awt.Color(255, 255, 255));
        txtBlockInSectorReadAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockInSectorReadAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockInSectorReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        lblBlockInSectorReadAKM1.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockInSectorReadAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblBlockInSectorReadAKM1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockInSectorReadAKM1.setText("BlockInSector Read AKM1");
        lblBlockInSectorReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockInSectorReadAKM1.setOpaque(true);

        lblSectorAddressReadAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorAddressReadAKM1.setText("Sector Address");

        lblBlockAddressReadAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressReadAKM1.setText("Block Address");

        lblBlockInSectorReadDataAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockInSectorReadDataAKM1.setText("Read Data");

        javax.swing.GroupLayout pnlBlockInSectorReadAKM1Layout = new javax.swing.GroupLayout(pnlBlockInSectorReadAKM1);
        pnlBlockInSectorReadAKM1.setLayout(pnlBlockInSectorReadAKM1Layout);
        pnlBlockInSectorReadAKM1Layout.setHorizontalGroup(
            pnlBlockInSectorReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockInSectorReadAKM1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlBlockInSectorReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(txtBlockInSectorReadAKM1, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockInSectorReadAKM1Layout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSectorAddressReadAKM1)
                            .addComponent(lblBlockAddressReadAKM1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtSectorAddressReadAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtBlockAddressReadAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBlockInSectorReadAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(lblBlockInSectorReadDataAKM1, javax.swing.GroupLayout.Alignment.LEADING))
                .addContainerGap())
            .addComponent(lblBlockInSectorReadAKM1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        pnlBlockInSectorReadAKM1Layout.setVerticalGroup(
            pnlBlockInSectorReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockInSectorReadAKM1Layout.createSequentialGroup()
                .addComponent(lblBlockInSectorReadAKM1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockInSectorReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlBlockInSectorReadAKM1Layout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblSectorAddressReadAKM1)
                            .addComponent(txtSectorAddressReadAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorReadAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblBlockAddressReadAKM1)
                            .addComponent(txtBlockAddressReadAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(btnBlockInSectorReadAKM1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addComponent(lblBlockInSectorReadDataAKM1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtBlockInSectorReadAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        tabBlockInSectorRead.add(pnlBlockInSectorReadAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 10, -1, -1));

        pnlBlockInSectorReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtSectorAddressReadAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtSectorAddressReadAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorAddressReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressReadAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressReadAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockInSectorReadAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnBlockInSectorReadAKM2.setText("READ");
        btnBlockInSectorReadAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockInSectorReadAKM2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockInSectorReadAKM2ActionPerformed(evt);
            }
        });

        txtBlockInSectorReadAKM2.setEditable(false);
        txtBlockInSectorReadAKM2.setBackground(new java.awt.Color(255, 255, 255));
        txtBlockInSectorReadAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockInSectorReadAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockInSectorReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        lblBlockInSectorReadAKM2.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockInSectorReadAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblBlockInSectorReadAKM2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockInSectorReadAKM2.setText("BlockInSector Read AKM2");
        lblBlockInSectorReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockInSectorReadAKM2.setOpaque(true);

        lblSectorAddressReadAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorAddressReadAKM2.setText("Sector Address");

        lblBlockAddressReadAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressReadAKM2.setText("Block Address");

        lblBlockInSectorReadDataAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockInSectorReadDataAKM2.setText("Read Data");

        javax.swing.GroupLayout pnlBlockInSectorReadAKM2Layout = new javax.swing.GroupLayout(pnlBlockInSectorReadAKM2);
        pnlBlockInSectorReadAKM2.setLayout(pnlBlockInSectorReadAKM2Layout);
        pnlBlockInSectorReadAKM2Layout.setHorizontalGroup(
            pnlBlockInSectorReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblBlockInSectorReadAKM2, javax.swing.GroupLayout.DEFAULT_SIZE, 240, Short.MAX_VALUE)
            .addGroup(pnlBlockInSectorReadAKM2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlBlockInSectorReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(txtBlockInSectorReadAKM2, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockInSectorReadAKM2Layout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSectorAddressReadAKM2)
                            .addComponent(lblBlockAddressReadAKM2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtSectorAddressReadAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtBlockAddressReadAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBlockInSectorReadAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(lblBlockInSectorReadDataAKM2, javax.swing.GroupLayout.Alignment.LEADING))
                .addContainerGap())
        );
        pnlBlockInSectorReadAKM2Layout.setVerticalGroup(
            pnlBlockInSectorReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockInSectorReadAKM2Layout.createSequentialGroup()
                .addComponent(lblBlockInSectorReadAKM2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockInSectorReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlBlockInSectorReadAKM2Layout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblSectorAddressReadAKM2)
                            .addComponent(txtSectorAddressReadAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorReadAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblBlockAddressReadAKM2)
                            .addComponent(txtBlockAddressReadAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(btnBlockInSectorReadAKM2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addComponent(lblBlockInSectorReadDataAKM2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtBlockInSectorReadAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        tabBlockInSectorRead.add(pnlBlockInSectorReadAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 150, 242, -1));

        pnlBlockInSectorReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtSectorAddressReadPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtSectorAddressReadPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorAddressReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressReadPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressReadPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockInSectorReadPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnBlockInSectorReadPK.setText("READ");
        btnBlockInSectorReadPK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockInSectorReadPK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockInSectorReadPKActionPerformed(evt);
            }
        });

        txtBlockInSectorReadPK.setEditable(false);
        txtBlockInSectorReadPK.setBackground(new java.awt.Color(255, 255, 255));
        txtBlockInSectorReadPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockInSectorReadPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockInSectorReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        lblBlockInSectorReadPK.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockInSectorReadPK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblBlockInSectorReadPK.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockInSectorReadPK.setText("BlockInSector Read PK");
        lblBlockInSectorReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockInSectorReadPK.setOpaque(true);

        lblSectorAddressReadPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorAddressReadPK.setText("Sector Address");

        lblBlockAddressReadPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressReadPK.setText("Block Address");

        lblBlockInSectorReadDataPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockInSectorReadDataPK.setText("Read Data");

        javax.swing.GroupLayout pnlBlockInSectorReadPKLayout = new javax.swing.GroupLayout(pnlBlockInSectorReadPK);
        pnlBlockInSectorReadPK.setLayout(pnlBlockInSectorReadPKLayout);
        pnlBlockInSectorReadPKLayout.setHorizontalGroup(
            pnlBlockInSectorReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblBlockInSectorReadPK, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(pnlBlockInSectorReadPKLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlBlockInSectorReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(txtBlockInSectorReadPK, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlBlockInSectorReadPKLayout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSectorAddressReadPK)
                            .addComponent(lblBlockAddressReadPK))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtSectorAddressReadPK, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtBlockAddressReadPK, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBlockInSectorReadPK, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(lblBlockInSectorReadDataPK, javax.swing.GroupLayout.Alignment.LEADING))
                .addContainerGap())
        );
        pnlBlockInSectorReadPKLayout.setVerticalGroup(
            pnlBlockInSectorReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockInSectorReadPKLayout.createSequentialGroup()
                .addComponent(lblBlockInSectorReadPK)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockInSectorReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlBlockInSectorReadPKLayout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblSectorAddressReadPK)
                            .addComponent(txtSectorAddressReadPK, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorReadPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblBlockAddressReadPK)
                            .addComponent(txtBlockAddressReadPK, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(btnBlockInSectorReadPK, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addComponent(lblBlockInSectorReadDataPK)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtBlockInSectorReadPK, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        tabBlockInSectorRead.add(pnlBlockInSectorReadPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 150, -1, -1));

        tabBlockInSectorReadWrite.addTab("BlockInSector Read", tabBlockInSectorRead);

        tabBlockInSectorWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabBlockInSectorWrite.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        tabBlockInSectorWrite.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlBlockInSectorWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockInSectorWrite.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockInSectorWrite.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockInSectorWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtSectorAddressWrite.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtSectorAddressWrite.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorAddressWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressWrite.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressWrite.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockInSectorWrite.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnBlockInSectorWrite.setText("WRITE");
        btnBlockInSectorWrite.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockInSectorWrite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockInSectorWriteActionPerformed(evt);
            }
        });

        lblBlockInSectorWrite.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockInSectorWrite.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblBlockInSectorWrite.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockInSectorWrite.setText("BlockInSector Write");
        lblBlockInSectorWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockInSectorWrite.setOpaque(true);

        lblSectorAddressWrite.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorAddressWrite.setText("Sector Address");

        lblBlockAddressWrite.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWrite.setText("Block Address");

        lblBlockInSectorWriteData.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockInSectorWriteData.setText("Write Data");

        javax.swing.GroupLayout pnlBlockInSectorWriteLayout = new javax.swing.GroupLayout(pnlBlockInSectorWrite);
        pnlBlockInSectorWrite.setLayout(pnlBlockInSectorWriteLayout);
        pnlBlockInSectorWriteLayout.setHorizontalGroup(
            pnlBlockInSectorWriteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblBlockInSectorWrite, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(pnlBlockInSectorWriteLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlBlockInSectorWriteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlBlockInSectorWriteLayout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorWriteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSectorAddressWrite)
                            .addComponent(lblBlockAddressWrite))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorWriteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtBlockAddressWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtSectorAddressWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBlockInSectorWrite))
                    .addComponent(lblBlockInSectorWriteData)
                    .addComponent(txtBlockInSectorWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 218, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pnlBlockInSectorWriteLayout.setVerticalGroup(
            pnlBlockInSectorWriteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockInSectorWriteLayout.createSequentialGroup()
                .addComponent(lblBlockInSectorWrite)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblBlockInSectorWriteData)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtBlockInSectorWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockInSectorWriteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnBlockInSectorWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 52, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlBlockInSectorWriteLayout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorWriteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblSectorAddressWrite)
                            .addComponent(txtSectorAddressWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(pnlBlockInSectorWriteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblBlockAddressWrite)
                            .addComponent(txtBlockAddressWrite, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );

        tabBlockInSectorWrite.add(pnlBlockInSectorWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 10, -1, -1));

        pnlBlockInSectorWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockInSectorWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockInSectorWriteAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockInSectorWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtSectorAddressWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtSectorAddressWriteAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorAddressWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressWriteAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockInSectorWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnBlockInSectorWriteAKM1.setText("WRITE");
        btnBlockInSectorWriteAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockInSectorWriteAKM1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockInSectorWriteAKM1ActionPerformed(evt);
            }
        });

        lblBlockInSectorWriteAKM1.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockInSectorWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblBlockInSectorWriteAKM1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockInSectorWriteAKM1.setText("BlockInSector Write AKM1");
        lblBlockInSectorWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockInSectorWriteAKM1.setOpaque(true);

        lblSectorAddressWriteAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorAddressWriteAKM1.setText("Sector Address");

        lblBlockAddressWriteAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWriteAKM1.setText("Block Address");

        lblBlockInSectorWriteDataAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockInSectorWriteDataAKM1.setText("Write Data");

        javax.swing.GroupLayout pnlBlockInSectorWriteAKM1Layout = new javax.swing.GroupLayout(pnlBlockInSectorWriteAKM1);
        pnlBlockInSectorWriteAKM1.setLayout(pnlBlockInSectorWriteAKM1Layout);
        pnlBlockInSectorWriteAKM1Layout.setHorizontalGroup(
            pnlBlockInSectorWriteAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblBlockInSectorWriteAKM1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(pnlBlockInSectorWriteAKM1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlBlockInSectorWriteAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlBlockInSectorWriteAKM1Layout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorWriteAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSectorAddressWriteAKM1)
                            .addComponent(lblBlockAddressWriteAKM1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorWriteAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtBlockAddressWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtSectorAddressWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBlockInSectorWriteAKM1))
                    .addComponent(lblBlockInSectorWriteDataAKM1)
                    .addComponent(txtBlockInSectorWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 218, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pnlBlockInSectorWriteAKM1Layout.setVerticalGroup(
            pnlBlockInSectorWriteAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockInSectorWriteAKM1Layout.createSequentialGroup()
                .addComponent(lblBlockInSectorWriteAKM1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblBlockInSectorWriteDataAKM1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtBlockInSectorWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockInSectorWriteAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnBlockInSectorWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 52, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlBlockInSectorWriteAKM1Layout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorWriteAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblSectorAddressWriteAKM1)
                            .addComponent(txtSectorAddressWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(pnlBlockInSectorWriteAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblBlockAddressWriteAKM1)
                            .addComponent(txtBlockAddressWriteAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );

        tabBlockInSectorWrite.add(pnlBlockInSectorWriteAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 10, -1, -1));

        pnlBlockInSectorWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockInSectorWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockInSectorWriteAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockInSectorWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtSectorAddressWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtSectorAddressWriteAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorAddressWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressWriteAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockInSectorWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnBlockInSectorWriteAKM2.setText("WRITE");
        btnBlockInSectorWriteAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockInSectorWriteAKM2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockInSectorWriteAKM2ActionPerformed(evt);
            }
        });

        lblBlockInSectorWriteAKM2.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockInSectorWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblBlockInSectorWriteAKM2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockInSectorWriteAKM2.setText("BlockInSector Write AKM2");
        lblBlockInSectorWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockInSectorWriteAKM2.setOpaque(true);

        lblSectorAddressWriteAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorAddressWriteAKM2.setText("Sector Address");

        lblBlockAddressWriteAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWriteAKM2.setText("Block Address");

        lblBlockInSectorWriteDataAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockInSectorWriteDataAKM2.setText("Write Data");

        javax.swing.GroupLayout pnlBlockInSectorWriteAKM2Layout = new javax.swing.GroupLayout(pnlBlockInSectorWriteAKM2);
        pnlBlockInSectorWriteAKM2.setLayout(pnlBlockInSectorWriteAKM2Layout);
        pnlBlockInSectorWriteAKM2Layout.setHorizontalGroup(
            pnlBlockInSectorWriteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblBlockInSectorWriteAKM2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(pnlBlockInSectorWriteAKM2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlBlockInSectorWriteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlBlockInSectorWriteAKM2Layout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorWriteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSectorAddressWriteAKM2)
                            .addComponent(lblBlockAddressWriteAKM2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorWriteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtBlockAddressWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtSectorAddressWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBlockInSectorWriteAKM2))
                    .addComponent(lblBlockInSectorWriteDataAKM2)
                    .addComponent(txtBlockInSectorWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 218, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pnlBlockInSectorWriteAKM2Layout.setVerticalGroup(
            pnlBlockInSectorWriteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockInSectorWriteAKM2Layout.createSequentialGroup()
                .addComponent(lblBlockInSectorWriteAKM2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblBlockInSectorWriteDataAKM2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtBlockInSectorWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockInSectorWriteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnBlockInSectorWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 52, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlBlockInSectorWriteAKM2Layout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorWriteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblSectorAddressWriteAKM2)
                            .addComponent(txtSectorAddressWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(pnlBlockInSectorWriteAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblBlockAddressWriteAKM2)
                            .addComponent(txtBlockAddressWriteAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );

        tabBlockInSectorWrite.add(pnlBlockInSectorWriteAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 150, -1, -1));

        pnlBlockInSectorWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockInSectorWritePK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockInSectorWritePK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockInSectorWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtSectorAddressWritePK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtSectorAddressWritePK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtSectorAddressWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressWritePK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressWritePK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnBlockInSectorWritePK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnBlockInSectorWritePK.setText("WRITE");
        btnBlockInSectorWritePK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnBlockInSectorWritePK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBlockInSectorWritePKActionPerformed(evt);
            }
        });

        lblBlockInSectorWritePK.setBackground(new java.awt.Color(204, 204, 204));
        lblBlockInSectorWritePK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblBlockInSectorWritePK.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblBlockInSectorWritePK.setText("BlockInSector Write PK");
        lblBlockInSectorWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblBlockInSectorWritePK.setOpaque(true);

        lblSectorAddressWritePK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblSectorAddressWritePK.setText("Sector Address");

        lblBlockAddressWritePK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWritePK.setText("Block Address");

        lblBlockInSectorWriteDataPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockInSectorWriteDataPK.setText("Write Data");

        javax.swing.GroupLayout pnlBlockInSectorWritePKLayout = new javax.swing.GroupLayout(pnlBlockInSectorWritePK);
        pnlBlockInSectorWritePK.setLayout(pnlBlockInSectorWritePKLayout);
        pnlBlockInSectorWritePKLayout.setHorizontalGroup(
            pnlBlockInSectorWritePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblBlockInSectorWritePK, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(pnlBlockInSectorWritePKLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlBlockInSectorWritePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlBlockInSectorWritePKLayout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorWritePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSectorAddressWritePK)
                            .addComponent(lblBlockAddressWritePK))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlBlockInSectorWritePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtBlockAddressWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtSectorAddressWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBlockInSectorWritePK))
                    .addComponent(lblBlockInSectorWriteDataPK)
                    .addComponent(txtBlockInSectorWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 218, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pnlBlockInSectorWritePKLayout.setVerticalGroup(
            pnlBlockInSectorWritePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBlockInSectorWritePKLayout.createSequentialGroup()
                .addComponent(lblBlockInSectorWritePK)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblBlockInSectorWriteDataPK)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtBlockInSectorWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlBlockInSectorWritePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnBlockInSectorWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 52, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlBlockInSectorWritePKLayout.createSequentialGroup()
                        .addGroup(pnlBlockInSectorWritePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblSectorAddressWritePK)
                            .addComponent(txtSectorAddressWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(pnlBlockInSectorWritePKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblBlockAddressWritePK)
                            .addComponent(txtBlockAddressWritePK, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );

        tabBlockInSectorWrite.add(pnlBlockInSectorWritePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 150, -1, -1));

        tabBlockInSectorReadWrite.addTab("BlockInSector Write", tabBlockInSectorWrite);

        getContentPane().add(tabBlockInSectorReadWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 46, 540, 336));

        txtFunctionStatus.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFunctionStatus.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtFunctionStatus.setText("Function Status");
        getContentPane().add(txtFunctionStatus, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 390, 140, -1));

        txtFErrorCode.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorCode.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorCode, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 390, 70, -1));

        txtFErrorExplain.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorExplain.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorExplain, new org.netbeans.lib.awtextra.AbsoluteConstraints(210, 390, 360, -1));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnBlockInSectorReadAKM1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockInSectorReadAKM1ActionPerformed
        frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);                    
          byte  bSectorAddress = 0;
          byte  bBlockAddress  = 0;
          byte[] baBlockData   = new byte[MAX_BLOCK_BYTES];
          
        if (txtSectorAddressReadAKM1.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtSectorAddressReadAKM1.requestFocus();
             return;
         }
          if (txtBlockAddressReadAKM1.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockAddressReadAKM1.requestFocus();
             return;
         }
          
         bSectorAddress=Byte.parseByte(txtSectorAddressReadAKM1.getText().trim());
         bBlockAddress=Byte.parseByte(txtBlockAddressReadAKM1.getText().trim());
         
         iFResult=Declarations.uFrFunctions.uFrInstance.BlockInSectorRead_AKM1(baBlockData, bSectorAddress, bBlockAddress, bAuthMode);
         if (iFResult==DL_OK){
             
               txtBlockInSectorReadAKM1.setText(new String(baBlockData));
              Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
              M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
        }
         catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }
        finally{
            M.SetFunct(false);
        }

    }//GEN-LAST:event_btnBlockInSectorReadAKM1ActionPerformed

    private void btnBlockInSectorReadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockInSectorReadActionPerformed
        frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B); 
          byte  bKeyIndex      = (byte)cboKeyIndex.getSelectedIndex();
          byte  bSectorAddress = 0;
          byte  bBlockAddress  = 0;
          byte[] baBlockData   = new byte[MAX_BLOCK_BYTES];
          
        if (txtSectorAddressRead.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtSectorAddressRead.requestFocus();
             return;
         }
          if (txtBlockAddressRead.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockAddressRead.requestFocus();
             return;
         }
          
         bSectorAddress=Byte.parseByte(txtSectorAddressRead.getText().trim());
         bBlockAddress =Byte.parseByte(txtBlockAddressRead.getText().trim());
         
         iFResult=Declarations.uFrFunctions.uFrInstance.BlockInSectorRead(baBlockData, bSectorAddress, bBlockAddress, bAuthMode, bKeyIndex);
         if (iFResult==DL_OK){             
               txtBlockInSectorRead.setText(new String(baBlockData));
              Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
              M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
        }
           catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockInSectorReadActionPerformed

    private void btnBlockInSectorReadAKM2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockInSectorReadAKM2ActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);           
          byte  bSectorAddress = 0;
          byte  bBlockAddress  = 0;
          byte[] baBlockData   = new byte[MAX_BLOCK_BYTES];
          
        if (txtSectorAddressReadAKM2.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtSectorAddressReadAKM2.requestFocus();
             return;
         }
          if (txtBlockAddressReadAKM2.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockAddressReadAKM2.requestFocus();
             return;
         }
          
         bSectorAddress=Byte.parseByte(txtSectorAddressReadAKM2.getText().trim());
         bBlockAddress =Byte.parseByte(txtBlockAddressReadAKM2.getText().trim());
         
         iFResult=Declarations.uFrFunctions.uFrInstance.BlockInSectorRead_AKM2(baBlockData, bSectorAddress, bBlockAddress, bAuthMode);
         if (iFResult==DL_OK){             
               txtBlockInSectorReadAKM2.setText(new String(baBlockData));
              Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
              M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
        }
           catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, GLFunctions.APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }

    }//GEN-LAST:event_btnBlockInSectorReadAKM2ActionPerformed

    private void btnBlockInSectorReadPKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockInSectorReadPKActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);           
          byte  bSectorAddress = 0;
          byte  bBlockAddress  = 0;
          byte[] baBlockData   = new byte[MAX_BLOCK_BYTES];
          
        if (txtSectorAddressReadPK.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtSectorAddressReadPK.requestFocus();
             return;
         }
          if (txtBlockAddressReadPK.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockAddressReadPK.requestFocus();
             return;
         }
        
          bSectorAddress=Byte.parseByte(txtSectorAddressReadPK.getText().trim());
          bBlockAddress =Byte.parseByte(txtBlockAddressReadPK.getText().trim());
         
          iFResult=Declarations.uFrFunctions.uFrInstance.BlockInSectorRead_PK(baBlockData, bSectorAddress, bBlockAddress, bAuthMode,new GLFunctions().PK_KEY(pnlPKKey));
         
          if (iFResult==DL_OK){             
              Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
              M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
           }
           catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, GLFunctions.APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
           M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockInSectorReadPKActionPerformed

    private void btnBlockInSectorWriteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockInSectorWriteActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);           
          byte  bSectorAddress = 0;
          byte  bBlockAddress  = 0;
          byte[] baBlockData   = new byte[MAX_BLOCK_BYTES];
          byte bKeyIndex       = (byte)cboKeyIndex.getSelectedIndex();
          
        if (txtBlockInSectorWrite.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockInSectorWrite.requestFocus();
             return;
        }
        if (txtSectorAddressWrite.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtSectorAddressWrite.requestFocus();
             return;
         }
          if (txtBlockAddressWrite.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockAddressWrite.requestFocus();
             return;
         }
         
          baBlockData   =(txtBlockInSectorWrite.getText().getBytes() );
          bSectorAddress=Byte.parseByte(txtSectorAddressWrite.getText().trim());
          bBlockAddress =Byte.parseByte(txtBlockAddressWrite.getText().trim());
         
          iFResult=Declarations.uFrFunctions.uFrInstance.BlockInSectorWrite(baBlockData, bSectorAddress, bBlockAddress,bAuthMode,bKeyIndex);
         if (iFResult==DL_OK){               
             Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
              M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
           }
           catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, GLFunctions.APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockInSectorWriteActionPerformed

    private void btnBlockInSectorWriteAKM1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockInSectorWriteAKM1ActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);           
          byte  bSectorAddress = 0;
          byte  bBlockAddress  = 0;
          byte[] baBlockData   = new byte[MAX_BLOCK_BYTES];
          
        if (txtBlockInSectorWriteAKM1.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockInSectorWriteAKM1.requestFocus();
             return;
        }
        if (txtSectorAddressWriteAKM1.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtSectorAddressWriteAKM1.requestFocus();
             return;
         }
          if (txtBlockAddressWriteAKM1.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockAddressWriteAKM1.requestFocus();
             return;
         }
          
         baBlockData   =(txtBlockInSectorWriteAKM1.getText().getBytes() );
         bSectorAddress=Byte.parseByte(txtSectorAddressWriteAKM1.getText().trim());
         bBlockAddress =Byte.parseByte(txtBlockAddressWriteAKM1.getText().trim());
         
         iFResult=Declarations.uFrFunctions.uFrInstance.BlockInSectorWrite_AKM1(baBlockData,bSectorAddress,bBlockAddress,bAuthMode);
         
         if (iFResult==DL_OK){               
             Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
              M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
              }
           catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, GLFunctions.APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockInSectorWriteAKM1ActionPerformed

    private void btnBlockInSectorWriteAKM2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockInSectorWriteAKM2ActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);           
          byte  bSectorAddress = 0;
          byte  bBlockAddress  = 0;
          byte[] baBlockData   = new byte[MAX_BLOCK_BYTES];
          
        if (txtBlockInSectorWriteAKM2.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockInSectorWriteAKM2.requestFocus();
             return;
        }
        if (txtSectorAddressWriteAKM2.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtSectorAddressWriteAKM2.requestFocus();
             return;
         }
          if (txtBlockAddressWriteAKM2.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockAddressWriteAKM2.requestFocus();
             return;
         }
          
          baBlockData    =(txtBlockInSectorWriteAKM2.getText().getBytes() );
          bSectorAddress =Byte.parseByte(txtSectorAddressWriteAKM2.getText().trim());
          bBlockAddress  =Byte.parseByte(txtBlockAddressWriteAKM2.getText().trim());         
          iFResult=Declarations.uFrFunctions.uFrInstance.BlockInSectorWrite_AKM2(baBlockData,bSectorAddress,bBlockAddress,bAuthMode);
         
         if (iFResult==DL_OK){               
              Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
              M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
      }
           catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, GLFunctions.APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockInSectorWriteAKM2ActionPerformed

    private void btnBlockInSectorWritePKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBlockInSectorWritePKActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult       = 0;
          byte  bAuthMode      = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);           
          byte  bSectorAddress = 0;
          byte  bBlockAddress  = 0;
          byte[] baBlockData   = new byte[MAX_BLOCK_BYTES];
          
        if (txtBlockInSectorWritePK.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockInSectorWritePK.requestFocus();
             return;
        }
        if (txtSectorAddressWritePK.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter SECTOR ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtSectorAddressWritePK.requestFocus();
             return;
         }
          if (txtBlockAddressWritePK.getText().trim().isEmpty()) {
             JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
             txtBlockAddressWritePK.requestFocus();
             return;
         }
          
         baBlockData   =(txtBlockInSectorWritePK.getText().getBytes() );
         bSectorAddress=Byte.parseByte(txtSectorAddressWritePK.getText().trim());
         bBlockAddress =Byte.parseByte(txtBlockAddressWritePK.getText().trim());
         
         iFResult=Declarations.uFrFunctions.uFrInstance.BlockInSectorWrite_PK(baBlockData, bSectorAddress, bBlockAddress, bAuthMode,new GLFunctions().PK_KEY(pnlPKKey));
         
         if (iFResult==DL_OK){               
              Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
              M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            } else {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
            }
       }
           catch(NumberFormatException NfeX)
      {
          JOptionPane.showMessageDialog(rootPane, GLFunctions.APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
      }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnBlockInSectorWritePKActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnBlockInSectorRead;
    private javax.swing.JButton btnBlockInSectorReadAKM1;
    private javax.swing.JButton btnBlockInSectorReadAKM2;
    private javax.swing.JButton btnBlockInSectorReadPK;
    private javax.swing.JButton btnBlockInSectorWrite;
    private javax.swing.JButton btnBlockInSectorWriteAKM1;
    private javax.swing.JButton btnBlockInSectorWriteAKM2;
    private javax.swing.JButton btnBlockInSectorWritePK;
    private javax.swing.JComboBox cboKeyIndex;
    private javax.swing.JLabel lblBlockAddressRead;
    private javax.swing.JLabel lblBlockAddressReadAKM1;
    private javax.swing.JLabel lblBlockAddressReadAKM2;
    private javax.swing.JLabel lblBlockAddressReadPK;
    private javax.swing.JLabel lblBlockAddressWrite;
    private javax.swing.JLabel lblBlockAddressWriteAKM1;
    private javax.swing.JLabel lblBlockAddressWriteAKM2;
    private javax.swing.JLabel lblBlockAddressWritePK;
    private javax.swing.JLabel lblBlockInSectorRead;
    private javax.swing.JLabel lblBlockInSectorReadAKM1;
    private javax.swing.JLabel lblBlockInSectorReadAKM2;
    private javax.swing.JLabel lblBlockInSectorReadData;
    private javax.swing.JLabel lblBlockInSectorReadDataAKM1;
    private javax.swing.JLabel lblBlockInSectorReadDataAKM2;
    private javax.swing.JLabel lblBlockInSectorReadDataPK;
    private javax.swing.JLabel lblBlockInSectorReadPK;
    private javax.swing.JLabel lblBlockInSectorWrite;
    private javax.swing.JLabel lblBlockInSectorWriteAKM1;
    private javax.swing.JLabel lblBlockInSectorWriteAKM2;
    private javax.swing.JLabel lblBlockInSectorWriteData;
    private javax.swing.JLabel lblBlockInSectorWriteDataAKM1;
    private javax.swing.JLabel lblBlockInSectorWriteDataAKM2;
    private javax.swing.JLabel lblBlockInSectorWriteDataPK;
    private javax.swing.JLabel lblBlockInSectorWritePK;
    private javax.swing.JLabel lblKeyIndex;
    private javax.swing.JLabel lblPKKey;
    private javax.swing.JLabel lblSectorAddressRead;
    private javax.swing.JLabel lblSectorAddressReadAKM1;
    private javax.swing.JLabel lblSectorAddressReadAKM2;
    private javax.swing.JLabel lblSectorAddressReadPK;
    private javax.swing.JLabel lblSectorAddressWrite;
    private javax.swing.JLabel lblSectorAddressWriteAKM1;
    private javax.swing.JLabel lblSectorAddressWriteAKM2;
    private javax.swing.JLabel lblSectorAddressWritePK;
    private javax.swing.JPanel pnlBlockInSectorRead;
    private javax.swing.JPanel pnlBlockInSectorReadAKM1;
    private javax.swing.JPanel pnlBlockInSectorReadAKM2;
    private javax.swing.JPanel pnlBlockInSectorReadPK;
    private javax.swing.JPanel pnlBlockInSectorWrite;
    private javax.swing.JPanel pnlBlockInSectorWriteAKM1;
    private javax.swing.JPanel pnlBlockInSectorWriteAKM2;
    private javax.swing.JPanel pnlBlockInSectorWritePK;
    private javax.swing.JPanel pnlPKKey;
    private javax.swing.JRadioButton rbAUTH1A;
    private javax.swing.JRadioButton rbAUTH1B;
    private javax.swing.ButtonGroup rbtnRadioButton;
    private javax.swing.JPanel tabBlockInSectorRead;
    private javax.swing.JTabbedPane tabBlockInSectorReadWrite;
    private javax.swing.JPanel tabBlockInSectorWrite;
    private javax.swing.JTextField txtBlockAddressRead;
    private javax.swing.JTextField txtBlockAddressReadAKM1;
    private javax.swing.JTextField txtBlockAddressReadAKM2;
    private javax.swing.JTextField txtBlockAddressReadPK;
    private javax.swing.JTextField txtBlockAddressWrite;
    private javax.swing.JTextField txtBlockAddressWriteAKM1;
    private javax.swing.JTextField txtBlockAddressWriteAKM2;
    private javax.swing.JTextField txtBlockAddressWritePK;
    private javax.swing.JTextField txtBlockInSectorRead;
    private javax.swing.JTextField txtBlockInSectorReadAKM1;
    private javax.swing.JTextField txtBlockInSectorReadAKM2;
    private javax.swing.JTextField txtBlockInSectorReadPK;
    private javax.swing.JTextField txtBlockInSectorWrite;
    private javax.swing.JTextField txtBlockInSectorWriteAKM1;
    private javax.swing.JTextField txtBlockInSectorWriteAKM2;
    private javax.swing.JTextField txtBlockInSectorWritePK;
    private javax.swing.JTextField txtFErrorCode;
    private javax.swing.JTextField txtFErrorExplain;
    private javax.swing.JTextField txtFunctionStatus;
    private javax.swing.JTextField txtSectorAddressRead;
    private javax.swing.JTextField txtSectorAddressReadAKM1;
    private javax.swing.JTextField txtSectorAddressReadAKM2;
    private javax.swing.JTextField txtSectorAddressReadPK;
    private javax.swing.JTextField txtSectorAddressWrite;
    private javax.swing.JTextField txtSectorAddressWriteAKM1;
    private javax.swing.JTextField txtSectorAddressWriteAKM2;
    private javax.swing.JTextField txtSectorAddressWritePK;
    // End of variables declaration//GEN-END:variables

}
