

package ufcoderadvancedapplet;

import javax.swing.JOptionPane;


public class frmValueBlockIncrementDecrement extends javax.swing.JInternalFrame {
    static final int 
         FUNCT_LIGHT_OK     = 4,
         FUNCT_SOUND_OK     = 0,//4 Tripple sound
         FUNCT_LIGHT_ERROR  = 2,
         FUNCT_SOUND_ERROR  = 0,//2 Long sound
         DL_OK              = 0;
    
    static final byte
         MIFARE_AUTHENT1A   = 0x60,  
         MIFARE_AUTHENT1B   = 0x61,
         MAX_BLOCK_BYTES    = 16;
    
    
    final static String ANY_DATA            = "You must enter any data !",
                        APPROPRIATE_FORMAT  = "You must enter the appropriate format !";
    
    public frmValueBlockIncrementDecrement() {
        initComponents();
        new GLFunctions().CreatePKBox(pnlPKKey,29,20,13,350,"txtPKKey");
    }

    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        rbtnRadioGroup = new javax.swing.ButtonGroup();
        pnlPKKey = new javax.swing.JPanel();
        rbAUTH1A = new javax.swing.JRadioButton();
        rbAUTH1B = new javax.swing.JRadioButton();
        lblKeyIndex = new javax.swing.JLabel();
        cboKeyIndex = new javax.swing.JComboBox();
        lblPKKey = new javax.swing.JLabel();
        tabValueBlockIncrDecr = new javax.swing.JTabbedPane();
        tabValueBlockIncrement = new javax.swing.JPanel();
        pnlValueBlockIncr = new javax.swing.JPanel();
        txtIncrementValue = new javax.swing.JTextField();
        txtBlockAddress = new javax.swing.JTextField();
        btnValueBlockIncrement = new javax.swing.JButton();
        lblValueBlockIncr = new javax.swing.JLabel();
        lblIncrementValue = new javax.swing.JLabel();
        lblBlockAddress = new javax.swing.JLabel();
        pnlValueBlockIncrAKM1 = new javax.swing.JPanel();
        txtIncrementValueAKM1 = new javax.swing.JTextField();
        txtBlockAddressAKM1 = new javax.swing.JTextField();
        btnValueBlockIncrementAKM1 = new javax.swing.JButton();
        lblValueBlockIncrAKM1 = new javax.swing.JLabel();
        lblIncrementValueAKM1 = new javax.swing.JLabel();
        lblBlockAddressAKM1 = new javax.swing.JLabel();
        pnlValueBlockIncrAKM2 = new javax.swing.JPanel();
        txtIncrementValueAKM2 = new javax.swing.JTextField();
        txtBlockAddressAKM2 = new javax.swing.JTextField();
        btnValueBlockIncrementAKM2 = new javax.swing.JButton();
        lblValueBlockIncrAKM2 = new javax.swing.JLabel();
        lblIncrementValueAKM2 = new javax.swing.JLabel();
        lblBlockAddressAKM2 = new javax.swing.JLabel();
        pnlValueBlockIncrPK = new javax.swing.JPanel();
        txtIncrementValuePK = new javax.swing.JTextField();
        txtBlockAddressPK = new javax.swing.JTextField();
        btnValueBlockIncrementPK = new javax.swing.JButton();
        lblValueBlockIncrPK = new javax.swing.JLabel();
        lblIncrementValuePK = new javax.swing.JLabel();
        lblBlockAddressPK = new javax.swing.JLabel();
        tabValueBlockDecrement = new javax.swing.JPanel();
        pnlValueBlockDecr = new javax.swing.JPanel();
        txtDecrementValue = new javax.swing.JTextField();
        txtBlockAddressDecrement = new javax.swing.JTextField();
        btnValueBlockDecrement = new javax.swing.JButton();
        lblValueBlockDecrement = new javax.swing.JLabel();
        lblDecrementValue = new javax.swing.JLabel();
        lblBlockAddressDecrement = new javax.swing.JLabel();
        pnlValueBlockDecrAKM1 = new javax.swing.JPanel();
        txtDecrementValueAKM1 = new javax.swing.JTextField();
        txtBlockAddressDecrementAKM1 = new javax.swing.JTextField();
        btnValueBlockDecrementAKM1 = new javax.swing.JButton();
        lblValueBlockDecrementAKM1 = new javax.swing.JLabel();
        lblDecrementValueAKM1 = new javax.swing.JLabel();
        lblBlockAddressDecrementAKM1 = new javax.swing.JLabel();
        pnlValueBlockDecrAKM2 = new javax.swing.JPanel();
        txtDecrementValueAKM2 = new javax.swing.JTextField();
        txtBlockAddressDecrementAKM2 = new javax.swing.JTextField();
        btnValueBlockDecrementAKM2 = new javax.swing.JButton();
        lblValueBlockDecrementAKM2 = new javax.swing.JLabel();
        lblDecrementValueAKM2 = new javax.swing.JLabel();
        lblBlockAddressDecrementAKM2 = new javax.swing.JLabel();
        pnlValueBlockDecrPK = new javax.swing.JPanel();
        txtDecrementValuePK = new javax.swing.JTextField();
        txtBlockAddressDecrementPK = new javax.swing.JTextField();
        btnValueBlockDecrementPK = new javax.swing.JButton();
        lblValueBlockDecrementPK = new javax.swing.JLabel();
        lblDecrementValuePK = new javax.swing.JLabel();
        lblBlockAddressDecrementPK = new javax.swing.JLabel();
        txtFunctionStatus = new javax.swing.JTextField();
        txtFErrorCode = new javax.swing.JTextField();
        txtFErrorExplain = new javax.swing.JTextField();

        setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        setTitle("frmValueBlockIncrementDecrement");
        setMaximumSize(new java.awt.Dimension(660, 435));
        setName("frmValueBlockIncrDecr"); // NOI18N
        setPreferredSize(new java.awt.Dimension(569, 448));
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlPKKey.setBackground(new java.awt.Color(255, 255, 255));
        pnlPKKey.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        rbAUTH1A.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioGroup.add(rbAUTH1A);
        rbAUTH1A.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1A.setSelected(true);
        rbAUTH1A.setText("AUTH 1A");
        rbAUTH1A.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        rbAUTH1B.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioGroup.add(rbAUTH1B);
        rbAUTH1B.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1B.setText("AUTH 1B");
        rbAUTH1B.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblKeyIndex.setText("Key Index");

        cboKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        cboKeyIndex.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", " " }));
        cboKeyIndex.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblPKKey.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblPKKey.setText("PK Key");

        javax.swing.GroupLayout pnlPKKeyLayout = new javax.swing.GroupLayout(pnlPKKey);
        pnlPKKey.setLayout(pnlPKKeyLayout);
        pnlPKKeyLayout.setHorizontalGroup(
            pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPKKeyLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(rbAUTH1A)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rbAUTH1B)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lblKeyIndex)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(10, 10, 10)
                .addComponent(lblPKKey)
                .addContainerGap(252, Short.MAX_VALUE))
        );
        pnlPKKeyLayout.setVerticalGroup(
            pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPKKeyLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblPKKey)
                    .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblKeyIndex)
                    .addComponent(rbAUTH1A)
                    .addComponent(rbAUTH1B))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        getContentPane().add(pnlPKKey, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 570, 40));

        tabValueBlockIncrDecr.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N

        tabValueBlockIncrement.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabValueBlockIncrement.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlValueBlockIncr.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtIncrementValue.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtIncrementValue.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtIncrementValue.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddress.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddress.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddress.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnValueBlockIncrement.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockIncrement.setText("INCREMENT");
        btnValueBlockIncrement.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnValueBlockIncrement.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockIncrement.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockIncrementActionPerformed(evt);
            }
        });

        lblValueBlockIncr.setBackground(new java.awt.Color(153, 153, 153));
        lblValueBlockIncr.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockIncr.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockIncr.setText("ValueBlock Increment");
        lblValueBlockIncr.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockIncr.setOpaque(true);

        lblIncrementValue.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblIncrementValue.setText("Increment Value");

        lblBlockAddress.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddress.setText("Block Address");

        javax.swing.GroupLayout pnlValueBlockIncrLayout = new javax.swing.GroupLayout(pnlValueBlockIncr);
        pnlValueBlockIncr.setLayout(pnlValueBlockIncrLayout);
        pnlValueBlockIncrLayout.setHorizontalGroup(
            pnlValueBlockIncrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockIncrLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlValueBlockIncrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnValueBlockIncrement, javax.swing.GroupLayout.PREFERRED_SIZE, 211, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlValueBlockIncrLayout.createSequentialGroup()
                        .addGroup(pnlValueBlockIncrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblIncrementValue)
                            .addComponent(lblBlockAddress))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(pnlValueBlockIncrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtIncrementValue)
                            .addComponent(txtBlockAddress, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(20, 20, 20))
            .addGroup(pnlValueBlockIncrLayout.createSequentialGroup()
                .addComponent(lblValueBlockIncr, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pnlValueBlockIncrLayout.setVerticalGroup(
            pnlValueBlockIncrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockIncrLayout.createSequentialGroup()
                .addComponent(lblValueBlockIncr)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockIncrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblIncrementValue)
                    .addComponent(txtIncrementValue, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockIncrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblBlockAddress)
                    .addComponent(txtBlockAddress, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btnValueBlockIncrement, javax.swing.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabValueBlockIncrement.add(pnlValueBlockIncr, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 12, 233, -1));

        pnlValueBlockIncrAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtIncrementValueAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtIncrementValueAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtIncrementValueAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnValueBlockIncrementAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockIncrementAKM1.setText("INCREMENT");
        btnValueBlockIncrementAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnValueBlockIncrementAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockIncrementAKM1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockIncrementAKM1ActionPerformed(evt);
            }
        });

        lblValueBlockIncrAKM1.setBackground(new java.awt.Color(153, 153, 153));
        lblValueBlockIncrAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockIncrAKM1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockIncrAKM1.setText("ValueBlock Increment AKM1");
        lblValueBlockIncrAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockIncrAKM1.setOpaque(true);

        lblIncrementValueAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblIncrementValueAKM1.setText("Increment Value");

        lblBlockAddressAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressAKM1.setText("Block Address");

        javax.swing.GroupLayout pnlValueBlockIncrAKM1Layout = new javax.swing.GroupLayout(pnlValueBlockIncrAKM1);
        pnlValueBlockIncrAKM1.setLayout(pnlValueBlockIncrAKM1Layout);
        pnlValueBlockIncrAKM1Layout.setHorizontalGroup(
            pnlValueBlockIncrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockIncrAKM1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlValueBlockIncrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnValueBlockIncrementAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 211, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlValueBlockIncrAKM1Layout.createSequentialGroup()
                        .addGroup(pnlValueBlockIncrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblIncrementValueAKM1)
                            .addComponent(lblBlockAddressAKM1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(pnlValueBlockIncrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtIncrementValueAKM1)
                            .addComponent(txtBlockAddressAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(20, 20, 20))
            .addGroup(pnlValueBlockIncrAKM1Layout.createSequentialGroup()
                .addComponent(lblValueBlockIncrAKM1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pnlValueBlockIncrAKM1Layout.setVerticalGroup(
            pnlValueBlockIncrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockIncrAKM1Layout.createSequentialGroup()
                .addComponent(lblValueBlockIncrAKM1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockIncrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblIncrementValueAKM1)
                    .addComponent(txtIncrementValueAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockIncrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblBlockAddressAKM1)
                    .addComponent(txtBlockAddressAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btnValueBlockIncrementAKM1, javax.swing.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabValueBlockIncrement.add(pnlValueBlockIncrAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(272, 12, 233, -1));

        pnlValueBlockIncrAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtIncrementValueAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtIncrementValueAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtIncrementValueAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnValueBlockIncrementAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockIncrementAKM2.setText("INCREMENT");
        btnValueBlockIncrementAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnValueBlockIncrementAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockIncrementAKM2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockIncrementAKM2ActionPerformed(evt);
            }
        });

        lblValueBlockIncrAKM2.setBackground(new java.awt.Color(153, 153, 153));
        lblValueBlockIncrAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockIncrAKM2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockIncrAKM2.setText("ValueBlock Increment AKM2");
        lblValueBlockIncrAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockIncrAKM2.setOpaque(true);

        lblIncrementValueAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblIncrementValueAKM2.setText("Increment Value");

        lblBlockAddressAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressAKM2.setText("Block Address");

        javax.swing.GroupLayout pnlValueBlockIncrAKM2Layout = new javax.swing.GroupLayout(pnlValueBlockIncrAKM2);
        pnlValueBlockIncrAKM2.setLayout(pnlValueBlockIncrAKM2Layout);
        pnlValueBlockIncrAKM2Layout.setHorizontalGroup(
            pnlValueBlockIncrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockIncrAKM2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlValueBlockIncrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnValueBlockIncrementAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 211, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlValueBlockIncrAKM2Layout.createSequentialGroup()
                        .addGroup(pnlValueBlockIncrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblIncrementValueAKM2)
                            .addComponent(lblBlockAddressAKM2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(pnlValueBlockIncrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtIncrementValueAKM2)
                            .addComponent(txtBlockAddressAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(20, 20, 20))
            .addGroup(pnlValueBlockIncrAKM2Layout.createSequentialGroup()
                .addComponent(lblValueBlockIncrAKM2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pnlValueBlockIncrAKM2Layout.setVerticalGroup(
            pnlValueBlockIncrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockIncrAKM2Layout.createSequentialGroup()
                .addComponent(lblValueBlockIncrAKM2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockIncrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblIncrementValueAKM2)
                    .addComponent(txtIncrementValueAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockIncrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblBlockAddressAKM2)
                    .addComponent(txtBlockAddressAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btnValueBlockIncrementAKM2, javax.swing.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabValueBlockIncrement.add(pnlValueBlockIncrAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 155, 233, -1));

        pnlValueBlockIncrPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtIncrementValuePK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtIncrementValuePK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtIncrementValuePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnValueBlockIncrementPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockIncrementPK.setText("INCREMENT");
        btnValueBlockIncrementPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnValueBlockIncrementPK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockIncrementPK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockIncrementPKActionPerformed(evt);
            }
        });

        lblValueBlockIncrPK.setBackground(new java.awt.Color(153, 153, 153));
        lblValueBlockIncrPK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockIncrPK.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockIncrPK.setText("ValueBlock Increment PK");
        lblValueBlockIncrPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockIncrPK.setOpaque(true);

        lblIncrementValuePK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblIncrementValuePK.setText("Increment Value");

        lblBlockAddressPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressPK.setText("Block Address");

        javax.swing.GroupLayout pnlValueBlockIncrPKLayout = new javax.swing.GroupLayout(pnlValueBlockIncrPK);
        pnlValueBlockIncrPK.setLayout(pnlValueBlockIncrPKLayout);
        pnlValueBlockIncrPKLayout.setHorizontalGroup(
            pnlValueBlockIncrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockIncrPKLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlValueBlockIncrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnValueBlockIncrementPK, javax.swing.GroupLayout.PREFERRED_SIZE, 211, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlValueBlockIncrPKLayout.createSequentialGroup()
                        .addGroup(pnlValueBlockIncrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblIncrementValuePK)
                            .addComponent(lblBlockAddressPK))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(pnlValueBlockIncrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtIncrementValuePK)
                            .addComponent(txtBlockAddressPK, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(20, 20, 20))
            .addGroup(pnlValueBlockIncrPKLayout.createSequentialGroup()
                .addComponent(lblValueBlockIncrPK, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pnlValueBlockIncrPKLayout.setVerticalGroup(
            pnlValueBlockIncrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockIncrPKLayout.createSequentialGroup()
                .addComponent(lblValueBlockIncrPK)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockIncrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblIncrementValuePK)
                    .addComponent(txtIncrementValuePK, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockIncrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblBlockAddressPK)
                    .addComponent(txtBlockAddressPK, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btnValueBlockIncrementPK, javax.swing.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabValueBlockIncrement.add(pnlValueBlockIncrPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(272, 155, 233, -1));

        tabValueBlockIncrDecr.addTab("ValueBlock Increment", tabValueBlockIncrement);

        tabValueBlockDecrement.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabValueBlockDecrement.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlValueBlockDecr.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtDecrementValue.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtDecrementValue.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtDecrementValue.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressDecrement.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressDecrement.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressDecrement.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnValueBlockDecrement.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockDecrement.setText("DECREMENT");
        btnValueBlockDecrement.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnValueBlockDecrement.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockDecrement.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockDecrementActionPerformed(evt);
            }
        });

        lblValueBlockDecrement.setBackground(new java.awt.Color(153, 153, 153));
        lblValueBlockDecrement.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockDecrement.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockDecrement.setText("ValueBlock Decrement");
        lblValueBlockDecrement.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockDecrement.setOpaque(true);

        lblDecrementValue.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblDecrementValue.setText("Decrement Value");

        lblBlockAddressDecrement.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressDecrement.setText("Block Address");

        javax.swing.GroupLayout pnlValueBlockDecrLayout = new javax.swing.GroupLayout(pnlValueBlockDecr);
        pnlValueBlockDecr.setLayout(pnlValueBlockDecrLayout);
        pnlValueBlockDecrLayout.setHorizontalGroup(
            pnlValueBlockDecrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockDecrLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlValueBlockDecrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnValueBlockDecrement, javax.swing.GroupLayout.PREFERRED_SIZE, 211, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlValueBlockDecrLayout.createSequentialGroup()
                        .addGroup(pnlValueBlockDecrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblDecrementValue)
                            .addComponent(lblBlockAddressDecrement))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(pnlValueBlockDecrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtDecrementValue)
                            .addComponent(txtBlockAddressDecrement, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(20, 20, 20))
            .addGroup(pnlValueBlockDecrLayout.createSequentialGroup()
                .addComponent(lblValueBlockDecrement, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pnlValueBlockDecrLayout.setVerticalGroup(
            pnlValueBlockDecrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockDecrLayout.createSequentialGroup()
                .addComponent(lblValueBlockDecrement)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockDecrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblDecrementValue)
                    .addComponent(txtDecrementValue, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockDecrLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblBlockAddressDecrement)
                    .addComponent(txtBlockAddressDecrement, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btnValueBlockDecrement, javax.swing.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabValueBlockDecrement.add(pnlValueBlockDecr, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 12, 233, -1));

        pnlValueBlockDecrAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtDecrementValueAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtDecrementValueAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtDecrementValueAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressDecrementAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressDecrementAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressDecrementAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnValueBlockDecrementAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockDecrementAKM1.setText("DECREMENT");
        btnValueBlockDecrementAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnValueBlockDecrementAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockDecrementAKM1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockDecrementAKM1ActionPerformed(evt);
            }
        });

        lblValueBlockDecrementAKM1.setBackground(new java.awt.Color(153, 153, 153));
        lblValueBlockDecrementAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockDecrementAKM1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockDecrementAKM1.setText("ValueBlock Decrement AKM1");
        lblValueBlockDecrementAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockDecrementAKM1.setOpaque(true);

        lblDecrementValueAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblDecrementValueAKM1.setText("Decrement Value");

        lblBlockAddressDecrementAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressDecrementAKM1.setText("Block Address");

        javax.swing.GroupLayout pnlValueBlockDecrAKM1Layout = new javax.swing.GroupLayout(pnlValueBlockDecrAKM1);
        pnlValueBlockDecrAKM1.setLayout(pnlValueBlockDecrAKM1Layout);
        pnlValueBlockDecrAKM1Layout.setHorizontalGroup(
            pnlValueBlockDecrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockDecrAKM1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlValueBlockDecrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnValueBlockDecrementAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 211, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlValueBlockDecrAKM1Layout.createSequentialGroup()
                        .addGroup(pnlValueBlockDecrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblDecrementValueAKM1)
                            .addComponent(lblBlockAddressDecrementAKM1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(pnlValueBlockDecrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtDecrementValueAKM1)
                            .addComponent(txtBlockAddressDecrementAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(20, 20, 20))
            .addGroup(pnlValueBlockDecrAKM1Layout.createSequentialGroup()
                .addComponent(lblValueBlockDecrementAKM1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pnlValueBlockDecrAKM1Layout.setVerticalGroup(
            pnlValueBlockDecrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockDecrAKM1Layout.createSequentialGroup()
                .addComponent(lblValueBlockDecrementAKM1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockDecrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblDecrementValueAKM1)
                    .addComponent(txtDecrementValueAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockDecrAKM1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblBlockAddressDecrementAKM1)
                    .addComponent(txtBlockAddressDecrementAKM1, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btnValueBlockDecrementAKM1, javax.swing.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabValueBlockDecrement.add(pnlValueBlockDecrAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(272, 12, 233, -1));

        pnlValueBlockDecrAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtDecrementValueAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtDecrementValueAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtDecrementValueAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressDecrementAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressDecrementAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressDecrementAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnValueBlockDecrementAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockDecrementAKM2.setText("DECREMENT");
        btnValueBlockDecrementAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnValueBlockDecrementAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockDecrementAKM2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockDecrementAKM2ActionPerformed(evt);
            }
        });

        lblValueBlockDecrementAKM2.setBackground(new java.awt.Color(153, 153, 153));
        lblValueBlockDecrementAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockDecrementAKM2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockDecrementAKM2.setText("ValueBlock Decrement AKM2");
        lblValueBlockDecrementAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockDecrementAKM2.setOpaque(true);

        lblDecrementValueAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblDecrementValueAKM2.setText("Decrement Value");

        lblBlockAddressDecrementAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressDecrementAKM2.setText("Block Address");

        javax.swing.GroupLayout pnlValueBlockDecrAKM2Layout = new javax.swing.GroupLayout(pnlValueBlockDecrAKM2);
        pnlValueBlockDecrAKM2.setLayout(pnlValueBlockDecrAKM2Layout);
        pnlValueBlockDecrAKM2Layout.setHorizontalGroup(
            pnlValueBlockDecrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockDecrAKM2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlValueBlockDecrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnValueBlockDecrementAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 211, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlValueBlockDecrAKM2Layout.createSequentialGroup()
                        .addGroup(pnlValueBlockDecrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblDecrementValueAKM2)
                            .addComponent(lblBlockAddressDecrementAKM2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(pnlValueBlockDecrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtDecrementValueAKM2)
                            .addComponent(txtBlockAddressDecrementAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(20, 20, 20))
            .addGroup(pnlValueBlockDecrAKM2Layout.createSequentialGroup()
                .addComponent(lblValueBlockDecrementAKM2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pnlValueBlockDecrAKM2Layout.setVerticalGroup(
            pnlValueBlockDecrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockDecrAKM2Layout.createSequentialGroup()
                .addComponent(lblValueBlockDecrementAKM2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockDecrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblDecrementValueAKM2)
                    .addComponent(txtDecrementValueAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockDecrAKM2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblBlockAddressDecrementAKM2)
                    .addComponent(txtBlockAddressDecrementAKM2, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btnValueBlockDecrementAKM2, javax.swing.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabValueBlockDecrement.add(pnlValueBlockDecrAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 157, 233, -1));

        pnlValueBlockDecrPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtDecrementValuePK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtDecrementValuePK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtDecrementValuePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressDecrementPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressDecrementPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressDecrementPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnValueBlockDecrementPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockDecrementPK.setText("DECREMENT");
        btnValueBlockDecrementPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        btnValueBlockDecrementPK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockDecrementPK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockDecrementPKActionPerformed(evt);
            }
        });

        lblValueBlockDecrementPK.setBackground(new java.awt.Color(153, 153, 153));
        lblValueBlockDecrementPK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockDecrementPK.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockDecrementPK.setText("ValueBlock Decrement PK");
        lblValueBlockDecrementPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockDecrementPK.setOpaque(true);

        lblDecrementValuePK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblDecrementValuePK.setText("Decrement Value");

        lblBlockAddressDecrementPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressDecrementPK.setText("Block Address");

        javax.swing.GroupLayout pnlValueBlockDecrPKLayout = new javax.swing.GroupLayout(pnlValueBlockDecrPK);
        pnlValueBlockDecrPK.setLayout(pnlValueBlockDecrPKLayout);
        pnlValueBlockDecrPKLayout.setHorizontalGroup(
            pnlValueBlockDecrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockDecrPKLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlValueBlockDecrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnValueBlockDecrementPK, javax.swing.GroupLayout.PREFERRED_SIZE, 211, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlValueBlockDecrPKLayout.createSequentialGroup()
                        .addGroup(pnlValueBlockDecrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblDecrementValuePK)
                            .addComponent(lblBlockAddressDecrementPK))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(pnlValueBlockDecrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtDecrementValuePK)
                            .addComponent(txtBlockAddressDecrementPK, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(20, 20, 20))
            .addGroup(pnlValueBlockDecrPKLayout.createSequentialGroup()
                .addComponent(lblValueBlockDecrementPK, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pnlValueBlockDecrPKLayout.setVerticalGroup(
            pnlValueBlockDecrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockDecrPKLayout.createSequentialGroup()
                .addComponent(lblValueBlockDecrementPK)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockDecrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblDecrementValuePK)
                    .addComponent(txtDecrementValuePK, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockDecrPKLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblBlockAddressDecrementPK)
                    .addComponent(txtBlockAddressDecrementPK, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btnValueBlockDecrementPK, javax.swing.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabValueBlockDecrement.add(pnlValueBlockDecrPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(272, 157, 233, -1));

        tabValueBlockIncrDecr.addTab("ValueBlock Decrement", tabValueBlockDecrement);

        getContentPane().add(tabValueBlockIncrDecr, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 50, 520, 330));

        txtFunctionStatus.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFunctionStatus.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtFunctionStatus.setText("Function Status");
        getContentPane().add(txtFunctionStatus, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 390, 140, -1));

        txtFErrorCode.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorCode.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorCode, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 390, 70, -1));

        txtFErrorExplain.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorExplain.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorExplain, new org.netbeans.lib.awtextra.AbsoluteConstraints(210, 390, 350, -1));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnValueBlockIncrementActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockIncrementActionPerformed
        frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                               
          int   iIncDecValue             = 0;
          byte  bKeyIndex                = (byte)cboKeyIndex.getSelectedIndex();
                
            if (txtIncrementValue.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter INCREMENT VALUE !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtIncrementValue.requestFocus();
                return;
            }
            if (txtBlockAddress.getText().trim().isEmpty()) {
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtBlockAddress.requestFocus();
                return;                
            }
            
            iIncDecValue=Integer.parseInt(txtIncrementValue.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddress.getText().trim());
            
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockIncrement(iIncDecValue,bBlockAddress,bAuthMode, bKeyIndex);
            
            if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
    }//GEN-LAST:event_btnValueBlockIncrementActionPerformed

    private void btnValueBlockIncrementAKM1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockIncrementAKM1ActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                               
          int   iIncDecValue             = 0;
          
            if (txtIncrementValueAKM1.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter INCREMENT VALUE !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtIncrementValueAKM1.requestFocus();
                return;
            }
            if (txtBlockAddressAKM1.getText().trim().isEmpty()) {
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtBlockAddressAKM1.requestFocus();
                return;
            }
            
            iIncDecValue=Integer.parseInt(txtIncrementValueAKM1.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddressAKM1.getText().trim());
            
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockIncrement_AKM1(iIncDecValue,bBlockAddress,bAuthMode);
            
            if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
    }//GEN-LAST:event_btnValueBlockIncrementAKM1ActionPerformed

    private void btnValueBlockIncrementAKM2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockIncrementAKM2ActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                               
          int   iIncDecValue             = 0;
          
            if (txtIncrementValueAKM2.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter INCREMENT VALUE !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtIncrementValueAKM2.requestFocus();
                return;
            }
            if (txtBlockAddressAKM2.getText().trim().isEmpty()) {
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtBlockAddressAKM2.requestFocus();
                return;
            }
            
            iIncDecValue=Integer.parseInt(txtIncrementValueAKM2.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddressAKM2.getText().trim());            
            
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockIncrement_AKM2(iIncDecValue,bBlockAddress,bAuthMode);
           if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
        
    }//GEN-LAST:event_btnValueBlockIncrementAKM2ActionPerformed

    private void btnValueBlockIncrementPKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockIncrementPKActionPerformed
   frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                               
          int   iIncDecValue             = 0;
          
            if (txtIncrementValuePK.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter INCREMENT VALUE !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtIncrementValuePK.requestFocus();
                return;
            }
            if (txtBlockAddressPK.getText().trim().isEmpty()) {
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtBlockAddressPK.requestFocus();
                return;
            }
          
            iIncDecValue=Integer.parseInt(txtIncrementValuePK.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddressPK.getText().trim());
            
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockIncrement_PK(iIncDecValue,bBlockAddress,bAuthMode,new GLFunctions().PK_KEY(pnlPKKey));
          if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
    }//GEN-LAST:event_btnValueBlockIncrementPKActionPerformed

    private void btnValueBlockDecrementActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockDecrementActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                               
          int   iIncDecValue             = 0;
          byte  bKeyIndex                = (byte)cboKeyIndex.getSelectedIndex();
          
            if (txtDecrementValue.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter DECREMENT VALUE !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtDecrementValue.requestFocus();
                return;
            }
            if (txtBlockAddressDecrement.getText().trim().isEmpty()) {
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtBlockAddressDecrement.requestFocus();
                return;
            }
            
            iIncDecValue=Integer.parseInt(txtDecrementValue.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddressDecrement.getText().trim());
            
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockDecrement(iIncDecValue,bBlockAddress,bAuthMode, bKeyIndex);
             if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
    }//GEN-LAST:event_btnValueBlockDecrementActionPerformed

    private void btnValueBlockDecrementAKM1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockDecrementAKM1ActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                               
          int   iIncDecValue             = 0;
          
            if (txtDecrementValueAKM1.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter DECREMENT VALUE !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtDecrementValueAKM1.requestFocus();
                return;
            }
            if (txtBlockAddressDecrementAKM1.getText().trim().isEmpty()) {
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtBlockAddressDecrementAKM1.requestFocus();
                return;
            }
            
            iIncDecValue=Integer.parseInt(txtDecrementValueAKM1.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddressDecrementAKM1.getText().trim());
            
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockDecrement_AKM1(iIncDecValue,bBlockAddress,bAuthMode);
             if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
    }//GEN-LAST:event_btnValueBlockDecrementAKM1ActionPerformed

    private void btnValueBlockDecrementAKM2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockDecrementAKM2ActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                               
          int   iIncDecValue             = 0;
          
            if (txtDecrementValueAKM2.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter DECREMENT VALUE !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtDecrementValueAKM2.requestFocus();
                return;
            }
            if (txtBlockAddressDecrementAKM2.getText().trim().isEmpty()) {
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtBlockAddressDecrementAKM2.requestFocus();
                return;
            }
            
            iIncDecValue=Integer.parseInt(txtDecrementValueAKM2.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddressDecrementAKM2.getText().trim());
            
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockDecrement_AKM2(iIncDecValue,bBlockAddress,bAuthMode);
           if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
    }//GEN-LAST:event_btnValueBlockDecrementAKM2ActionPerformed

    private void btnValueBlockDecrementPKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockDecrementPKActionPerformed
    frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                               
          int   iIncDecValue             = 0;
          
            if (txtDecrementValuePK.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter DECREMENT VALUE !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtDecrementValuePK.requestFocus();
                return;
            }
            if (txtBlockAddressDecrementPK.getText().trim().isEmpty()) { 
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",
                                              JOptionPane.WARNING_MESSAGE);
                txtBlockAddressDecrementPK.requestFocus();
                return;
            }
            
            iIncDecValue=Integer.parseInt(txtDecrementValuePK.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddressDecrementPK.getText().trim());
            
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockDecrement_PK(iIncDecValue,bBlockAddress,bAuthMode,new GLFunctions().PK_KEY(pnlPKKey)); 
         
            if (iFResult==DL_OK)
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
         else
         {
            Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
            M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
         }
       }
       catch(NumberFormatException NfeX)
       {
           JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT, "Error !", JOptionPane.ERROR_MESSAGE);
       }finally{
            M.SetFunct(false);
            
        }
    }//GEN-LAST:event_btnValueBlockDecrementPKActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnValueBlockDecrement;
    private javax.swing.JButton btnValueBlockDecrementAKM1;
    private javax.swing.JButton btnValueBlockDecrementAKM2;
    private javax.swing.JButton btnValueBlockDecrementPK;
    private javax.swing.JButton btnValueBlockIncrement;
    private javax.swing.JButton btnValueBlockIncrementAKM1;
    private javax.swing.JButton btnValueBlockIncrementAKM2;
    private javax.swing.JButton btnValueBlockIncrementPK;
    private javax.swing.JComboBox cboKeyIndex;
    private javax.swing.JLabel lblBlockAddress;
    private javax.swing.JLabel lblBlockAddressAKM1;
    private javax.swing.JLabel lblBlockAddressAKM2;
    private javax.swing.JLabel lblBlockAddressDecrement;
    private javax.swing.JLabel lblBlockAddressDecrementAKM1;
    private javax.swing.JLabel lblBlockAddressDecrementAKM2;
    private javax.swing.JLabel lblBlockAddressDecrementPK;
    private javax.swing.JLabel lblBlockAddressPK;
    private javax.swing.JLabel lblDecrementValue;
    private javax.swing.JLabel lblDecrementValueAKM1;
    private javax.swing.JLabel lblDecrementValueAKM2;
    private javax.swing.JLabel lblDecrementValuePK;
    private javax.swing.JLabel lblIncrementValue;
    private javax.swing.JLabel lblIncrementValueAKM1;
    private javax.swing.JLabel lblIncrementValueAKM2;
    private javax.swing.JLabel lblIncrementValuePK;
    private javax.swing.JLabel lblKeyIndex;
    private javax.swing.JLabel lblPKKey;
    private javax.swing.JLabel lblValueBlockDecrement;
    private javax.swing.JLabel lblValueBlockDecrementAKM1;
    private javax.swing.JLabel lblValueBlockDecrementAKM2;
    private javax.swing.JLabel lblValueBlockDecrementPK;
    private javax.swing.JLabel lblValueBlockIncr;
    private javax.swing.JLabel lblValueBlockIncrAKM1;
    private javax.swing.JLabel lblValueBlockIncrAKM2;
    private javax.swing.JLabel lblValueBlockIncrPK;
    private javax.swing.JPanel pnlPKKey;
    private javax.swing.JPanel pnlValueBlockDecr;
    private javax.swing.JPanel pnlValueBlockDecrAKM1;
    private javax.swing.JPanel pnlValueBlockDecrAKM2;
    private javax.swing.JPanel pnlValueBlockDecrPK;
    private javax.swing.JPanel pnlValueBlockIncr;
    private javax.swing.JPanel pnlValueBlockIncrAKM1;
    private javax.swing.JPanel pnlValueBlockIncrAKM2;
    private javax.swing.JPanel pnlValueBlockIncrPK;
    private javax.swing.JRadioButton rbAUTH1A;
    private javax.swing.JRadioButton rbAUTH1B;
    private javax.swing.ButtonGroup rbtnRadioGroup;
    private javax.swing.JPanel tabValueBlockDecrement;
    private javax.swing.JTabbedPane tabValueBlockIncrDecr;
    private javax.swing.JPanel tabValueBlockIncrement;
    private javax.swing.JTextField txtBlockAddress;
    private javax.swing.JTextField txtBlockAddressAKM1;
    private javax.swing.JTextField txtBlockAddressAKM2;
    private javax.swing.JTextField txtBlockAddressDecrement;
    private javax.swing.JTextField txtBlockAddressDecrementAKM1;
    private javax.swing.JTextField txtBlockAddressDecrementAKM2;
    private javax.swing.JTextField txtBlockAddressDecrementPK;
    private javax.swing.JTextField txtBlockAddressPK;
    private javax.swing.JTextField txtDecrementValue;
    private javax.swing.JTextField txtDecrementValueAKM1;
    private javax.swing.JTextField txtDecrementValueAKM2;
    private javax.swing.JTextField txtDecrementValuePK;
    private javax.swing.JTextField txtFErrorCode;
    private javax.swing.JTextField txtFErrorExplain;
    private javax.swing.JTextField txtFunctionStatus;
    private javax.swing.JTextField txtIncrementValue;
    private javax.swing.JTextField txtIncrementValueAKM1;
    private javax.swing.JTextField txtIncrementValueAKM2;
    private javax.swing.JTextField txtIncrementValuePK;
    // End of variables declaration//GEN-END:variables

}
