

package ufcoderadvancedapplet;

import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.ShortByReference;
import javax.swing.JOptionPane;


public class frmValueBlockReadWrite extends javax.swing.JInternalFrame {
     
    static final int 
         FUNCT_LIGHT_OK     = 4,
         FUNCT_SOUND_OK     = 0,//4 Tripple sound
         FUNCT_LIGHT_ERROR  = 2,
         FUNCT_SOUND_ERROR  = 0,//2 Long sound
         DL_OK              = 0;
    
    static final byte
         MIFARE_AUTHENT1A   = 0x60,  
         MIFARE_AUTHENT1B   = 0x61,
         MAX_BLOCK_BYTES    = 16;
    
    
    final static String ANY_DATA            = "You must enter any data !",
                        APPROPRIATE_FORMAT  = "You must enter the appropriate format !";                       
    
    public frmValueBlockReadWrite() {
        initComponents();
        new GLFunctions().CreatePKBox(pnlPKKey,29,20,13,350,"txtPKKey");
        
    }

   
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        rbtnRadioButtons = new javax.swing.ButtonGroup();
        pnlValueBlockRead1 = new javax.swing.JPanel();
        txtBlockAddressRead1 = new javax.swing.JTextField();
        btnValueBlockRead1 = new javax.swing.JButton();
        lblValueBlockRead1 = new javax.swing.JLabel();
        lblBlockAddress1 = new javax.swing.JLabel();
        lblReadValueRead1 = new javax.swing.JLabel();
        txtReadValueRead1 = new javax.swing.JTextField();
        lblValueAddressRead1 = new javax.swing.JLabel();
        txtValueAddressRead1 = new javax.swing.JTextField();
        pnlPKKey = new javax.swing.JPanel();
        rbAUTH1A = new javax.swing.JRadioButton();
        rbAUTH1B = new javax.swing.JRadioButton();
        lblKeyIndex = new javax.swing.JLabel();
        cboKeyIndex = new javax.swing.JComboBox();
        lblPKKey = new javax.swing.JLabel();
        tabValueBlockReadWrite = new javax.swing.JTabbedPane();
        tabValueBlockRead = new javax.swing.JPanel();
        pnlValueBlockRead = new javax.swing.JPanel();
        txtBlockAddressRead = new javax.swing.JTextField();
        btnValueBlockRead = new javax.swing.JButton();
        lblValueBlockRead = new javax.swing.JLabel();
        lblBlockAddress = new javax.swing.JLabel();
        lblReadValueRead = new javax.swing.JLabel();
        txtReadValueRead = new javax.swing.JTextField();
        lblValueAddressRead = new javax.swing.JLabel();
        txtValueAddressRead = new javax.swing.JTextField();
        pnlValueBlockReadAKM1 = new javax.swing.JPanel();
        txtBlockAddressReadAKM1 = new javax.swing.JTextField();
        btnValueBlockReadAKM1 = new javax.swing.JButton();
        lblValueBlockReadAKM1 = new javax.swing.JLabel();
        lblBlockAddressAKM1 = new javax.swing.JLabel();
        lblReadValueReadAKM1 = new javax.swing.JLabel();
        txtReadValueReadAKM1 = new javax.swing.JTextField();
        lblValueAddressReadAKM1 = new javax.swing.JLabel();
        txtValueAddressReadAKM1 = new javax.swing.JTextField();
        pnlValueBlockReadAKM2 = new javax.swing.JPanel();
        txtBlockAddressReadAKM2 = new javax.swing.JTextField();
        btnValueBlockReadAKM2 = new javax.swing.JButton();
        lblValueBlockReadAKM2 = new javax.swing.JLabel();
        lblBlockAddressAKM2 = new javax.swing.JLabel();
        lblReadValueReadAKM2 = new javax.swing.JLabel();
        txtReadValueReadAKM2 = new javax.swing.JTextField();
        lblValueAddressReadAKM2 = new javax.swing.JLabel();
        txtValueAddressReadAKM2 = new javax.swing.JTextField();
        pnlValueBlockReadPK = new javax.swing.JPanel();
        txtBlockAddressReadPK = new javax.swing.JTextField();
        lblValueBlockReadPK = new javax.swing.JLabel();
        lblBlockAddressPK = new javax.swing.JLabel();
        lblReadValueReadPK = new javax.swing.JLabel();
        txtReadValueReadPK = new javax.swing.JTextField();
        lblValueAddressReadPK = new javax.swing.JLabel();
        txtValueAddressReadPK = new javax.swing.JTextField();
        btnValueBlockReadPK = new javax.swing.JButton();
        tabValueBlockWrite = new javax.swing.JPanel();
        pnlValueBlockWrite = new javax.swing.JPanel();
        txtValueBlockWrite = new javax.swing.JTextField();
        txtBlockAddressWrite = new javax.swing.JTextField();
        txtValueAddressWrite = new javax.swing.JTextField();
        btnValueBlockWrite = new javax.swing.JButton();
        lblValueBlockWrite = new javax.swing.JLabel();
        lblWriteData = new javax.swing.JLabel();
        lblBlockAddressWrite = new javax.swing.JLabel();
        lblValueAddressWrite = new javax.swing.JLabel();
        pnlValueBlockWriteAKM1 = new javax.swing.JPanel();
        txtValueBlockWriteAKM1 = new javax.swing.JTextField();
        txtBlockAddressWriteAKM1 = new javax.swing.JTextField();
        txtValueAddressWriteAKM1 = new javax.swing.JTextField();
        btnValueBlockWriteAKM1 = new javax.swing.JButton();
        lblValueBlockWriteAKM1 = new javax.swing.JLabel();
        lblWriteDataAKM1 = new javax.swing.JLabel();
        lblBlockAddressWriteAKM1 = new javax.swing.JLabel();
        lblValueAddressWriteAKM1 = new javax.swing.JLabel();
        pnlValueBlockWriteAKM2 = new javax.swing.JPanel();
        txtValueBlockWriteAKM2 = new javax.swing.JTextField();
        txtBlockAddressWriteAKM2 = new javax.swing.JTextField();
        txtValueAddressWriteAKM2 = new javax.swing.JTextField();
        btnValueBlockWriteAKM2 = new javax.swing.JButton();
        lblValueBlockWriteAKM2 = new javax.swing.JLabel();
        lblWriteDataAKM2 = new javax.swing.JLabel();
        lblBlockAddressWriteAKM2 = new javax.swing.JLabel();
        lblValueAddressWriteAKM2 = new javax.swing.JLabel();
        pnlValueBlockWritePK = new javax.swing.JPanel();
        txtValueBlockWritePK = new javax.swing.JTextField();
        txtBlockAddressWritePK = new javax.swing.JTextField();
        txtValueAddressWritePK = new javax.swing.JTextField();
        btnValueBlockWritePK = new javax.swing.JButton();
        lblValueBlockWritePK = new javax.swing.JLabel();
        lblWriteDataPK = new javax.swing.JLabel();
        lblBlockAddressWritePK = new javax.swing.JLabel();
        lblValueAddressWritePK = new javax.swing.JLabel();
        txtFunctionStatus = new javax.swing.JTextField();
        txtFErrorCode = new javax.swing.JTextField();
        txtFErrorExplain = new javax.swing.JTextField();

        pnlValueBlockRead1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        txtBlockAddressRead1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressRead1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressRead1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnValueBlockRead1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockRead1.setText("READ");
        btnValueBlockRead1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblValueBlockRead1.setBackground(new java.awt.Color(204, 204, 204));
        lblValueBlockRead1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockRead1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockRead1.setText("ValueBlock Read");
        lblValueBlockRead1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockRead1.setOpaque(true);

        lblBlockAddress1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddress1.setText("Block Address");

        lblReadValueRead1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblReadValueRead1.setText("Read Value");

        txtReadValueRead1.setEditable(false);
        txtReadValueRead1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtReadValueRead1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        txtReadValueRead1.setEnabled(false);
        txtReadValueRead1.setFocusTraversalPolicyProvider(true);

        lblValueAddressRead1.setText("Value Address");

        txtValueAddressRead1.setEditable(false);
        txtValueAddressRead1.setBackground(new java.awt.Color(204, 204, 204));
        txtValueAddressRead1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueAddressRead1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueAddressRead1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        javax.swing.GroupLayout pnlValueBlockRead1Layout = new javax.swing.GroupLayout(pnlValueBlockRead1);
        pnlValueBlockRead1.setLayout(pnlValueBlockRead1Layout);
        pnlValueBlockRead1Layout.setHorizontalGroup(
            pnlValueBlockRead1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockRead1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlValueBlockRead1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblReadValueRead1)
                    .addComponent(txtReadValueRead1, javax.swing.GroupLayout.PREFERRED_SIZE, 159, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(pnlValueBlockRead1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(lblValueAddressRead1)
                    .addComponent(txtValueAddressRead1, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(21, 21, 21))
            .addGroup(pnlValueBlockRead1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblBlockAddress1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtBlockAddressRead1, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(27, 27, 27)
                .addComponent(btnValueBlockRead1, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(19, 19, 19))
            .addGroup(pnlValueBlockRead1Layout.createSequentialGroup()
                .addComponent(lblValueBlockRead1, javax.swing.GroupLayout.DEFAULT_SIZE, 258, Short.MAX_VALUE)
                .addContainerGap())
        );
        pnlValueBlockRead1Layout.setVerticalGroup(
            pnlValueBlockRead1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlValueBlockRead1Layout.createSequentialGroup()
                .addComponent(lblValueBlockRead1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockRead1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblBlockAddress1)
                    .addComponent(txtBlockAddressRead1, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnValueBlockRead1, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockRead1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblReadValueRead1)
                    .addComponent(lblValueAddressRead1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlValueBlockRead1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtReadValueRead1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txtValueAddressRead1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        setTitle("frmValueBlockReadWrite");
        setName("frmValueBlockReadWrite"); // NOI18N
        setPreferredSize(new java.awt.Dimension(569, 449));
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlPKKey.setBackground(new java.awt.Color(255, 255, 255));
        pnlPKKey.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        rbAUTH1A.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioButtons.add(rbAUTH1A);
        rbAUTH1A.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1A.setSelected(true);
        rbAUTH1A.setText("AUTH 1A");
        rbAUTH1A.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        rbAUTH1B.setBackground(new java.awt.Color(255, 255, 255));
        rbtnRadioButtons.add(rbAUTH1B);
        rbAUTH1B.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        rbAUTH1B.setText("AUTH 1B");
        rbAUTH1B.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblKeyIndex.setText("Key Index");

        cboKeyIndex.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        cboKeyIndex.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", " " }));
        cboKeyIndex.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblPKKey.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblPKKey.setText("PK Key");

        javax.swing.GroupLayout pnlPKKeyLayout = new javax.swing.GroupLayout(pnlPKKey);
        pnlPKKey.setLayout(pnlPKKeyLayout);
        pnlPKKeyLayout.setHorizontalGroup(
            pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPKKeyLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(rbAUTH1A)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rbAUTH1B)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lblKeyIndex)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(10, 10, 10)
                .addComponent(lblPKKey)
                .addContainerGap(252, Short.MAX_VALUE))
        );
        pnlPKKeyLayout.setVerticalGroup(
            pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPKKeyLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlPKKeyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblPKKey)
                    .addComponent(cboKeyIndex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblKeyIndex)
                    .addComponent(rbAUTH1A)
                    .addComponent(rbAUTH1B))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        getContentPane().add(pnlPKKey, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 570, -1));

        tabValueBlockReadWrite.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        tabValueBlockReadWrite.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N

        tabValueBlockRead.setBackground(new java.awt.Color(239, 239, 240));
        tabValueBlockRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabValueBlockRead.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlValueBlockRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockRead.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        txtBlockAddressRead.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressRead.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockRead.add(txtBlockAddressRead, new org.netbeans.lib.awtextra.AbsoluteConstraints(96, 27, 47, 26));

        btnValueBlockRead.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockRead.setText("READ");
        btnValueBlockRead.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockRead.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockReadActionPerformed(evt);
            }
        });
        pnlValueBlockRead.add(btnValueBlockRead, new org.netbeans.lib.awtextra.AbsoluteConstraints(154, 24, -1, 33));

        lblValueBlockRead.setBackground(new java.awt.Color(204, 204, 204));
        lblValueBlockRead.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockRead.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockRead.setText("ValueBlock Read");
        lblValueBlockRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockRead.setOpaque(true);
        pnlValueBlockRead.add(lblValueBlockRead, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 230, -1));

        lblBlockAddress.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddress.setText("Block Address");
        pnlValueBlockRead.add(lblBlockAddress, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 33, -1, -1));

        lblReadValueRead.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblReadValueRead.setText("Read Value");
        pnlValueBlockRead.add(lblReadValueRead, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 63, -1, -1));

        txtReadValueRead.setEditable(false);
        txtReadValueRead.setBackground(java.awt.Color.white);
        txtReadValueRead.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtReadValueRead.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtReadValueRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        txtReadValueRead.setFocusTraversalPolicyProvider(true);
        txtReadValueRead.setOpaque(false);
        pnlValueBlockRead.add(txtReadValueRead, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 84, 132, -1));

        lblValueAddressRead.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblValueAddressRead.setText("Value Address");
        pnlValueBlockRead.add(lblValueAddressRead, new org.netbeans.lib.awtextra.AbsoluteConstraints(141, 63, -1, -1));

        txtValueAddressRead.setEditable(false);
        txtValueAddressRead.setBackground(new java.awt.Color(204, 204, 204));
        txtValueAddressRead.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueAddressRead.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueAddressRead.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockRead.add(txtValueAddressRead, new org.netbeans.lib.awtextra.AbsoluteConstraints(154, 84, 57, -1));

        tabValueBlockRead.add(pnlValueBlockRead, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 20, 230, 110));

        pnlValueBlockReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockReadAKM1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        txtBlockAddressReadAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressReadAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockReadAKM1.add(txtBlockAddressReadAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(96, 27, 47, 26));

        btnValueBlockReadAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockReadAKM1.setText("READ");
        btnValueBlockReadAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockReadAKM1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockReadAKM1ActionPerformed(evt);
            }
        });
        pnlValueBlockReadAKM1.add(btnValueBlockReadAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(154, 24, -1, 33));

        lblValueBlockReadAKM1.setBackground(new java.awt.Color(204, 204, 204));
        lblValueBlockReadAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockReadAKM1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockReadAKM1.setText("ValueBlock Read AKM1");
        lblValueBlockReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockReadAKM1.setOpaque(true);
        pnlValueBlockReadAKM1.add(lblValueBlockReadAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(1, 1, 229, -1));

        lblBlockAddressAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressAKM1.setText("Block Address");
        pnlValueBlockReadAKM1.add(lblBlockAddressAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 33, -1, -1));

        lblReadValueReadAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblReadValueReadAKM1.setText("Read Value");
        pnlValueBlockReadAKM1.add(lblReadValueReadAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 63, -1, -1));

        txtReadValueReadAKM1.setEditable(false);
        txtReadValueReadAKM1.setBackground(java.awt.Color.white);
        txtReadValueReadAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtReadValueReadAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtReadValueReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        txtReadValueReadAKM1.setFocusTraversalPolicyProvider(true);
        pnlValueBlockReadAKM1.add(txtReadValueReadAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 84, 132, -1));

        lblValueAddressReadAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblValueAddressReadAKM1.setText("Value Address");
        pnlValueBlockReadAKM1.add(lblValueAddressReadAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(141, 63, -1, -1));

        txtValueAddressReadAKM1.setEditable(false);
        txtValueAddressReadAKM1.setBackground(new java.awt.Color(204, 204, 204));
        txtValueAddressReadAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueAddressReadAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueAddressReadAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockReadAKM1.add(txtValueAddressReadAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(150, 84, 57, -1));

        tabValueBlockRead.add(pnlValueBlockReadAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 20, 230, 110));

        pnlValueBlockReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockReadAKM2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        txtBlockAddressReadAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressReadAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockReadAKM2.add(txtBlockAddressReadAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(96, 27, 47, 26));

        btnValueBlockReadAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockReadAKM2.setText("READ");
        btnValueBlockReadAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockReadAKM2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockReadAKM2ActionPerformed(evt);
            }
        });
        pnlValueBlockReadAKM2.add(btnValueBlockReadAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(153, 24, -1, 33));

        lblValueBlockReadAKM2.setBackground(new java.awt.Color(204, 204, 204));
        lblValueBlockReadAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockReadAKM2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockReadAKM2.setText("ValueBlock Read AKM2");
        lblValueBlockReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockReadAKM2.setOpaque(true);
        pnlValueBlockReadAKM2.add(lblValueBlockReadAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(1, 1, 229, -1));

        lblBlockAddressAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressAKM2.setText("Block Address");
        pnlValueBlockReadAKM2.add(lblBlockAddressAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 33, -1, -1));

        lblReadValueReadAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblReadValueReadAKM2.setText("Read Value");
        pnlValueBlockReadAKM2.add(lblReadValueReadAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 63, -1, -1));

        txtReadValueReadAKM2.setEditable(false);
        txtReadValueReadAKM2.setBackground(java.awt.Color.white);
        txtReadValueReadAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtReadValueReadAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtReadValueReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        txtReadValueReadAKM2.setFocusTraversalPolicyProvider(true);
        pnlValueBlockReadAKM2.add(txtReadValueReadAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 84, 132, -1));

        lblValueAddressReadAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblValueAddressReadAKM2.setText("Value Address");
        pnlValueBlockReadAKM2.add(lblValueAddressReadAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 63, -1, -1));

        txtValueAddressReadAKM2.setEditable(false);
        txtValueAddressReadAKM2.setBackground(new java.awt.Color(204, 204, 204));
        txtValueAddressReadAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueAddressReadAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueAddressReadAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockReadAKM2.add(txtValueAddressReadAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(153, 84, 56, -1));

        tabValueBlockRead.add(pnlValueBlockReadAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 140, 230, 110));

        pnlValueBlockReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockReadPK.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        txtBlockAddressReadPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        txtBlockAddressReadPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockReadPK.add(txtBlockAddressReadPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(96, 27, 47, 26));

        lblValueBlockReadPK.setBackground(new java.awt.Color(204, 204, 204));
        lblValueBlockReadPK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        lblValueBlockReadPK.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockReadPK.setText("ValueBlock Read PK");
        lblValueBlockReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockReadPK.setOpaque(true);
        pnlValueBlockReadPK.add(lblValueBlockReadPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(1, 1, 229, -1));

        lblBlockAddressPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressPK.setText("Block Address");
        pnlValueBlockReadPK.add(lblBlockAddressPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 33, -1, -1));

        lblReadValueReadPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblReadValueReadPK.setText("Read Value");
        pnlValueBlockReadPK.add(lblReadValueReadPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 63, -1, -1));

        txtReadValueReadPK.setEditable(false);
        txtReadValueReadPK.setBackground(java.awt.Color.white);
        txtReadValueReadPK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtReadValueReadPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtReadValueReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        txtReadValueReadPK.setFocusTraversalPolicyProvider(true);
        pnlValueBlockReadPK.add(txtReadValueReadPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 84, 132, -1));

        lblValueAddressReadPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblValueAddressReadPK.setText("Value Address");
        pnlValueBlockReadPK.add(lblValueAddressReadPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 63, -1, -1));

        txtValueAddressReadPK.setEditable(false);
        txtValueAddressReadPK.setBackground(new java.awt.Color(204, 204, 204));
        txtValueAddressReadPK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueAddressReadPK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueAddressReadPK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockReadPK.add(txtValueAddressReadPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(153, 84, 57, -1));

        btnValueBlockReadPK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockReadPK.setText("READ");
        btnValueBlockReadPK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockReadPK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockReadPKActionPerformed(evt);
            }
        });
        pnlValueBlockReadPK.add(btnValueBlockReadPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(153, 24, -1, 33));

        tabValueBlockRead.add(pnlValueBlockReadPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 140, 230, 110));

        tabValueBlockReadWrite.addTab("ValueBlock Read", tabValueBlockRead);

        tabValueBlockWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabValueBlockWrite.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pnlValueBlockWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWrite.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        txtValueBlockWrite.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueBlockWrite.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueBlockWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWrite.add(txtValueBlockWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 25, 137, -1));

        txtBlockAddressWrite.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtBlockAddressWrite.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWrite.add(txtBlockAddressWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 53, 54, 26));

        txtValueAddressWrite.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueAddressWrite.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueAddressWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWrite.add(txtValueAddressWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 85, 54, 26));

        btnValueBlockWrite.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockWrite.setText("WRITE");
        btnValueBlockWrite.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockWrite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockWriteActionPerformed(evt);
            }
        });
        pnlValueBlockWrite.add(btnValueBlockWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(163, 53, -1, 56));

        lblValueBlockWrite.setBackground(new java.awt.Color(204, 204, 204));
        lblValueBlockWrite.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblValueBlockWrite.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockWrite.setText("ValueBlock Write");
        lblValueBlockWrite.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockWrite.setOpaque(true);
        pnlValueBlockWrite.add(lblValueBlockWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(1, 1, 249, -1));

        lblWriteData.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblWriteData.setText("Write Data");
        pnlValueBlockWrite.add(lblWriteData, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 26, -1, -1));

        lblBlockAddressWrite.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWrite.setText("Block Address");
        pnlValueBlockWrite.add(lblBlockAddressWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 58, -1, -1));

        lblValueAddressWrite.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblValueAddressWrite.setText("Value Address");
        pnlValueBlockWrite.add(lblValueAddressWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 90, -1, -1));

        tabValueBlockWrite.add(pnlValueBlockWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 250, 120));

        pnlValueBlockWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWriteAKM1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        txtValueBlockWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueBlockWriteAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueBlockWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWriteAKM1.add(txtValueBlockWriteAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 25, 137, -1));

        txtBlockAddressWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtBlockAddressWriteAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWriteAKM1.add(txtBlockAddressWriteAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 53, 54, 26));

        txtValueAddressWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueAddressWriteAKM1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueAddressWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWriteAKM1.add(txtValueAddressWriteAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 85, 54, 26));

        btnValueBlockWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockWriteAKM1.setText("WRITE");
        btnValueBlockWriteAKM1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockWriteAKM1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockWriteAKM1ActionPerformed(evt);
            }
        });
        pnlValueBlockWriteAKM1.add(btnValueBlockWriteAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(163, 53, -1, 56));

        lblValueBlockWriteAKM1.setBackground(new java.awt.Color(204, 204, 204));
        lblValueBlockWriteAKM1.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblValueBlockWriteAKM1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockWriteAKM1.setText("ValueBlock Write AKM1");
        lblValueBlockWriteAKM1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockWriteAKM1.setOpaque(true);
        pnlValueBlockWriteAKM1.add(lblValueBlockWriteAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(1, 1, 249, -1));

        lblWriteDataAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblWriteDataAKM1.setText("Write Data");
        pnlValueBlockWriteAKM1.add(lblWriteDataAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 26, -1, -1));

        lblBlockAddressWriteAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWriteAKM1.setText("Block Address");
        pnlValueBlockWriteAKM1.add(lblBlockAddressWriteAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(12, 58, -1, -1));

        lblValueAddressWriteAKM1.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblValueAddressWriteAKM1.setText("Value Address");
        pnlValueBlockWriteAKM1.add(lblValueAddressWriteAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 90, -1, -1));

        tabValueBlockWrite.add(pnlValueBlockWriteAKM1, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 10, 250, 120));

        pnlValueBlockWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWriteAKM2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        txtValueBlockWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueBlockWriteAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueBlockWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWriteAKM2.add(txtValueBlockWriteAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 25, 137, -1));

        txtBlockAddressWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtBlockAddressWriteAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWriteAKM2.add(txtBlockAddressWriteAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 53, 54, 26));

        txtValueAddressWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueAddressWriteAKM2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueAddressWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWriteAKM2.add(txtValueAddressWriteAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 85, 54, 26));

        btnValueBlockWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockWriteAKM2.setText("WRITE");
        btnValueBlockWriteAKM2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockWriteAKM2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockWriteAKM2ActionPerformed(evt);
            }
        });
        pnlValueBlockWriteAKM2.add(btnValueBlockWriteAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(163, 53, -1, 56));

        lblValueBlockWriteAKM2.setBackground(new java.awt.Color(204, 204, 204));
        lblValueBlockWriteAKM2.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblValueBlockWriteAKM2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockWriteAKM2.setText("ValueBlock Write AKM2");
        lblValueBlockWriteAKM2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockWriteAKM2.setOpaque(true);
        pnlValueBlockWriteAKM2.add(lblValueBlockWriteAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(1, 1, 249, -1));

        lblWriteDataAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblWriteDataAKM2.setText("Write Data");
        pnlValueBlockWriteAKM2.add(lblWriteDataAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 26, -1, -1));

        lblBlockAddressWriteAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWriteAKM2.setText("Block Address");
        pnlValueBlockWriteAKM2.add(lblBlockAddressWriteAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(12, 58, -1, -1));

        lblValueAddressWriteAKM2.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblValueAddressWriteAKM2.setText("Value Address");
        pnlValueBlockWriteAKM2.add(lblValueAddressWriteAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 90, -1, -1));

        tabValueBlockWrite.add(pnlValueBlockWriteAKM2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 140, 250, 120));

        pnlValueBlockWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWritePK.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        txtValueBlockWritePK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueBlockWritePK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueBlockWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWritePK.add(txtValueBlockWritePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 25, 143, -1));

        txtBlockAddressWritePK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtBlockAddressWritePK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtBlockAddressWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWritePK.add(txtBlockAddressWritePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 53, 54, 26));

        txtValueAddressWritePK.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtValueAddressWritePK.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtValueAddressWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        pnlValueBlockWritePK.add(txtValueAddressWritePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(103, 85, 54, 26));

        btnValueBlockWritePK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        btnValueBlockWritePK.setText("WRITE");
        btnValueBlockWritePK.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnValueBlockWritePK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValueBlockWritePKActionPerformed(evt);
            }
        });
        pnlValueBlockWritePK.add(btnValueBlockWritePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(163, 53, 83, 56));

        lblValueBlockWritePK.setBackground(new java.awt.Color(204, 204, 204));
        lblValueBlockWritePK.setFont(new java.awt.Font("Verdana", 1, 12)); // NOI18N
        lblValueBlockWritePK.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblValueBlockWritePK.setText("ValueBlock Write PK");
        lblValueBlockWritePK.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        lblValueBlockWritePK.setOpaque(true);
        pnlValueBlockWritePK.add(lblValueBlockWritePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(1, 1, 249, -1));

        lblWriteDataPK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblWriteDataPK.setText("Write Data");
        pnlValueBlockWritePK.add(lblWriteDataPK, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 26, -1, -1));

        lblBlockAddressWritePK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblBlockAddressWritePK.setText("Block Address");
        pnlValueBlockWritePK.add(lblBlockAddressWritePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(12, 58, -1, -1));

        lblValueAddressWritePK.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        lblValueAddressWritePK.setText("Value Address");
        pnlValueBlockWritePK.add(lblValueAddressWritePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(11, 90, -1, -1));

        tabValueBlockWrite.add(pnlValueBlockWritePK, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 140, 250, 120));

        tabValueBlockReadWrite.addTab("ValueBlock Write", tabValueBlockWrite);

        getContentPane().add(tabValueBlockReadWrite, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 50, 540, 310));

        txtFunctionStatus.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFunctionStatus.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtFunctionStatus.setText("Function Status");
        getContentPane().add(txtFunctionStatus, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 390, 140, -1));

        txtFErrorCode.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorCode.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorCode, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 390, 70, -1));

        txtFErrorExplain.setFont(new java.awt.Font("Verdana", 0, 11)); // NOI18N
        txtFErrorExplain.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        getContentPane().add(txtFErrorExplain, new org.netbeans.lib.awtextra.AbsoluteConstraints(210, 390, 350, -1));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnValueBlockReadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockReadActionPerformed
        frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                                                   
          IntByReference iBlockData      = new IntByReference();
          ShortByReference shValueAddress= new ShortByReference();
          byte  bKeyIndex                = (byte)cboKeyIndex.getSelectedIndex();      
          
        if (txtBlockAddressRead.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtBlockAddressRead.requestFocus();
                return;
            }
            
            bBlockAddress=Byte.parseByte(txtBlockAddressRead.getText().trim());
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockRead(iBlockData, shValueAddress, bBlockAddress, bAuthMode, bKeyIndex);
           
            if (iFResult==DL_OK){
                txtReadValueRead.setText(Integer.toString(iBlockData.getValue()));
                txtValueAddressRead.setText(Short.toString(shValueAddress.getValue()));
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
           else
           {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
          }
        catch (NumberFormatException NfEx)
        {
            JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT,"Error !",JOptionPane.ERROR_MESSAGE);            
        }finally{
            M.SetFunct(false);
        }

    }//GEN-LAST:event_btnValueBlockReadActionPerformed

    private void btnValueBlockReadAKM1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockReadAKM1ActionPerformed
       frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                                                   
          IntByReference iBlockData      = new IntByReference();
          ShortByReference shValueAddress= new ShortByReference();
          
        if (txtBlockAddressReadAKM1.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtBlockAddressReadAKM1.requestFocus();
                return;
            }
          
            bBlockAddress=Byte.parseByte(txtBlockAddressReadAKM1.getText().trim());
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockRead_AKM1(iBlockData, shValueAddress, bBlockAddress, bAuthMode);
            if (iFResult==DL_OK){
                txtReadValueReadAKM1.setText(Integer.toString(iBlockData.getValue()));
                txtValueAddressReadAKM1.setText(Short.toString(shValueAddress.getValue()));
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
           else
           {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
         }
        catch (NumberFormatException NfEx)
        {
            JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT,"Error !",JOptionPane.ERROR_MESSAGE);           
        }finally{
           M.SetFunct(false);
           
        }

    }//GEN-LAST:event_btnValueBlockReadAKM1ActionPerformed

    private void btnValueBlockReadAKM2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockReadAKM2ActionPerformed
       frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                                                   
          IntByReference iBlockData      = new IntByReference();
          ShortByReference shValueAddress= new ShortByReference();
          
        if (txtBlockAddressReadAKM2.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtBlockAddressReadAKM2.requestFocus();
                return;
            }
          
            bBlockAddress=Byte.parseByte(txtBlockAddressReadAKM2.getText().trim());
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockRead_AKM2(iBlockData, shValueAddress, bBlockAddress, bAuthMode);
            if (iFResult==DL_OK){
                txtReadValueReadAKM2.setText(Integer.toString(iBlockData.getValue()));
                txtValueAddressReadAKM2.setText(Short.toString(shValueAddress.getValue()));
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
           else
           {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
        }
        catch (NumberFormatException NfEx)
        {
            JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT,"Error !",JOptionPane.ERROR_MESSAGE);            
        }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnValueBlockReadAKM2ActionPerformed

    private void btnValueBlockReadPKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockReadPKActionPerformed
       frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                                                   
          IntByReference iBlockData      = new IntByReference();
          ShortByReference shValueAddress= new ShortByReference();
          
        if (txtBlockAddressReadPK.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtBlockAddressReadPK.requestFocus();
                return;
            }
          
            bBlockAddress=Byte.parseByte(txtBlockAddressReadPK.getText().trim());
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockRead_PK(iBlockData, shValueAddress, bBlockAddress, bAuthMode,
                    new GLFunctions().PK_KEY(pnlPKKey));
            if (iFResult==DL_OK){
                txtReadValueReadPK.setText(Integer.toString(iBlockData.getValue()));
                txtValueAddressReadPK.setText(Short.toString(shValueAddress.getValue()));
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
           else
           {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
          }
        catch (NumberFormatException NfEx)
        {
            JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT,"Error !",JOptionPane.ERROR_MESSAGE);            
        }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnValueBlockReadPKActionPerformed

    private void btnValueBlockWriteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockWriteActionPerformed
      frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                                                   
          int   iWriteData               = 0;
          short shValueAddress           = 0;
          byte  bKeyIndex                = (byte)cboKeyIndex.getSelectedIndex();
          
        if (txtValueBlockWrite.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
                txtValueBlockWrite.requestFocus();
                return;
            }
            if (txtBlockAddressWrite.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtBlockAddressWrite.requestFocus();
                return;
            }
            if (txtValueAddressWrite.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter VALUE ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtValueAddressWrite.requestFocus();
                return;
            }
            
            iWriteData=Integer.parseInt(txtValueBlockWrite.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddressWrite.getText().trim());
            shValueAddress=Short.parseShort(txtValueAddressWrite.getText().trim());
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockWrite(iWriteData, shValueAddress, bBlockAddress, bAuthMode,bKeyIndex);
            
            if (iFResult==DL_OK){
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
           else
           {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
          }
        catch (NumberFormatException NfEx)
        {
            JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT,"Error !",JOptionPane.ERROR_MESSAGE);            
        }finally{
           M.SetFunct(false);
        }
    }//GEN-LAST:event_btnValueBlockWriteActionPerformed

    private void btnValueBlockWriteAKM1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockWriteAKM1ActionPerformed
        frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                                                   
          int   iWriteData               = 0;
          short shValueAddress           = 0;
          
        if (txtValueBlockWriteAKM1.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
                txtValueBlockWriteAKM1.requestFocus();
                return;
            }
            if (txtBlockAddressWriteAKM1.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtBlockAddressWriteAKM1.requestFocus();
                return;
            }
            if (txtValueAddressWriteAKM1.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter VALUE ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtValueAddressWriteAKM1.requestFocus();
                return;
            }
          
            iWriteData=Integer.parseInt(txtValueBlockWriteAKM1.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddressWriteAKM1.getText().trim());
            shValueAddress=Short.parseShort(txtValueAddressWriteAKM1.getText().trim());
            
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockWrite_AKM1(iWriteData, shValueAddress, bBlockAddress, bAuthMode);
            if (iFResult==DL_OK){
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
           else
           {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
           }
        catch (NumberFormatException NfEx)
        {
            JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT,"Error !",JOptionPane.ERROR_MESSAGE);            
        }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnValueBlockWriteAKM1ActionPerformed

    private void btnValueBlockWritePKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockWritePKActionPerformed
        frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                                                   
          int   iWriteData               = 0;
          short shValueAddress           = 0;
          
        if (txtValueBlockWritePK.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
                txtValueBlockWritePK.requestFocus();
                return;
            }
            if (txtBlockAddressWritePK.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtBlockAddressWritePK.requestFocus();
                return;
            }
            if (txtValueAddressWritePK.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter VALUE ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtValueAddressWritePK.requestFocus();
                return;
            }
            
            iWriteData=Integer.parseInt(txtValueBlockWritePK.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddressWritePK.getText().trim());
            shValueAddress=Short.parseShort(txtValueAddressWritePK.getText().trim());
            
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockWrite_PK(iWriteData, shValueAddress, bBlockAddress, bAuthMode,
                    new GLFunctions().PK_KEY(pnlPKKey));
            if (iFResult==DL_OK){
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
           else
           {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
              }
        catch (NumberFormatException NfEx)
        {
            JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT,"Error !",JOptionPane.ERROR_MESSAGE);           
        }finally{
           M.SetFunct(false);
        }
    }//GEN-LAST:event_btnValueBlockWritePKActionPerformed

    private void btnValueBlockWriteAKM2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValueBlockWriteAKM2ActionPerformed
       frmuFrAdvancedApplet M = new frmuFrAdvancedApplet();
        if (M.GetFunct() || M.GetLoop()) {
            return;
        }
        try
        {
          M.SetFunct(true);
          int   iFResult                 = 0;
          byte  bAuthMode                = (rbAUTH1A.isSelected() ? MIFARE_AUTHENT1A : MIFARE_AUTHENT1B);          
          
          byte  bBlockAddress            = 0;                                                   
          int   iWriteData               = 0;
          short shValueAddress           = 0;
          
        if (txtValueBlockWriteAKM2.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,GLFunctions.ANY_DATA,"Warning !",JOptionPane.WARNING_MESSAGE);
                txtValueBlockWriteAKM2.requestFocus();
                return;
            }
            if (txtBlockAddressWriteAKM2.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter BLOCK ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtBlockAddressWriteAKM2.requestFocus();
                return;
            }
            if (txtValueAddressWriteAKM2.getText().trim().isEmpty()){
                JOptionPane.showMessageDialog(rootPane,"You must enter VALUE ADDRESS !","Warning !",JOptionPane.WARNING_MESSAGE);
                txtValueAddressWriteAKM2.requestFocus();
                return;
            }
          
            iWriteData=Integer.parseInt(txtValueBlockWriteAKM2.getText().trim());
            bBlockAddress=Byte.parseByte(txtBlockAddressWriteAKM2.getText().trim());
            shValueAddress=Short.parseShort(txtValueAddressWriteAKM2.getText().trim());
            
            iFResult=Declarations.uFrFunctions.uFrInstance.ValueBlockWrite_AKM2(iWriteData, shValueAddress, bBlockAddress, bAuthMode);
            if (iFResult==DL_OK){
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_OK, FUNCT_SOUND_OK);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
           else
           {
                Declarations.uFrFunctions.uFrInstance.ReaderUISignal(FUNCT_LIGHT_ERROR,FUNCT_SOUND_ERROR);
                M.SetStatusBar(txtFErrorCode,txtFErrorExplain,iFResult);
           }
                }
        catch (NumberFormatException NfEx)
        {
            JOptionPane.showMessageDialog(rootPane,APPROPRIATE_FORMAT,"Error !",JOptionPane.ERROR_MESSAGE);            
        }finally{
            M.SetFunct(false);
        }
    }//GEN-LAST:event_btnValueBlockWriteAKM2ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnValueBlockRead;
    private javax.swing.JButton btnValueBlockRead1;
    private javax.swing.JButton btnValueBlockReadAKM1;
    private javax.swing.JButton btnValueBlockReadAKM2;
    private javax.swing.JButton btnValueBlockReadPK;
    private javax.swing.JButton btnValueBlockWrite;
    private javax.swing.JButton btnValueBlockWriteAKM1;
    private javax.swing.JButton btnValueBlockWriteAKM2;
    private javax.swing.JButton btnValueBlockWritePK;
    private javax.swing.JComboBox cboKeyIndex;
    private javax.swing.JLabel lblBlockAddress;
    private javax.swing.JLabel lblBlockAddress1;
    private javax.swing.JLabel lblBlockAddressAKM1;
    private javax.swing.JLabel lblBlockAddressAKM2;
    private javax.swing.JLabel lblBlockAddressPK;
    private javax.swing.JLabel lblBlockAddressWrite;
    private javax.swing.JLabel lblBlockAddressWriteAKM1;
    private javax.swing.JLabel lblBlockAddressWriteAKM2;
    private javax.swing.JLabel lblBlockAddressWritePK;
    private javax.swing.JLabel lblKeyIndex;
    private javax.swing.JLabel lblPKKey;
    private javax.swing.JLabel lblReadValueRead;
    private javax.swing.JLabel lblReadValueRead1;
    private javax.swing.JLabel lblReadValueReadAKM1;
    private javax.swing.JLabel lblReadValueReadAKM2;
    private javax.swing.JLabel lblReadValueReadPK;
    private javax.swing.JLabel lblValueAddressRead;
    private javax.swing.JLabel lblValueAddressRead1;
    private javax.swing.JLabel lblValueAddressReadAKM1;
    private javax.swing.JLabel lblValueAddressReadAKM2;
    private javax.swing.JLabel lblValueAddressReadPK;
    private javax.swing.JLabel lblValueAddressWrite;
    private javax.swing.JLabel lblValueAddressWriteAKM1;
    private javax.swing.JLabel lblValueAddressWriteAKM2;
    private javax.swing.JLabel lblValueAddressWritePK;
    private javax.swing.JLabel lblValueBlockRead;
    private javax.swing.JLabel lblValueBlockRead1;
    private javax.swing.JLabel lblValueBlockReadAKM1;
    private javax.swing.JLabel lblValueBlockReadAKM2;
    private javax.swing.JLabel lblValueBlockReadPK;
    private javax.swing.JLabel lblValueBlockWrite;
    private javax.swing.JLabel lblValueBlockWriteAKM1;
    private javax.swing.JLabel lblValueBlockWriteAKM2;
    private javax.swing.JLabel lblValueBlockWritePK;
    private javax.swing.JLabel lblWriteData;
    private javax.swing.JLabel lblWriteDataAKM1;
    private javax.swing.JLabel lblWriteDataAKM2;
    private javax.swing.JLabel lblWriteDataPK;
    private javax.swing.JPanel pnlPKKey;
    private javax.swing.JPanel pnlValueBlockRead;
    private javax.swing.JPanel pnlValueBlockRead1;
    private javax.swing.JPanel pnlValueBlockReadAKM1;
    private javax.swing.JPanel pnlValueBlockReadAKM2;
    private javax.swing.JPanel pnlValueBlockReadPK;
    private javax.swing.JPanel pnlValueBlockWrite;
    private javax.swing.JPanel pnlValueBlockWriteAKM1;
    private javax.swing.JPanel pnlValueBlockWriteAKM2;
    private javax.swing.JPanel pnlValueBlockWritePK;
    private javax.swing.JRadioButton rbAUTH1A;
    private javax.swing.JRadioButton rbAUTH1B;
    private javax.swing.ButtonGroup rbtnRadioButtons;
    private javax.swing.JPanel tabValueBlockRead;
    private javax.swing.JTabbedPane tabValueBlockReadWrite;
    private javax.swing.JPanel tabValueBlockWrite;
    private javax.swing.JTextField txtBlockAddressRead;
    private javax.swing.JTextField txtBlockAddressRead1;
    private javax.swing.JTextField txtBlockAddressReadAKM1;
    private javax.swing.JTextField txtBlockAddressReadAKM2;
    private javax.swing.JTextField txtBlockAddressReadPK;
    private javax.swing.JTextField txtBlockAddressWrite;
    private javax.swing.JTextField txtBlockAddressWriteAKM1;
    private javax.swing.JTextField txtBlockAddressWriteAKM2;
    private javax.swing.JTextField txtBlockAddressWritePK;
    private javax.swing.JTextField txtFErrorCode;
    private javax.swing.JTextField txtFErrorExplain;
    private javax.swing.JTextField txtFunctionStatus;
    private javax.swing.JTextField txtReadValueRead;
    private javax.swing.JTextField txtReadValueRead1;
    private javax.swing.JTextField txtReadValueReadAKM1;
    private javax.swing.JTextField txtReadValueReadAKM2;
    private javax.swing.JTextField txtReadValueReadPK;
    private javax.swing.JTextField txtValueAddressRead;
    private javax.swing.JTextField txtValueAddressRead1;
    private javax.swing.JTextField txtValueAddressReadAKM1;
    private javax.swing.JTextField txtValueAddressReadAKM2;
    private javax.swing.JTextField txtValueAddressReadPK;
    private javax.swing.JTextField txtValueAddressWrite;
    private javax.swing.JTextField txtValueAddressWriteAKM1;
    private javax.swing.JTextField txtValueAddressWriteAKM2;
    private javax.swing.JTextField txtValueAddressWritePK;
    private javax.swing.JTextField txtValueBlockWrite;
    private javax.swing.JTextField txtValueBlockWriteAKM1;
    private javax.swing.JTextField txtValueBlockWriteAKM2;
    private javax.swing.JTextField txtValueBlockWritePK;
    // End of variables declaration//GEN-END:variables

}
